#include <ctime>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

int n, m;
int k[MAXN + 5];
int p[MAXN + 5];
int idx[MAXN + 5];
vector<int> G[MAXN + 5], wh[MAXN + 5], e;

void DFS(int u, int p)
{
    e.push_back(u);

    int i0 = -1;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        if (G[u][i] == p) i0 = i;
    }
    for (int i = i0 + 1; i < G[u].size(); ++ i)
    {
        DFS(G[u][i], u);
        e.push_back(u);
    }
    for (int i = 0; i < i0; ++ i)
    {
        DFS(G[u][i], u);
        e.push_back(u);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    time_t start = clock();

    cin >> n >> m;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> k[i];
        for (int j = 1; j <= k[i]; ++ j)
        {
            int u;
            cin >> u;
            G[i].push_back(u);
        }
    }

    for (int i = 1; i <= m; ++ i)
    {
        cin >> p[i];
    }

    DFS(1, -1);

    long long t = 0;
    int i0 = 1, u = 1;
    int sz = e.size() - 1, pos = 0;
    while (i0 <= m)
    {
        t++;
        if (u == p[i0]) i0++;
        if (e[pos] == u) pos++;
        if (pos == sz) break;
        int v = G[u][idx[u]];
        idx[u]++;
        idx[u] %= k[u];
        u = v;
    }
    ///sz--;

    if (clock() - start > 0.5 * CLOCKS_PER_SEC) return 0;

    if (i0 == m + 1)
    {
        cout << t << endl;
        return 0;
    }

    for (int i = 0; i < sz; ++ i)
    {
        wh[e[i]].push_back(i);
    }

    int p0 = -1, p1;
    for (int i = i0; i <= m; ++ i)
    {
        if (wh[p[i]].back() <= p0)
        {
            t += sz - p0;
            p0 = 0;
        }
        p1 = lower_bound(wh[p[i]].begin(), wh[p[i]].end(), p0 + 1) - wh[p[i]].begin();
        p1 = wh[p[i]][p1];
        t += p1 - p0;
        p0 = p1;
    }
    cout << t << endl;

    return 0;
}
