#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

int n, m;
int k[MAXN + 5];
int p[MAXN + 5];
int idx[MAXN + 5];
int par[MAXN + 5];
int last[MAXN + 5];
vector<int> G[MAXN + 5], e, pos[MAXN + 5];

void DFS(int u, int p)
{
    for (auto v : G[u])
    {
        if (v != p)
        {
            par[v] = u;
            DFS(v, u);
        }
    }
}

void DFSe(int u, int p)
{
    e.push_back(u);

    int j = -1;
    for (int i = 0; i < k[u]; ++ i)
    {
        if (G[u][i] == p) j = i;
    }

    for (int i = j + 1; i < k[u]; ++ i)
    {
        DFSe(G[u][i], u);
        e.push_back(u);
    }
    for (int i = 0; i < j; ++ i)
    {
        DFSe(G[u][i], u);
        e.push_back(u);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> k[i];
        for (int j = 1; j <= k[i]; ++ j)
        {
            int u;
            cin >> u;
            G[i].push_back(u);
        }
    }

    for (int i = 1; i <= m; ++ i)
    {
        cin >> p[i];
    }

    DFS(1, -1);

    int cnt = 0;
    par[1] = G[1].back();
    for (int i = 1; i <= n; ++ i)
    {
        last[i] = G[i].back();
        if (last[i] == par[i]) cnt++;
    }

    long long t = 0;
    int i0 = 1, u = 1, v;
    while (i0 <= m)
    {
        t++;
        if (u == p[i0]) i0++;
        if (u == 1 and cnt == n) break;
        v = G[u][idx[u]];
        if (last[u] == par[u]) cnt--;
        last[u] = v;
        if (v == par[u]) cnt++;
        idx[u]++;
        idx[u] %= k[u];
        u = v;
    }
    if (n > 1000) return 0;

    if (i0 == m + 1)
    {
        cout << t << endl;
        return 0;
    }

    DFSe(1, -1);

    ///cout << t << " " << i0 << endl;
    int sz = e.size() - 1;
    for (int i = 0; i < sz; ++ i)
    {
        pos[e[i]].push_back(i);
        ///cout << e[i] << " ";
    }
    ///cout << endl;

    int curr = 0;
    for (int i = i0; i <= m; ++ i)
    {
        if (pos[p[i]].back() <= curr)
        {
            t += sz - curr - 1;
            curr = -1;
        }
        int h = lower_bound(pos[p[i]].begin(), pos[p[i]].end(), curr + 1) - pos[p[i]].begin();
        t += pos[p[i]][h] - curr;
        curr = pos[p[i]][h];
    }
    cout << t << endl;

    return 0;
}
