#include "game.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int d, n;
vector<int> a;
int deg[MAXN + 5];
bool win[MAXN + 5];
vector<int> G[MAXN + 5], rev[MAXN + 5];

void init(vector<int> A, int D)
{
    a = A;
    n = a.size();
    d = D;
}

void updateValue(int index, int newValue)
{
    a[index] = newValue;
}

bool isWinning(int startIndex)
{
    for (int i = 0; i < n; ++ i)
    {
        G[i].clear();
        rev[i].clear();
    }

    for (int i = 0; i < n; ++ i)
    {
        deg[i] = 0;
        int l = max(0, i - d), r = min(n - 1, i + d);
        for (int j = l; j <= r; ++ j)
        {
            if (a[j] > a[i])
            {
                deg[i]++;
                G[i].push_back(j);
                rev[j].push_back(i);
            }
        }
        win[i] = false;
    }

    queue<int> q;
    for (int i = 0; i < n; ++ i)
    {
        if (G[i].size() == 0) q.push(i);
    }

    while (!q.empty())
    {
        int u = q.front();
        q.pop();
        for (auto v : rev[u])
        {
            deg[v]--;
            if (!win[u]) win[v] = true;
            if (deg[v] == 0) q.push(v);
        }
    }

    return win[startIndex];
}
