#include "game.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int d, n;
vector<int> a;
int deg[MAXN + 5];
bool win[MAXN + 5];
vector<int> G[MAXN + 5], rev[MAXN + 5];

void init(vector<int> A, int D)
{
    a = A;
    n = a.size();
    d = D;

    for (int i = 0; i < n; ++ i)
    {
        G[i].clear();
        rev[i].clear();
    }

    for (int i = 0; i < n; ++ i)
    {
        deg[i] = 0;
        int l = max(0, i - d), r = min(n - 1, i + d);
        for (int j = l; j <= r; ++ j)
        {
            if (a[j] > a[i])
            {
                deg[i]++;
                G[i].push_back(j);
                rev[j].push_back(i);
            }
        }
        win[i] = false;
    }

    queue<int> q;
    for (int i = 0; i < n; ++ i)
    {
        if (G[i].size() == 0) q.push(i);
    }

    while (!q.empty())
    {
        int u = q.front();
        q.pop();
        for (auto v : rev[u])
        {
            deg[v]--;
            if (!win[u]) win[v] = true;
            if (deg[v] == 0) q.push(v);
        }
    }
}

void DFS_rev(int u)
{
    bool flag = win[u];
    win[u] = false;
    for (auto v : G[u])
    {
        if (!win[v]) win[u] = true;
    }
    if (flag == win[u]) return;
    for (auto v : rev[u])
    {
        DFS_rev(v);
    }
}

void updateValue(int index, int newValue)
{
    int i0 = index;
    a[i0] = newValue;

    for (auto u : G[i0])
    {
        for (int j = 0; j < rev[u].size(); ++ j)
        {
            if (rev[u][j] == i0)
            {
                rev[u].erase(rev[u].begin() + j);
                break;
            }
        }
    }
    G[i0].clear();

    for (auto u : rev[i0])
    {
        for (int j = 0; j < G[u].size(); ++ j)
        {
            if (G[u][j] == i0)
            {
                G[u].erase(G[u].begin() + j);
                break;
            }
        }
        DFS_rev(u);
    }
    rev[i0].clear();

    win[i0] = false;
    int l = max(0, i0 - d), r = min(n - 1, i0 + d);
    for (int j = l; j < i0; ++ j)
    {
        if (a[j] > a[i0])
        {
            if (!win[j]) win[i0] = true;
            G[i0].push_back(j);
            rev[j].push_back(i0);
        }
        else
        {
            G[j].push_back(i0);
            rev[i0].push_back(j);
        }
    }

    for (int j = i0 + 1; j <= r; ++ j)
    {
        if (a[j] > a[i0])
        {
            if (!win[j]) win[i0] = true;
            G[i0].push_back(j);
            rev[j].push_back(i0);
        }
        else
        {
            G[j].push_back(i0);
            rev[i0].push_back(j);
        }
    }

    for (auto v : rev[i0])
    {
        DFS_rev(v);
    }
}

bool isWinning(int startIndex)
{
    return win[startIndex];
}
