#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAX = 100000;

int a[MAX + 5];
int wh[MAX + 5];
bool e[MAX + 5];
int num[MAX + 5];
vector<int> nums;
vector<int> primes;
int pw_gcd[2 * MAX + 5];
vector<int> groups[MAX + 5];
vector<int> powers[2 * MAX + 5];
vector< pair<int, int> > decomp[MAX + 5];

void eratosthenes()
{
    for (int i = 2; i <= MAX; ++ i)
    {
        if (!e[i])
        {
            primes.push_back(i);
            for (long long j = 1ll * i * i; j <= MAX; j += i)
            {
                e[j] = true;
            }
        }
    }
}

void solve()
{
    int n, k, x;
    cin >> n >> k >> x;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        int tmp = a[i];
        decomp[i].clear();
        for (auto p : primes)
        {
            int pw = 0;
            while (tmp % p == 0)
            {
                tmp /= p;
                pw++;
            }
            if (pw) decomp[i].push_back({p, pw});
        }
        if (tmp > 1)
        {
            decomp[i].push_back({tmp, 1});
            primes.push_back(tmp);
        }
    }

    sort(primes.begin(), primes.end());
    auto it = unique(primes.begin(), primes.end());
    primes.resize(distance(primes.begin(), it));

    for (int i = 1; i <= primes.size(); ++ i)
    {
        powers[i].clear();
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (auto [p, pw] : decomp[i])
        {
            int idx = lower_bound(primes.begin(), primes.end(), p) - primes.begin();
            idx++;
            powers[idx].push_back(pw);
        }
    }

    for (int i = 1; i <= primes.size(); ++ i)
    {
        sort(powers[i].begin(), powers[i].end());
        if (powers[i].size() >= k) pw_gcd[i] = powers[i][powers[i].size() - k];
        else pw_gcd[i] = 0;
    }

    nums.clear();
    for (int i = 1; i <= n; ++ i)
    {
        num[i] = 1;
        for (auto [p, pw] : decomp[i])
        {
            int idx = lower_bound(primes.begin(), primes.end(), p) - primes.begin();
            idx++;
            int pw2 = min(pw, pw_gcd[idx]);
            while (pw2--) num[i] *= p;
        }
        nums.push_back(num[i]);
    }

    sort(nums.begin(), nums.end());
    it = unique(nums.begin(), nums.end());
    nums.resize(distance(nums.begin(), it));

    for (int i = 1; i <= nums.size(); ++ i)
    {
        groups[i].clear();
    }

    for (int i = 1; i <= n; ++ i)
    {
        int idx = lower_bound(nums.begin(), nums.end(), num[i]) - nums.begin();
        idx++;
        groups[idx].push_back(a[i]);
    }

    for (int i = 1; i <= nums.size(); ++ i)
    {
        sort(groups[i].begin(), groups[i].end());
        wh[i] = 0;
    }

    for (int i = 1; i <= n; ++ i)
    {
        int idx = lower_bound(nums.begin(), nums.end(), num[i]) - nums.begin();
        idx++;
        cout << groups[idx][wh[idx]++] << " ";
    }
    cout << endl;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    eratosthenes();

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
