#include <algorithm>
#include <iostream>
#include <vector>
#include <map>
#define endl '\n'
using namespace std;

const long long MAX = 100000;

long long n, k, x;
long long cnt = 0;
long long wh[MAX + 5];
bool e[MAX + 5];
long long num[MAX + 5];
vector<long long> nums;
vector<long long> primes;
map<long long, long long> cprimes;
long long pw_gcd[2 * MAX + 5];
vector<long long> groups[MAX + 5];
vector<long long> powers[2 * MAX + 5];
vector< pair<long long, long long> > decomp[MAX + 5];
long long a[MAX + 5], b[MAX + 5], c[MAX + 5];

void eratosthenes()
{
    for (long long i = 2; i <= MAX; ++ i)
    {
        if (!e[i])
        {
            cprimes[i] = ++cnt;
            primes.push_back(i);
            for (long long j = 1ll * i * i; j <= MAX; j += i)
            {
                e[j] = true;
            }
        }
    }
}

bool check()
{
    for (long long i = 1; i <= n; ++ i)
    {
        if (b[i] != c[i]) return (b[i] < c[i]);
    }
    return true;
}

void go()
{
    for (long long i = 1; i <= n; ++ i)
    {
        long long tmp = a[i];
        decomp[i].clear();
        for (auto p : primes)
        {
            if (1ll * p * p > tmp) break;
            long long pw = 0;
            while (tmp % p == 0)
            {
                tmp /= p;
                pw++;
            }
            if (pw) decomp[i].push_back({p, pw});
        }
        if (tmp > 1)
        {
            decomp[i].push_back({tmp, 1});
            if (cprimes.count(tmp) == 0)
            {
                primes.push_back(tmp);
                cprimes[tmp] = ++cnt;
            }
        }
    }

    for (long long i = 1; i <= primes.size(); ++ i)
    {
        powers[i].clear();
    }

    for (long long i = 1; i <= n; ++ i)
    {
        for (auto [p, pw] : decomp[i])
        {
            long long idx = cprimes[p];
            powers[idx].push_back(pw);
        }
    }

    for (long long i = 1; i <= primes.size(); ++ i)
    {
        sort(powers[i].begin(), powers[i].end());
        if (powers[i].size() >= k) pw_gcd[i] = powers[i][powers[i].size() - k];
        else pw_gcd[i] = 0;
    }

    nums.clear();
    for (long long i = 1; i <= n; ++ i)
    {
        num[i] = 1;
        for (auto [p, pw] : decomp[i])
        {
            long long idx = cprimes[p];
            long long pw2 = min(pw, pw_gcd[idx]);
            while (pw2--) num[i] *= p;
        }
        nums.push_back(num[i]);
    }

    sort(nums.begin(), nums.end());
    auto it = unique(nums.begin(), nums.end());
    nums.resize(distance(nums.begin(), it));

    for (long long i = 1; i <= nums.size(); ++ i)
    {
        groups[i].clear();
    }

    for (long long i = 1; i <= n; ++ i)
    {
        long long idx = lower_bound(nums.begin(), nums.end(), num[i]) - nums.begin();
        idx++;
        groups[idx].push_back(a[i]);
    }

    for (long long i = 1; i <= nums.size(); ++ i)
    {
        sort(groups[i].begin(), groups[i].end());
        wh[i] = 0;
    }

    for (long long i = 1; i <= n; ++ i)
    {
        long long idx = lower_bound(nums.begin(), nums.end(), num[i]) - nums.begin();
        idx++;
        c[i] = groups[idx][wh[idx]++];
    }

    if (!check())
    {
        for (long long i = 1; i <= n; ++ i)
        {
            b[i] = c[i];
        }
    }
}

void solve()
{
    cin >> n >> k >> x;

    for (long long i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        b[i] = a[i];
    }

    go();

    if (x > 1)
    {
        for (long long i = 1; i <= n; ++ i)
        {
            a[i] *= x;
            go();
            a[i] /= x;
        }
    }

    for (long long i = 1; i <= n; ++ i)
    {
        cout << b[i] << " ";
    }
    cout << endl;
}

long long main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    eratosthenes();

    long long t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
