#include<iostream>
#include "game.h"
#define MAXN 200010
int a[MAXN];
std::pair<int,int> tree[4*MAXN];
int n,d;
int comp[MAXN];
void build(int ind, int l, int r)
{
    if(l==r){tree[ind]={a[l],l};return;}
    int mid=(l+r)>>1;
    int left=ind<<1,right=left|1;
    build(left,l,mid);
    build(right,mid+1,r);

    if(tree[left].first>tree[right].first)tree[ind]=tree[left];
    else tree[ind]=tree[right];
}
void update(int ind, int l, int r, int pos ,int val)
{
    if(l==r){tree[ind].first=val;return;}
    int mid=(l+r)>>1;
    int left=ind<<1,right=left|1;
    if(pos<=mid)update(left,l,mid,pos,val);
    else update(right,mid+1,r,pos,val);

    if(tree[left].first>tree[right].first)tree[ind]=tree[left];
    else tree[ind]=tree[right];
}
std::pair<int,int> query(int ind, int l, int r, int ql, int qr)
{
    if(qr<l || r<ql)return {0,0};
    if(ql<=l && r<=qr)return tree[ind];
    int mid=(l+r)>>1;
    int left=ind<<1,right=left|1;
    std::pair<int,int> res1=query(left,l,mid,ql,qr);
    std::pair<int,int> res2=query(right,mid+1,r,ql,qr);

    if(res1.first>res2.first)return res1;
    return res2;
}
void construct(int l, int r)
{
    if(l>r)return;
    if(l==r){comp[l]=a[l];return;}
    int ind=query(1,1,n,l,r).second;
    int st=std::max(ind-d,l);
    int en=std::min(ind+d,r);
    for(int i=st;i<=en;i++)comp[i]=a[ind];
    construct(l,st-1);
    construct(en+1,r);
}
void init(std::vector<int> A, int D)
{
    for(int i=0;i<A.size();i++)
    {
        a[i+1]=A[i];
    }
    n=A.size();
    d=D;
    build(1,1,n);
    construct(1,n);
}
void updateValue(int index, int newValue)
{
    index++;
    if(newValue<comp[index])return;
    update(1,1,n,index,newValue);
    construct(1,n);
}
bool isWinning(int startIndex)
{
    startIndex++;
    if(comp[startIndex]==a[startIndex])return 0;
    return 1;
}