#include <iostream>
#include <vector>
#include "game.h"
using namespace std;
const int MAXN = 1e5+7;
int rangeMax[MAXN];
int rangeSecMax[MAXN];
int maxInRange[MAXN]; /// za vseki index pazim dali v range-a mu ima chislo koeto e max v svoq range
int D;
bool winning[MAXN];
bool losing[MAXN];
vector<int> val;
int n;
void uwp(int pos){
    if(losing[pos] or winning[pos]) return;
    losing[pos]=true;
    for(int j = max(pos-D,0);j<=min(pos+D,n-1);j++){
      if(!losing[j]){
        winning[j]=true;
      }
    }
    if(pos-D-1>=0){
      uwp(pos-D-1);
    }
    if(pos+D+1<=n-1){
      uwp(pos+D+1);
    }
}
void evaluate(){
  for(int i=0;i<n;i++){
    maxInRange[i]=-1;
    losing[i]=false;
    winning[i]=false;
  }
  for(int i=0;i<n;i++){
    if(rangeMax[i]==i){
      for(int j=i+D+1;j<n;j++){
          losing[i]=false;
          winning[i]=false;
      }
      //cerr<<"vryh "<<i<<"\n";
      uwp(i);
    }
  }
  /*for(int i=0;i<n;i++){
    if(winning[i]) cerr<<1<<" ";
    if(losing[i]) cerr<<-1<<" ";
  }*/
}
void init(vector<int> originalA, int originalD){
  D = originalD;
  val = originalA;
  n = val.size();
  int firstpos = 0;
  int firstmax,secmax;
  for(int i = 0;i<n;i++){
    firstpos = max(i-D,0);
    if(val[firstpos]>val[firstpos+1]){
      firstmax = firstpos;
      secmax = firstpos+1;
    }else{
      firstmax = firstpos+1;
      secmax = firstpos;
    }
    for(int j = firstpos+2;j<=min(i+D,n-1);j++){
      if(val[j]>val[firstmax]){
      secmax = firstmax;
      firstmax = j;
      }else if(val[j]>val[secmax]){
        secmax = j;
      }
    }
    rangeMax[i]=firstmax;
    rangeSecMax[i]=secmax;
  }
  evaluate();

}
void updateValue(int index, int newValue){
  val[index]=newValue;
  int firstpos = 0;
  int firstmax,secmax;
  for(int i = max(index-D,0);i<=min(index+D,n-1);i++){
    firstpos = max(i-D,0);
    if(val[firstpos]>val[firstpos+1]){
      firstmax = firstpos;
      secmax = firstpos+1;
    }else{
      firstmax = firstpos+1;
      secmax = firstpos;
    }
    for(int j = firstpos+2;j<min(i+D,n);j++){
      if(val[j]>val[firstmax]){
      secmax = firstmax;
      firstmax = j;
      }else if(val[j]>val[secmax]){
        secmax = j;
      }
    }
    rangeMax[i]=firstmax;
    rangeSecMax[i]=secmax;
  }
  evaluate();
}
bool isWinning(int startIndex){
  int igrach = 0;
  int ind = startIndex;
  if(losing[ind]) return 0;
  else if(winning[ind]) return 1;
  return igrach;
}
