#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

//#define print_a for (int elementt : a) cout << elementt << " "; cout << endl;
//#define print_b for (int elementt : b) cout << elementt << " "; cout << endl;
#define print(a) for (int elementt : a) cout << elementt << " "; cout << endl;

int count_bits(int a) {
    int c = 0;
    while (a > 0) {
        c += a % 2;
        a /= 2;
    }
    return c;
}

int gcd(int a, int b) {
    int c = a % b;
    while (c != 0) {
        a = b;
        b = c;
        c = a % b;
    }
    return b;
}

int gcd(vector <int> &a) {
    int res = a[0];
    for (int i : a) {
        res = gcd(res, i);
    }

    return res;
}

int gcd(vector <int> &a, int mask) {
    int res = -1;
    for (int i = 0; i < a.size(); i++) {
        int curr_bit = a.size() - 1 - i;
        if (mask & (1 << curr_bit)) {
            if (res == -1) res = a[i];
            else res = gcd(res, a[i]);
        }
    }

    return res;
}

bool is_kgcd(vector <int> &a, vector <int> &b, int k) {
    int up_to = 1 << k;
    for (int i = 0; i < up_to; i++) {
        if (count_bits(i) != k) continue;
        if (gcd(a, i) != gcd(b, i)) return false;
//        print_a
//        print_b
//        cout << i << endl;
    }
    return true;
}

void find_perm(vector <int> &a, int k) {
    vector <int> b;
    b = a;
    sort(b.begin(), b.end());

    do {
        if (is_kgcd(a, b, k)) {
//            print(a)
//            print(b)
            a = b;
            return;
        }
    } while (next_permutation(b.begin(), b.end()));
}

//int main() {
//    vector <int> a = { 10, 3, 6, 9 };
//    int k = 2;
//    find(a, k);
////    for (int i : a) {
////        cout << i << " ";
////    }
//}

int main() {
    int t;
    cin >> t;

    for (int i = 0; i < t; i++) {
        int n, k, x;
        cin >> n >> k >> x;
        vector <int> temp;
        for (int j = 0; j < n; j++) {
            int tt; cin >> tt;
            temp.push_back(tt);
        }
        find_perm(temp, k);
        print(temp);
    }
}
