#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define prll(a) for (ll elementt : a) cout << elementt << " "; cout << endl;

ll count_bits(ll a) {
    ll c = 0;
    while (a > 0) {
        c += a % 2;
        a /= 2;
    }
    return c;
}

ll gcd(ll a, ll b) {
    ll c = a % b;
    while (c != 0) {
        a = b;
        b = c;
        c = a % b;
    }
    return b;
}

ll gcd(vector <ll> &a) {
    ll res = a[0];
    for (ll i : a) {
        res = gcd(res, i);
    }

    return res;
}

ll gcd(vector <ll> &a, ll mask) {
    ll res = -1;
    for (ll i = 0; i < a.size(); i++) {
        ll curr_bit = a.size() - 1 - i;
        if (mask & (1 << curr_bit)) {
            if (res == -1) res = a[i];
            else res = gcd(res, a[i]);
        }
    }

    return res;
}

bool is_kgcd(vector <ll> &a, vector <ll> &b, ll k) {
    ll up_to = 1 << a.size();
    for (ll i = 0; i < up_to; i++) {
        if (count_bits(i) != k) continue;
        if (gcd(a, i) != gcd(b, i)) return false;
    }
    return true;
}

void find_perm(vector <ll> &a, ll k) {
    vector <ll> b;
    b = a;
    sort(b.begin(), b.end());

    do {
        if (is_kgcd(a, b, k)) {
            a = b;
            return;
        }
    } while (next_permutation(b.begin(), b.end()));
}

int main() {
    ll t;
    cin >> t;

    for (ll i = 0; i < t; i++) {
        ll n, k, x;
        cin >> n >> k >> x;
        vector <ll> temp;
        for (ll j = 0; j < n; j++) {
            ll tt; cin >> tt;
            temp.push_back(tt);
        }
        find_perm(temp, k);
        prll(temp);
    }
}
