#include <iostream>
#include <vector>
#include "game.h"
using namespace std;
const int MAXN = 1e5 + 1;
const int INF = 1e9 + 7;
int sit[MAXN];
int sparse[MAXN][30];
int lg[MAXN];
int arr[MAXN];
int dist, n;
int maxx(int l, int r) {
    if (arr[sparse[l][lg[r - l + 1]]] > arr[sparse[r - (1 << (lg[r - l + 1])) + 1][lg[r - l + 1]]]) {
        return sparse[l][lg[r - l + 1]];
    } else {
        return sparse[r - (1 << (lg[r - l + 1])) + 1][lg[r - l + 1]];
    }
}
void expand_left(int curr, int l) {
    if (curr - dist <= l) {
        return;
    }
    int nex = maxx(max(curr - 2 * dist, l), curr - dist - 1);
    if (maxx(max(nex - dist, 1), curr - dist - 1) == nex) {
        sit[nex] = 1;
        for (int i = curr - dist - 1; i >= max(nex - dist, 1); i--) {
            if (i != nex) {
                sit[i] = -1;
            }
        }
        expand_left(nex, l);
    }
}
int expand_right(int curr, int r) {
    if (curr + dist >= r) {
        return curr + dist + 1;
    }
    int nex = maxx(curr + dist + 1, min(curr + 2 * dist, r));
    if (maxx(curr + dist + 1, min(nex + dist, n)) == nex) {
        sit[nex] = 1;
        for (int i = curr + dist + 1; i <= min(nex + dist, n); i++) {
            if (i != nex) {
                sit[i] = -1;
            }
        }
        return expand_right(nex, r);
    } else {
        return curr + dist + 1;
    }
}
void build() {
    for (int i = 1; i <= n; i++) {
        sparse[i][0] = i;
    }
    for (int e = 1; (1 << e) <= n; e++) {
        for (int i = 1; i <= n; i++) {
            if (arr[sparse[i][e - 1]] > arr[sparse[min(i + (1 << (e-1)), n)][e - 1]]) {
                sparse[i][e] = sparse[i][e - 1];
            } else {
                sparse[i][e] = sparse[min(i + (1 << (e-1)), n)][e - 1];
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        sit[i] = 0;
    }
    vector<int> wins;
    for (int i = 1; i <= n; i++) {
        if (maxx(max(i - dist, 1), min(i + dist, n)) == i) {
            sit[i] = 1;
            wins.push_back(i);
        }
    }
    int l = 1;
    for (int i = 0; i < wins.size(); i++) {
        for (int j = max(wins[i] - dist, l); j <= min(wins[i] + dist, n); j++) {
            if (j != wins[i]) {
                sit[j] = -1;
            }
        }
        if (l + dist < wins[i]) {
            expand_left(wins[i], l);
        }
        int r;
        if (i == wins.size() - 1) {
            r = n;
        } else {
            r = wins[i + 1] - dist - 1;
        }
        l = expand_right(wins[i], r);
    }
}
void init(vector<int> A, int D) {
    n = A.size();
    lg[0] = 0;
    lg[1] = 0;
    for (int i = 1; i <= n; i++) {
        arr[i] = A[i - 1];
        lg[i] = lg[i - 1];
        if ((1 << (lg[i] + 1)) == i) {
            lg[i]++;
        }
    }
    dist = D;
    build();
}
void updateValue(int index, int newValue) {
    arr[index + 1] = newValue;
    build();
}
bool isWinning(int startIndex) {
    if (sit[startIndex + 1] == 1) {
        return false;
    }
    if (sit[startIndex + 1] == -1) {
        return true;
    }
//    if (sit[startIndex + 1] == 0) {
//        cout << "ugabuga";
//    }
    return 1 / 0;
}
//int main() {
//    int u, v;
//    cin >> u >> v;
//    vector<int> vhod;
//    for (int i = 1; i <= u; i++) {
//        int uhod;
//        cin >> uhod;
//        vhod.push_back(uhod);
//    }
//    init(vhod, v);
//    int q;
//    cin >> q;
//    while (q --> 0) {
//        int type;
//        cin >> type;
//        if (type == 1) {
//            int ind, val;
//            cin >> ind >> val;
//            updateValue(ind, val);
//        }
//        if (type == 2) {
//            int st;
//            cin >> st;
//            cout << isWinning(st) << '\n';
//        }
//    }
//    return 0;
//}
