#include <iostream>
#include <vector>

#define endl '\n'

using namespace std;

const int MAXN = 5e5 + 3;

vector<int> graph[MAXN];
int edgeIndex[MAXN];

int friends[MAXN];

bool visited[MAXN];
int visitedCounter;

vector<int> eulerTour;

bool dfs(int currv, int n) {
    if (currv == 0 and visitedCounter == n) {
        return true;
    }

    eulerTour.push_back(currv);

    if (!visited[currv]) {
        ++visitedCounter;
    }

    visited[currv] = true;

    int nextv = graph[currv][edgeIndex[currv]];

    ++edgeIndex[currv];
    if (edgeIndex[currv] == (int) graph[currv].size()) {
        edgeIndex[currv] = 0;
    }

    if (dfs(nextv, n)) {
        return true;
    }

    return false;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    for (int from = 0; from < n; ++from) {
        int k;
        cin >> k;

        graph[from].resize(k);

        for (int i = 0; i < k; ++i) {
            int to;
            cin >> to;

            graph[from][i] = to - 1;
        }
    }

    for (int i = 0; i < m; ++i) {
        cin >> friends[i];
        --friends[i];
    }

    dfs(0, n);

    // int currentFriend = 0;
    // int currentCity = 0;
    // int days = 0;

    // while (currentFriend < m) {
    //     ++days;

    //     if (currentCity == friends[currentFriend]) {
    //         ++currentFriend;
    //     }

    //     int nextCity = graph[currentCity][edgeIndex[currentCity]];

    //     ++edgeIndex[currentCity];
    //     if (edgeIndex[currentCity] == (int) graph[currentCity].size()) {
    //         edgeIndex[currentCity] = 0;
    //     }

    //     currentCity = nextCity;
    // }

    // cout << days << endl;

    return 0;
}