#include "game.h"

#include <iostream>
#include <vector>

using namespace std;

int n;
vector<int> values;

int distanceLimit;

void init(vector<int> A, int D) {
    n = (int) A.size();
    values = A;
    distanceLimit = D;
}

void updateValue(int index, int newValue) {
    values[index] = newValue;
}

bool isWinning(int startIndex) {
    int64_t klimi = 0ll;
    int64_t nikol = 0ll;

    int currentIndex = startIndex;
    bool isKlimiTurn = true;

    vector<bool> visitedByKlimi(n, false);

    while (true) {
        int maxValue = -1;
        int newIndex = -1;

        for (int i = max(currentIndex - distanceLimit, 0); i <= min(currentIndex + distanceLimit, n - 1); ++i) {
            if (i == currentIndex) {
                continue;
            }

            if (values[i] > maxValue) {
                maxValue = values[i];
                newIndex = i;
            }
        }

        if (isKlimiTurn) {
            if (visitedByKlimi[newIndex]) {
                break;
            }

            klimi += 1ll * maxValue;
            visitedByKlimi[newIndex] = true;
        } else {
            nikol += 1ll * maxValue;
        }

        isKlimiTurn = !isKlimiTurn;
        currentIndex = newIndex;
    }

    return klimi > nikol;
}
