#include "game.h"

#include <iostream>
#include <vector>

using namespace std;

int n;
vector<int> values;

int distanceLimit;

void init(vector<int> A, int D) {
    n = (int) A.size();
    values = A;
    distanceLimit = D;
}

void updateValue(int index, int newValue) {
    values[index] = newValue;
}

bool check_is_winning(int currentIndex, bool isKlimiTurn, int64_t klimi, int64_t nikol, vector<bool> &visitedByKlimi) {
    if (isKlimiTurn) {
        for (int i = max(currentIndex - distanceLimit, 0); i <= min(currentIndex + distanceLimit, n - 1); ++i) {
            if (i == currentIndex) {
                continue;
            }
        
            if (visitedByKlimi[i]) {
                if (klimi > nikol) {
                    return true;
                }

                continue;
            }

            visitedByKlimi[i] = true;

            if (check_is_winning(i, false, klimi + 1ll * values[i], nikol, visitedByKlimi)) {
                return true;
            }

            visitedByKlimi[i] = false;
        }
    } else {
        int maxValue = -1;
        int newIndex = -1;

        for (int i = max(currentIndex - distanceLimit, 0); i <= min(currentIndex + distanceLimit, n - 1); ++i) {
            if (i == currentIndex) {
                continue;
            }

            if (values[i] > maxValue) {
                maxValue = values[i];
                newIndex = i;
            }
        }

        if (check_is_winning(newIndex, true, klimi, nikol + 1ll * maxValue, visitedByKlimi)) {
            return true;
        }
    }

    return false;
}

bool isWinning(int startIndex) {
    vector<bool> visitedByKlimi(n, false);

    return check_is_winning(startIndex, true, 0ll, 0ll, visitedByKlimi);
}
