#include <iostream>
#include <algorithm>
#include <vector>

#define endl '\n'

using namespace std;

void make_all_k_combinations(int currentNumber, int n, int k, vector<int> &currentCombination, vector<vector<int>> &allCombinatons) {
     if ((int) currentCombination.size() == k) {
        allCombinatons.push_back(currentCombination);

        return;
     }

     for (int i = currentNumber; i < n; ++i) {
        currentCombination.push_back(i);

        make_all_k_combinations(i + 1, n, k, currentCombination, allCombinatons);

        currentCombination.pop_back();
     }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;

    for (int test = 0; test < tests; ++test) {
        int n, k, x;
        cin >> n >> k >> x;

        vector<int> nums(n);

        for (int i = 0; i < n; ++i) {
            cin >> nums[i];
        }

        vector<int> original = nums;
        sort(nums.begin(), nums.end());

        vector<vector<int>> allCombinatons;
        vector<int> currentCombination;

        make_all_k_combinations(0, n, k, currentCombination, allCombinatons);

        do {
            bool istGut = true;

            for (vector<int> combination : allCombinatons) {
                int gcd1 = 0;
                int gcd2 = 0;

                for (int index : combination) {
                    gcd1 = __gcd(gcd1, original[index]);
                    gcd2 = __gcd(gcd2, nums[index]);
                }

                if (gcd1 != gcd2) {
                    istGut = false;
                    break;
                }
            }

            if (istGut) {
                break;
            }
        } while (next_permutation(nums.begin(), nums.end()));

        for (int num : nums) {
            cout << num << " ";
        }
        cout << endl;
    }

    return 0;
}