#include <iostream>
#include <vector>
#include <algorithm>
#include "game.h"
///#include "Lgrader.cpp"

using namespace std;
vector<int> A;
int bigInd;
int D;
vector<bool> state;
int segmentTree[600000];
void fixSize(){
    int n = 1;
    while(n<A.size()){
        n *= 2;
    }
    A.resize(n);
}

void setup(int ind, int otK, int doK){
    if(otK == doK-1){
        segmentTree[ind] = A[otK];
        return;
    }

    setup(ind*2+1, otK, (otK+doK)/2);
    setup(ind*2+2, (otK+doK)/2, doK);
    segmentTree[ind] = max(segmentTree[ind*2+1], segmentTree[ind*2+2]);
}
int query(int l, int r, int ind, int otK, int doK){
    //cout<<"Query: "<<otK<<" "<<doK<<"\n";
    if(r<otK || doK-1<l){
        return -1;
    }
    if(l<=otK && doK-1<=r){
        return segmentTree[ind];
    }
    return max(query(l, r, ind*2+1, otK, (otK+doK)/2), query(l, r, ind*2+2, (otK+doK)/2, doK));
}


void printState(){
    for(int i=0; i<state.size(); i++){
        cout<<state[i]<<" ";
    }
    cout<<"\n";
}
void findLocals(int l, int r){
    vector<int> locals;
    if(l == r){
        //return;
    }
    for(int i=l; i<=r; i++){
        /*int biggest = -1;
        for(int off=-D; off<=D; off++){
            if(i+off >= l && i+off <= r){
                biggest = max(biggest, A[i+off]);
            }
        }*/
        int biggest = query(max(l, i-D), min(r, i+D), 0, 0, A.size());
        if(biggest == A[i]){
            state[i] = 1;
            locals.push_back(i);
        }
    }
    ///printState();
    ///sort(locals.begin(), locals.end());
    if(locals[0]-D-1 >= l){
        findLocals(l, locals[0]-D-1);
    }
    for(int i=0; i<locals.size()-1; i++){
        if(locals[i]+D+1 <= locals[i+1]-D-1){
            findLocals(locals[i]+D+1, locals[i+1]-D-1);
        }
    }
    if(locals[locals.size()-1]+D+1 <= r){
        findLocals(locals[locals.size()-1]+D+1, r);
    }
}
void init(vector<int> v, int d){
    A = v;
    D = d;
    fixSize();
    setup(0, 0, A.size());

    state.resize(A.size(), 0);

    //cout<<query(0, A.size()-5, 0, 0, A.size());
    findLocals(0, A.size()-1);
    //printState();
}
bool isWinning(int startIndex){
    //printState();
    return !state[startIndex];

}
void updateValue(int index, int newValue){
    A[index] = newValue;
    state = {};
    state.resize(A.size(), 0);

    setup(0, 0, A.size());
    findLocals(0, A.size()-1);
    ///printState();
}
/*
6 2
1 7 4 9 30 2
1
1 4 8

6 2
1 7 4 9 30 2
5
2 0
2 1


10 2
29 28 3 5 1 7 4 9 30 2
*/

