#include <bits/stdc++.h>
#include "game.h"
using namespace std;
typedef int ll;

const ll Size=2e5+1;

ll seg_tree[4*Size];
vector<ll> A1;
bool isWinner[Size],solved[Size];
ll n,dist;

void build(ll l,ll r,ll i){
    if(l==r){
        seg_tree[i]=-1;
    }else{
        ll mid=(l+r)/2;
        build(l,mid,i*2);
        build(mid+1,r,i*2+1);
        seg_tree[i]=max(seg_tree[i*2],seg_tree[i*2+1]);
    }
}

ll query(ll l,ll r,ll tl,ll tr,ll i){
    if(r<tl or l>tr)
        return -1;
    if(tl==l and tr==r){
        return seg_tree[i];
    }else{
        ll mid=(l+r)/2;
        ll n1=query(l,mid,tl,min(tr,mid),i*2);
        ll n2=query(mid+1,r,max(tl,mid+1),tr,i*2+1);
        if(n1==-1)
            return n2;
        if(n2==-2)
            return n1;
        return max(n1,n2);
    }
}

void update(ll l,ll r,ll t,ll i){
    ll mid=(l+r)/2;
    if(l==r){
        seg_tree[i]=A1[t];
        return;
    }
    if(mid>=t){
        update(l,mid,t,i*2);
    }else{
        update(mid+1,r,t,i*2+1);
    }
    seg_tree[i]=max(seg_tree[i*2],seg_tree[i*2+1]);
}

bool isWinning(ll startIndex){
    return isWinner[startIndex];
}

void updateValue(ll index, ll newValue){
    A1[index]=newValue;
    /*
    stack<pair<ll,ll>> largest_value;
    largest_value.push({A1[0],0});
    closest_left[0]=-1;
    for(ll i=1;i<n;i++){
        pair<ll,ll> curr=largest_value.top();
        while(largest_value.size()>1 and A1[i]>=curr.first){
            largest_value.pop();
            curr=largest_value.top();
        }
        if(largest_value.size()==1 and A1[i]>=curr.first){
            closest_left[i]=-1;
            largest_value.pop();
        }else{
            closest_left[i]=curr.second;
        }
        largest_value.push({A1[i],i});
    }
    while(!largest_value.empty()){
        largest_value.pop();
    }
    largest_value.push({A1[n-1],n-1});
    closest_right[n-1]=n;
    for(ll i=n-2;i>=0;i--){
        pair<ll,ll> curr=largest_value.top();
        while(largest_value.size()>1 and A1[i]>=curr.first){
            largest_value.pop();
            curr=largest_value.top();
        }
        if(largest_value.size()==1 and A1[i]>=curr.first){
            closest_right[i]=-1;
            non_trivial_right[i]=-1;
            largest_value.pop();
        }else{
            closest_right[i]=curr.second;
            if(closest_right[i]-i<=dist){
                non_trivial_right[i]=non_trivial_right[curr.second]+1;
            }else{

            }
        }
        largest_value.push({A1[i],i});
    }
    */
    build(0,n-1,1);
    for(ll i=0;i<n;i++){
        isWinner[i]=true;
        solved[i]=false;
    }
    vector<pair<ll,ll>> sortedA;
    for(ll i=0;i<n;i++){
        sortedA.push_back({A1[i],i});
    }
    sort(sortedA.rbegin(),sortedA.rend());
    for(ll i=0;i<n;i++){
        ll id=sortedA[i].second;
        ll l=max(id-dist,0), r=min(id+dist,n-1);
        ll state=query(0,n-1,l,r,1);
        if(state<A1[id]){
            isWinner[id]=false;
            update(0,n-1,id,1);
        }
        solved[id]=true;
    }
}

void init(vector<ll> A, ll D){
    n=A.size();
    dist=D;
    A1=A;
    updateValue(0,A1[0]);
}
