/**
  * V purviq edin chas ot sustezanieto se sluchi da spq i da sanuvam tochno 3 puti.
  */
#include <bits/stdc++.h>
#include "game.h"
#ifdef IATI_LOCAL
#include "Lgrader.cpp"
#endif
using namespace std;

vector<int> a;
struct Segmentno{
    vector<int> tree;
    void init(){
        tree.resize(a.size()*4);
        build(1, 0, a.size()-1);
    }
    void build(int idx, int left, int right){
        if(left == right){ tree[idx] = left; return; }

        int mid = (left+right)/2;
        build(idx*2, left, mid);
        build(idx*2+1, mid+1, right);
        if(a[tree[idx*2]] >= a[tree[idx*2+1]]){
            tree[idx] = tree[idx*2];
        }else{
            tree[idx] = tree[idx*2+1];
        }
    }
    int query(int idx, int left, int right, int from, int to){
        if(from <= left && right <= to){ return tree[idx]; }
        if(to < left || right < from){ return -1; }

        int mid = (left+right)/2;
        int ql = query(idx*2, left, mid, from, to);
        int qr = query(idx*2+1, mid+1, right, from, to);
        if(ql == -1){ return qr; }
        if(qr == -1){ return ql; }

        if(a[ql] >= a[qr]){ return ql; }
                      else{ return qr; }
    }
    void update(int idx, int left, int right, int pos){
        if(left == right){ tree[idx] = left; return; }
        if(pos < left || pos > right){ return; }

        int mid = (left+right)/2;
        update(idx*2, left, mid, pos);
        update(idx*2+1, mid+1, right, pos);

        if(a[tree[idx*2]] >= a[tree[idx*2+1]]){
            tree[idx] = tree[idx*2];
        }else{
            tree[idx] = tree[idx*2+1];
        }
    }
};
Segmentno segm;
vector<bool> canWin;
vector<int> localMxi;
int n, d;

int getMxi(int from, int to){
    return segm.query(1, 0, n-1, from, to);
}

void updateWins(int from, int to){
    int mxi = getMxi(from, to); /// get biggest in interval : sus segmentno
    bool skipLeft = true, skipRigth = true;
    for(int i = max(from, mxi-d); i <= min(to, mxi+d); i++){
        if(canWin[i] == false){
            if(i < mxi){ skipLeft = false; }
            else { skipRigth = false; }
        }
        canWin[i] = true;
        localMxi[i] = mxi;
    }
    canWin[mxi] = false;

    if(mxi-(d+1) >= from && !skipLeft){ updateWins(from, mxi-(d+1)); }
    if(mxi+(d+1) <= to && !skipRigth){ updateWins(mxi+(d+1), to); }
}

void init(vector<int> _a, int _d){
    a = _a;
    n = a.size();
    d = _d;

    canWin.resize(n);
    localMxi.resize(n);
    segm.init();
    updateWins(0, n-1);
}

void updateValue(int idx, int val){
    if(localMxi[idx] == idx && val >= a[idx]){
        a[idx] = val;
//        cout << "1\n";
//        cout << "2\n";
        return;
    }
    if(localMxi[idx] != idx && val < a[localMxi[idx]]){
        a[idx] = val;
        return;
    }
    a[idx] = val;
    segm.update(1, 0, n-1, idx);

    updateWins(0, n-1);
}

bool isWinning(int startIdx){
    return canWin[startIdx];
}
