#include<bits/stdc++.h>
#include "game.h"

#define MAXN 200002

using namespace std;

vector<int> mas;
int n, lastT = 1, mnBnd, mxBnd = 1, d;

struct segTree
{
    pair<int, int> arr[4 * MAXN];
    int lazy[4 * MAXN];
    void init()
    {
        for(int i = 0; i < 4 * n; i ++) lazy[i] = -1;
    }
    void build(int ind, int l, int r)
    {
        if(l == r)
        {
            arr[ind] = {mas[l], l};
            return;
        }
        int mid = (l + r) / 2;
        build(ind * 2 + 1, l, mid);
        build(ind * 2 + 2, mid + 1, r);
        arr[ind] = max(arr[ind * 2 + 1], arr[ind * 2 + 2]);
    }
    void update(int ind, int l, int r, int i, int v)
    {
        if(l == r)
        {
            arr[ind] = {v, l};
            return;
        }
        int mid = (l + r) / 2;
        if(i <= mid) update(ind * 2 + 1, l, mid, i, v);
        else update(ind * 2 + 2, mid + 1, r, i, v);
        arr[ind] = max(arr[ind * 2 + 1], arr[ind * 2 + 2]);
    }
    void updateLazy(int ind, int l, int r, int curL, int curR, int v)
    {
        if(curL > r || curR < l) return;
        if(lazy[ind] != -1) lazy[ind * 2 + 1] = lazy[ind * 2 + 2] = lazy[ind];
        lazy[ind] = -1;
        if(curL >= l && curR <= r)
        {
            lazy[ind] = v;
            arr[ind] = {v, 0};
            return;
        }
        int mid = (curL + curR) / 2;
        updateLazy(ind * 2 + 1, l, r, curL, mid, v);
        updateLazy(ind * 2 + 2, l, r, mid + 1, curR, v);
        arr[ind] = max(arr[ind * 2 + 1], arr[ind * 2 + 2]);
    }
    pair<int, int> query(int ind, int l, int r, int curL, int curR)
    {
        if(curL > r || curR < l) return {-1, -1};
        if(curL >= l && curR <= r) return arr[ind];
        int mid = (curL + curR) / 2;
        return max(query(ind * 2 + 1, l, r, curL, mid), query(ind * 2 + 2, l, r, mid + 1, curR));
    }
}tree, lazyTree;

void init(vector<int> A, int D)
{
    mas = A;
    n = A.size();
    d = D;
    mnBnd = 0;
    mxBnd = n - 1;
    tree.build(0, 0, n - 1);
    lazyTree.init();
}

void updateValue(int index, int newValue)
{
    tree.update(0, 0, n - 1, index, newValue);
    lastT = 1;
}

void rec(int l, int r)
{
    //cout<<l<<" "<<r<<endl;
    if(l > r || l >= n || r < 0) return;
    pair<int, int> cur = tree.query(0, l, r, 0, n - 1);
    int mxInd = cur.second;
    int bg = max(l, mxInd - d);
    int ed = min(r, mxInd + d);

    if(bg <= mxInd - 1) lazyTree.updateLazy(0, bg, mxInd - 1, 0, n - 1, 1);
    //cout<<"Set "<<max(mxInd - d, l)<<" "<<mxInd - 1<<" as 1\n";
    if(ed >= mxInd + 1)lazyTree.updateLazy(0, mxInd + 1, ed, 0, n - 1, 1);
    //cout<<"Set "<<mxInd + 1<<" "<<min(r, mxInd + d)<<" as 1\n";
    lazyTree.updateLazy(0, mxInd, mxInd, 0, n - 1, 0);

    /*for(int i = bg; i < mxInd; i ++) lazyTree.update(0, 0, n - 1, i, 1);
    for(int i = mxInd + 1; i <= ed; i ++) lazyTree.update(0, 0, n - 1, i, 1);
    lazyTree.update(0, 0, n - 1, mxInd, 0);
    //cout<<"Set "<<mxInd<<" "<<mxInd<<" as 0\n";*/

    if(l == r) return;
    if(!(mxInd - d - 1 < 0))rec(l, mxInd - d - 1);
    if(!(mxInd + d + 1 >= n)) rec(mxInd + d + 1, r);
}
bool isWinning(int startIndex)
{
    if(lastT)
    {
        rec(0, n - 1);
    }
    lastT = 0;
    return lazyTree.query(0, startIndex, startIndex, 0, n - 1).first;
}
