#include "game.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;

int n;
int a[maxn];
int d;

vector<int> g[maxn];

void init(vector<int> A, int D)
{
    n = A.size();
    d = D;

    for (int i = 1; i <= n; ++i)
    {
        a[i] = A[i - 1];
    }

    for (int i = 1; i <= n; ++i)
    {
        for (int j = i + 1; j <= min(n, i + d); ++j)
        {
            if (a[j] > a[i])
            {
                //cout << i << " -> " << j << endl;
                g[i].push_back(j);
            }
        }

        for (int j = i - 1; j >= max(1, i - d); --j)
        {
            if (a[j] > a[i])
            {
                //cout << i << " -> " << j << endl;
                g[i].push_back(j);
            }
        }
    }
}

void updateValue(int index, int newValue)
{
    ++index;

    int from = max(1, index - d);
    int to = min(n, index + d);

    for (int i = from; i <= to; ++i)
    {
        g[i].clear();
    }

    a[index] = newValue;

    for (int i = from; i <= to; ++i)
    {
        for (int j = i + 1; j <= min(to, i + d); ++j)
        {
            if (a[j] > a[i])
            {
                g[i].push_back(j);
            }
        }

        for (int j = i - 1; j >= max(from, i - d); --j)
        {
            if (a[j] > a[i])
            {
                g[i].push_back(j);
            }
        }
    }
}

bool dp[maxn][2];
bool mem[maxn][2];

bool f(int pos, bool who)
{
    //cout << pos << " " << who << endl;
    if (g[pos].empty() == true)
    {
        return false;
    }

    if (mem[pos][who] == true)
    {
        return dp[pos][who];
    }

    mem[pos][who] = true;

    for (int i = 0; i < g[pos].size(); ++i)
    {
        dp[pos][who] |= (!f(g[pos][i], 1 - who));
    }

    return dp[pos][who];
}

bool isWinning(int startIndex)
{
    //1 - first, 0 - second

    for (int i = 1; i <= n; ++i)
    {
        mem[i][0] = mem[i][1] = 0;
        dp[i][0] = dp[i][1] = 0;
    }

    return f(startIndex + 1, 1);
}
