/*
    Vuv tebe vsichko mamka mu e top top top
    Habibi e top top
    Krakata ti top top
    Ochite ti top top
    Kosite ti top top
    Ustata ti top top
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>
#include <stack>
#include <chrono>
#include <random>
#include <set>
#include <map>

typedef long long llong;
const int MAXN = 500000 + 10;
const int INF  = 1e9;

int n, m;
struct Fenwick
{
    int tree[MAXN];
    void reset()
    {
        std::fill(tree, tree + 1 + n, 0);
    }

    void update(int pos, int val)
    {
        for (int idx = pos ; idx <= n ; idx += idx & (-idx))
        {
            tree[idx] += val;
        }   
    }  

    void rangeUpdate(int l, int r, int val)
    {
        update(l, val);
        update(r + 1, -val);
    }

    int query(int pos)
    {
        int res = 0;
        for (int idx = pos ; idx > 0 ; idx -= idx & (-idx))
        {
            res += tree[idx];
        }

        return res;
    }
};

int a[MAXN];
int ptr[MAXN];
int pos[MAXN];
int nodes[MAXN];
bool isVisited[MAXN];
std::vector <int> g[MAXN];
std::vector <int> g2[MAXN];
std::set <int> goodNodes;
int cntVisited;

std::vector <int> tour;
std::vector <int> inTour[MAXN];
void dfs(int node, int par)
{
    if (par != 0)
    {
        assert(g[node].back() == par);
    }

    if (par != 0) tour.push_back(node);
    for (const int &u : g[node])
    {
        if (u == par)
        {
            continue;
        }

        dfs(u, node);
        tour.push_back(node);
    }
}

void solve()
{   
    llong time = 1;
    int node = 1;
    int globalPtr = 1;
    while (globalPtr <= m)
    {
        if (node == nodes[globalPtr])
        {
            globalPtr++;
            if (globalPtr == m + 1)
            {
                std::cout << time << '\n';
                exit(0);
            }
        }
        
        time++;
        cntVisited += !isVisited[node];
        isVisited[node] = true;
        if (cntVisited == n)
        {
            break;
        }

        int next = g[node][ptr[node]];
        ptr[node]++;
        if (ptr[node] == g[node].size()) ptr[node] = 0;
        node = next;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        g2[i].reserve(g[i].size());
        for (int j = ptr[i] ; j < g[i].size() ; ++j)
        {
            g2[i].push_back(g[i][j]);
        }

        for (int j = 0 ; j < ptr[i] ; ++j)
        {
            g2[i].push_back(g[i][j]);
        }

        g[i] = g2[i];
    }

    dfs(node, 0);
    int idx = 0;

    for (const int &u : tour)
    {
        inTour[u].push_back(idx);
        idx++;
    }

    int tourPos = -1;
    for (int i = globalPtr ; i <= m ; ++i)
    {
        int u = nodes[i];
        int l = -1, r = inTour[nodes[i]].size(), mid;
        while (l < r - 1)
        {
            mid = (l + r) / 2;
            if (tourPos >= inTour[nodes[i]][mid]) l = mid;
            else r = mid;
        }

        if (r != inTour[nodes[i]].size())
        {
            time += inTour[nodes[i]][r] - tourPos;
            tourPos = inTour[nodes[i]][r];
        } else
        {
            time += tour.size() - tourPos + inTour[nodes[i]][0];
            tourPos = inTour[nodes[i]][0];
        }
    }

    std::cout << time << '\n';
}

void input()
{
    std::cin >> n >> m;
    for (int i = 1 ; i <= n ; ++i)
    {
        int sz;
        std::cin >> sz;
        g[i].resize(sz);

        for (int j = 0 ; j < sz ; ++j)
        {
            std::cin >> g[i][j];
        }
    }

    for (int i = 1 ; i <= m ; ++i)
    {
        std::cin >> nodes[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}