/*
    Vuv tebe vsichko mamka mu e top top top
    Habibi e top top
    Krakata ti top top
    Ochite ti top top
    Kosite ti top top
    Ustata ti top top
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>
#include <stack>
#include <chrono>
#include <random>
#include <set>
#include <map>

typedef long long llong;
const int MAXN = 500000 + 10;
const int INF  = 1e9;

int n, m;
struct Fenwick
{
    int tree[MAXN];
    void reset()
    {
        std::fill(tree, tree + 1 + n, 0);
    }

    void update(int pos, int val)
    {
        for (int idx = pos ; idx <= n ; idx += idx & (-idx))
        {
            tree[idx] += val;
        }   
    }  

    void rangeUpdate(int l, int r, int val)
    {
        update(l, val);
        update(r + 1, -val);
    }

    int query(int pos)
    {
        int res = 0;
        for (int idx = pos ; idx > 0 ; idx -= idx & (-idx))
        {
            res += tree[idx];
        }

        return res;
    }
};

int a[MAXN];
int in[MAXN];
int out[MAXN];
int ptr[MAXN];
int pos[MAXN];
int nodes[MAXN];
bool isVisited[MAXN];
std::vector <int> g[MAXN];
std::vector <int> g2[MAXN];
std::set <int> goodNodes;
Fenwick fenwick;
int cntVisited;

std::vector <int> tour;
std::vector <int> inTour[MAXN];
void dfs(int node, int par)
{
    if (par != 0)
    {
        assert(g[node].back() == par);
    }

    if (par != 0) tour.push_back(node);
    for (const int &u : g[node])
    {
        if (u == par)
        {
            continue;
        }

        dfs(u, node);
        tour.push_back(node);
    }
}

int timer;
int firstParent[MAXN];
void buildDFS(int node, int par)
{
    in[node] = ++timer;
    firstParent[node] = par;
    for (const int &u : g[node])
    {
        if (u == par)
        {
            continue;
        }

        buildDFS(u, node);
    }

    out[node] = timer;
}

void setPointing(int node, int idx, int val)
{
    if (firstParent[node] == g[node][idx])
    {
        fenwick.rangeUpdate(1, n, val);
        fenwick.rangeUpdate(in[node], out[node], -val);
        return;
    }

    fenwick.rangeUpdate(in[g[node][idx]], out[g[node][idx]], val);
}

void solve()
{   
    buildDFS(1, 0);
    llong time = 1;
    int node = 1;
    int globalPtr = 1;

    for (int i = 1 ; i <= n ; ++i)
    {
        setPointing(i, g[i].size() - 1, 1);
    }

    while (globalPtr <= m)
    {
        if (node == nodes[globalPtr])
        {
            globalPtr++;
            if (globalPtr == m + 1)
            {
                std::cout << time << '\n';
                exit(0);
            }
        }
        
        time++;
        
        if (fenwick.query(in[node]) == n - 1)
        {
            break;
        }

        cntVisited += !isVisited[node];
        isVisited[node] = true;
        // if (cntVisited == n)
        // {
        //     std::cout << "What the fuck: " << cntVisited << ' ' << fenwick.qu
        // }

        assert(cntVisited < n);
        setPointing(node, (ptr[node] == 0 ? g[node].size() - 1 : ptr[node] - 1), -1);

        int next = g[node][ptr[node]];
        ptr[node]++;

        if (ptr[node] == g[node].size()) ptr[node] = 0;
        setPointing(node, (ptr[node] == 0 ? g[node].size() - 1 : ptr[node] - 1), 1);
        node = next;
    }

    if (n > 1000 || m > 1000)
    {
        return;
    }
    
    for (int i = 1 ; i <= n ; ++i)
    {
        g2[i].reserve(g[i].size());
        for (int j = ptr[i] ; j < g[i].size() ; ++j)
        {
            g2[i].push_back(g[i][j]);
        }

        for (int j = 0 ; j < ptr[i] ; ++j)
        {
            g2[i].push_back(g[i][j]);
        }

        g[i] = g2[i];
    }

    dfs(node, 0);
    int idx = 1;

    for (const int &u : tour)
    {
        inTour[u].push_back(idx);
        idx++;
    }

    int tourPos = 0;
    for (int i = globalPtr ; i <= m ; ++i)
    {
        int u = nodes[i];
        int l = -1, r = inTour[u].size(), mid;
        while (l < r - 1)
        {
            mid = (l + r) / 2;
            if (tourPos >= inTour[u][mid]) l = mid;
            else r = mid;
        }

        if (r != inTour[u].size())
        {
            time += inTour[u][r] - tourPos;
            tourPos = inTour[u][r];
        } else
        {
            time += tour.size() - tourPos + inTour[u][0];
            tourPos = inTour[u][0];
        }
    }   

    time--;
    std::cout << time << '\n';
}

void input()
{
    std::cin >> n >> m;
    for (int i = 1 ; i <= n ; ++i)
    {
        int sz;
        std::cin >> sz;
        g[i].resize(sz);

        for (int j = 0 ; j < sz ; ++j)
        {
            std::cin >> g[i][j];
        }
    }

    for (int i = 1 ; i <= m ; ++i)
    {
        std::cin >> nodes[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}