/*
    Vuv tebe vsichko mamka mu e top top top
    Habibi e top top
    Krakata ti top top
    Ochite ti top top
    Kosite ti top top
    Ustata ti top top
*/

#include "game.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <queue>
#include <stack>
#include <chrono>
#include <cassert>
#include <random>
#include <set>
#include <map>

// #include <ext/pb_ds/assoc_container.h>
// #include <tree_policy.h>

// using namespace __gnu_pbds;

// template <typename T>
// using OSet = std::tree <T, std::less <T>, nullptr, 

typedef long long llong;
const int MAXN = 200000 + 10;
const int MAXLOG = 18;
const int INF  = 1e9;

int n, d;
struct Fenwick
{
    int tree[MAXN];
    void reset()
    {
        std::fill(tree, tree + 1 + n, 0);
    }

    void update(int pos, int val)
    {
        for (int idx = pos ; idx <= n ; idx += idx & (-idx))
        {
            tree[idx] += val;
        }   
    }  

    int query(int pos)
    {
        int res = 0;
        for (int idx = pos ; idx > 0 ; idx -= idx & (-idx))
        {
            res += tree[idx];
        }

        return res;
    }

    int findFirstBigger(int value)
    {
        if (value < 0)
        {
            return 0;
        }

        int ptr = 0;
        for (int lg = MAXLOG - 1 ; lg >= 0 ; --lg)
        {
            if (ptr + (1 << lg) <= n && tree[ptr + (1 << lg)] <= value)
            {
                ptr += (1 << lg);
                value -= tree[ptr];
            }
        }
        
        return ptr + 1;
    }
};

int a[MAXN];
int perm[MAXN];
bool win[MAXN];
Fenwick tree;

void init(std::vector <int> A, int D)
{
    n = A.size();
    d = D;

    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = A[i - 1];
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        bool local = true;
        for (int j = std::max(1, i - d) ; j <= std::max(n, i + d) ; ++j)
        {
            if (a[j] > a[i])
            {
                local = false;
                break;
            }
        }

        if (local)
        {
            tree.update(i, 1);
        }
    }
}

bool isWinning(int index)
{
    index++;
    int cntToMe = tree.query(index);
    int left = tree.findFirstBigger(cntToMe - 1);
    int right = tree.findFirstBigger(cntToMe);

    if ((left > 0 && index <= left + d) || (right <= n && index + d >= right))
    {
        return true;
    }

    int leftPos = (left == 0 ? 1 : left + d + 1);
    int rightPos = (right == n + 1 ? n : right - d - 1);
    int cntBigger = 0;
    for (int i = leftPos ; i <= rightPos ; ++i)
    {
        cntBigger += (a[i] > a[index]);
    }   

    return cntBigger & 1;
}

void updateValue(int idx, int value)
{
    idx++;
    a[idx] = value;

    tree.reset();
    for (int i = 1 ; i <= n ; ++i)
    {
        bool local = true;
        for (int j = std::max(1, i - d) ; j <= std::max(n, i + d) ; ++j)
        {
            if (a[j] > a[i])
            {
                local = false;
                break;
            }
        }

        if (local)
        {
            tree.update(i, 1);
        }
    }
}
