#include <bits/stdc++.h>
#include "game.h"
#define pb push_back
#define ff first
#define ss second
#define rep(i, n) for (int i = 0; i < int(n); i++)
#define replr(i, l, r) for (int i = int(l); i <= int(r); i++) 
#define reprl(i, r, l) for (int i = int(r); i >= int(l); i--) 
using namespace std;
typedef pair<int, int> PII;
typedef vector<int> VI;
typedef vector<PII> VPI;
typedef vector<VI> VVI;
typedef long long ll;
typedef pair<ll, ll> PLL;
typedef vector<ll> VL;
typedef vector<PLL> VPL;
typedef vector<VL> VVL;

struct SEGTREE {
	int n;
	VI a;
	VI tree;
	SEGTREE(VI vec) {
		a = vec;
		n = 1;
		while (n < a.size()) n *= 2;
		while (a.size() < n) a.pb(0);
		tree = VI(2*n, -1);

		for (int i = n-1; i < 2*n-1; i++) tree[i] = i-(n-1);

		for (int u = n-2; u >= 0; u--) {
			int i = tree[2*u+1];
			int j = tree[2*u+2];
			if (a[i] > a[j]) tree[u] = i;
			else tree[u] = j;
		}
	}
	int get(int N, int L, int R, int l, int r) {
		if (R < l || L > r) return -1;
		if (l <= L && R <= r) return tree[N];
		int M = (L + R)/2;
		int i = get(2*N+1, L, M, l, r);
		int j = get(2*N+2, M+1, R, l, r);
		if (i == -1) return j;
		if (j == -1) return i;
		if (a[i] > a[j]) return i;
		return j;
	}
	int get(int l, int r) {
		return get(0, 0, n-1, l, r);
	}
};

VI ans;
int n;
VI a;
int d;

void solve() {
	ans = VI(n, 2);
	SEGTREE seg(a);
	VPI ranges;
	ranges.pb({0, n-1});
	auto avelacnel = [&](int L, int R) {
		if (L <= R) ranges.pb({L, R});
	};
	while (ranges.size()) {
		int l = ranges.back().ff;
		int r = ranges.back().ss;
		ranges.pop_back();
		int c = seg.get(l, r);
		ans[c] = 0;
		for (int i = c+1; i <= c+d && i <= r; i++) ans[i] = 1;
		for (int i = c-1; i >= c-d && i >= l; i--) ans[i] = 1;
		avelacnel(c+d+1, r);
		avelacnel(l, c-d-1);
	}
}

void init(VI A, int D) {
	a = A;
	d = D;
	n = a.size();
	solve();
}

void updateValue(int index, int newValue) {
	a[index] = newValue;
	solve();
}

bool isWinning(int startIndex) {
	return ans[startIndex];
}
