#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <string>
#include <numeric>
#include <limits>
#include <climits>
using namespace std;

typedef long long ll;

#define pb push_back
#define all(v) (v).begin(), (v).end()
#define mkp make_pair

const int INF = INT_MAX;
const long long LNF = LLONG_MAX;

const int N = 100003;
int k[N], p[N];
int n, m, ind, ans, res;

vector<int> g[N];
bool used[N];
vector<int> order;
vector<int> v[N];

void dfs(int v)
{
	if (res == n && v == 1) return;
	if (!used[v]) {
		used[v] = true;
		res++;
	}

	ans++;
	if (p[ind] == v) {
		ind++;
		if (ind > m) return;
	}
	
	int u = g[v][0];
	g[v].erase(g[v].begin());
	g[v].push_back(u);

	dfs(u);
	return;
}

void dfs1(int v) {
	used[v] = true;
	order.pb(v);
	for (auto u : g[v]) {
		if (!used[u]) {
			dfs1(u);
			order.push_back(v);
		}
	}

	return;
}

void solve()
{
	int i, j;

	cin >> n >> m;
	for (i = 1; i <= n; i++) {
		int x;
		cin >> x;
		for (j = 1; j <= x; j++) {
			cin >> k[j];
			g[i].pb(k[j]);
		}
	}

	for (i = 1; i <= m; i++) {
		cin >> p[i];
	}

	ans = 0LL;
	res = 0LL;
	ind = 1;
	dfs(1);

	if (ind > m) {
		cout << ans << "\n";
		return;
	}

	ans++;

	for (i = 1; i <= n; i++) used[i] = false;
	dfs1(1);
	order.erase(order.end() - 1);

	for (i = 0; i < order.size(); i++) {
		v[order[i]].pb(i);
	}

	ans += v[p[ind]][0];
	int x = v[p[ind]][0];
	ind++;

	for (i = ind; i <= m; i++) {
		j = upper_bound(all(v[p[i]]), x) - v[p[i]].begin();
		if (j == v[p[i]].size()) {
			ans += (order.size() - x);
			ans += v[p[i]][0];
			x = v[p[i]][0];
		}
		else {
			ans += (v[p[i]][j] - x);
			x = v[p[i]][j];
		}
	}

	cout << ans << "\n";
	return;
}

int main()
{
	int mt = 1;
	//cin >> mt;
	while (mt--) {
		solve();
	}
	return 0;
}