#include "game.h"
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <string>
#include <numeric>
#include <limits>
#include <climits>
using namespace std;

typedef long long ll;

#define pb push_back
#define all(v) (v).begin(), (v).end()
#define mkp make_pair

const int INF = INT_MAX;
const long long LNF = LLONG_MAX;

///////////////////////////

const int N = 200003;
int a[N], b[N];
int d, n;
int treemx[4 * N], tree[4 * N];

void buildmx(int v, int tl, int tr)
{
	if (tl == tr) {
		treemx[v] = a[tl];
		return;
	}

	int mid = (tl + tr) / 2;

	buildmx(2 * v, tl, mid);
	buildmx(2 * v + 1, mid + 1, tr);

	treemx[v] = max(treemx[2 * v], treemx[2 * v + 1]);
	return;
}

void updatemx(int v, int tl, int tr, int ind, int c)
{
	if (tl == tr) {
		treemx[v] = c;
		return;
	}

	int mid = (tl + tr) / 2;

	if (ind <= mid) updatemx(2 * v, tl, mid, ind, c);
	else updatemx(2 * v + 1, mid + 1, tr, ind, c);

	treemx[v] = max(treemx[2 * v], treemx[2 * v + 1]);
	return;
}

int querymx(int v, int tl, int tr, int l, int r)
{
	if (tl > r || tr < l) return -INF;
	if (tl >= l && tr <= r) return treemx[v];

	int mid = (tl + tr) / 2;

	return max(querymx(2 * v, tl, mid, l, r), querymx(2 * v + 1, mid + 1, tr, l, r));
}

void build(int v, int tl, int tr)
{
	if (tl == tr) {
		tree[v] = b[tl];
		return;
	}

	int  mid = (tl + tr) / 2;

	build(2 * v, tl, mid);
	build(2 * v + 1, mid + 1, tr);

	tree[v] = tree[2 * v] + tree[2 * v + 1];
	return;
}

void update(int v, int tl, int tr, int ind, int c)
{
	if (tl == tr) {
		tree[v] = c;
		return;
	}

	int mid = (tl + tr) / 2;

	if (ind <= mid) update(2 * v, tl, mid, ind, c);
	else update(2 * v + 1, mid + 1, tr, ind, c);

	tree[v] = tree[2 * v] + tree[2 * v + 1];
	return;
}

int query(int v, int tl, int tr, int l, int r)
{
	if (tl > r || tr < l) return 0;
	if (tl >= l && tr <= r) return tree[v];

	int mid = (tl + tr) / 2;

	return query(2 * v, tl, mid, l, r) + query(2 * v + 1, mid + 1, tr, l, r);

	return true;
}

void updateValue(int ind, int c) {
	ind++;
	a[ind] = c;

	updatemx(1, 1, n, ind, c);

	for (int i = ind - d; i <= ind + d; i++) {
		if (querymx(1, 1, n, max(1, i - d), min(n, i + d)) <= a[i]) update(1, 1, n, i, 1);
		else update(1, 1, n, i, 0);
	}

	return;
}

bool isWinning(int ind) {
	ind++;
	bool flag = false;

	int lx = 0, rx = n + 1;

	if (ind < n) {
		int l = ind + 1, r = n;
		while (l < r) {
			int mid = (l + r) / 2;
			if (query(1, 1, n, ind + 1, mid) > 0) r = mid;
			else l = mid + 1;
		}
		rx = r;
	}
	if (ind > 1) {
		int l = 1, r = ind - 1;
		while (l < r) {
			int mid = (l + r) / 2;
			if (query(1, 1, n, 1, mid) > 0) l = mid + 1;
			else r = mid;
		}
		lx = l;
	}
	rx--;
	lx++;

	if (querymx(1, 1, n, max(lx, ind - d), min(rx, ind + d)) >= a[ind]) return true;
	else return false;
}

void init(std::vector<int> A, int D) {
	n = A.size();
	for (int i = 0; i < A.size(); i++) {
		a[i + 1] = A[i];
	}
	d = D;

	buildmx(1, 1, n);

	for (int i = 1; i <= n; i++) {
		if (querymx(1, 1, n, max(1, i - d), min(n, i + d)) <= a[i]) b[i] = 1;
		else b[i] = 0;
	}

	build(1, 1, n);
	return;
}
