#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <string>
#include <numeric>
#include <limits>
#include <climits>
using namespace std;

typedef long long ll;

#define pb push_back
#define all(v) (v).begin(), (v).end()
#define mkp make_pair

const int INF = INT_MAX;
const long long LNF = LLONG_MAX;

const int N = 1003;
ll a[N], b[N];
int n, k, x;
vector<ll> v;
vector<vector<ll>> vx;

ll gcd(ll a, ll b) {
	if (a == 0LL || b == 0LL) return max(a, b);
	if (a >= b) return gcd(b, a % b);
	else return gcd(a, b % a);
}

void solve()
{
	v.clear();
	vx.clear();
	int i, j, p, q, r, g;
	cin >> n >> k >> x;

	for (i = 1; i <= n; i++) {
		cin >> a[i];
		v.pb(a[i]);
	}

	for (i = 0; i < 30; i++) {
		next_permutation(all(v));

		if (k == 2) {
			bool flag = true;
			for (j = 1; j < n; j++) {
				for (p = j + 1; p <= n; p++) {
					if (gcd(a[j], a[p]) != gcd(v[j - 1], v[p - 1])) {
						flag = false;
						break;
					}
				}
			}

			if (flag) {
				vx.pb(v);
			}
		}
		else if (k == 3) {
			bool flag = true;
			for (j = 1; j < n - 1; j++) {
				for (p = j + 1; p < n; p++) {
					for (q = p + 1; q <= n; q++) {
						if (gcd(gcd(a[j], a[p]), a[q]) != gcd(gcd(v[j - 1], v[p - 1]), v[q - 1])) {
							flag = false;
							break;
						}
					}
				}
			}

			if (flag) {
				vx.pb(v);
			}
		}
		else if (k == 4) {
			bool flag = true;
			for (j = 1; j < n - 2; j++) {
				for (p = j + 1; p < n - 1; p++) {
					for (q = p + 1; q < n; q++) {
						for (r = q + 1; r <= n; r++) {
							if (gcd(gcd(a[j], a[p]), gcd(a[q], a[r])) != gcd(gcd(v[j - 1], v[p - 1]), gcd(v[q - 1], v[r- 1]))) {
								flag = false;
								break;
							}
						}
					}
				}
			}

			if (flag) {
				vx.pb(v);
			}
		}
		else if (k == 5) {
			bool flag = true;
			for (j = 1; j < n - 3; j++) {
				for (p = j + 1; p < n - 2; p++) {
					for (q = p + 1; q < n - 1; q++) {
						for (r = q + 1; r < n; r++) {
							for (g = r + 1; g <= n; g++) {
								if (gcd(gcd(gcd(a[j], a[p]), gcd(a[q], a[r])), a[g]) != gcd(gcd(gcd(v[j - 1], v[p - 1]), gcd(v[q - 1], v[r - 1])), v[g - 1])) {
									flag = false;
									break;
								}
							}
						}
					}
				}
			}

			if (flag) {
				vx.pb(v);
			}
		}
	}

	sort(all(vx));
	for (j = 0; j < n; j++) {
		cout << vx[0][j] << ' ';
	}
	cout << "\n";

	return;
}

int main()
{
	int mt = 1;
	cin >> mt;
	while (mt--) {
		solve();
	}
	return 0;
}