#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <cmath>
//#include "Lgrader.cpp"
#include <algorithm>
#include "game.h"
typedef long long ll;
using namespace std;
vector<int> A;
int N;
int D;
int t[800005];
bool dp[200005];
map<int, int> ind;
void build(int v, int l, int r) {
	if (l == r) t[v] = A[l];
	else {
		int m = (l + r) / 2;
		build(2 * v, l, m);
		build(2 * v + 1, m + 1, r);
		t[v] = max(t[2 * v], t[2 * v + 1]);
	}
}
void update(int v, int l, int r, int pos, int val) {
	if (pos >= l && pos <= r) {
		if (l == r) t[v] = val;
		else {
			int m = (l + r) / 2;
			update(2 * v, l, m, pos, val);
			update(2 * v + 1, m + 1, r, pos, val);
			t[v] = max(t[2 * v], t[2 * v + 1]);
		}
	}
	return;
}
int query(int v, int l, int r, int tl, int tr) {
	if (tl>=l && tr <= r) return t[v];
	if (tr<l || tl>r) return 0;
	int m = (tl + tr) / 2;
	return max(query(2 * v, l, r, tl, m), query(2 * v + 1, l, r, m + 1, tr));
}
void builddp(int l, int r) {
	int mx = query(1, l, r, 0, N - 1);
	// ind[mx]
	int I = ind[mx];
	dp[I] = 0;
	for (int i = I + 1; i <= min(r, I + D); i++) {
		dp[i] = 1;
	}
	for (int i = I - 1; i >= max(l, I - D); i--) {
		dp[i] = 1;
	}
	if (I + D < r) {
		builddp(I + D + 1, r);
	}
	//cout << "i-d-1=" << I - D - 1<<endl;
	//cout << "l=" << l << endl;
	//builddp(0, 1);
	if (I - D > l) {
		//cout << I<<' '<<D << ' ' << l << endl;
		builddp(l, I - D - 1);
	}
	return;
}
void updateValue(int pos, int val) {
	A[pos] = val;
	update(1, 0, N - 1, pos, val);
	//build(1, 0, N - 1);
	builddp(0, N - 1);
}
void init(vector<int> a, int d) {
	A = a;
	D = d;
	N = A.size();
	build(1, 0, N - 1);
	for (int i = 0; i < N; i++) {
		ind[A[i]] = i;
	}
	//cout <<"query"<< ind[query(1, 0, 1, 0, N - 1)];
	builddp(0, N - 1);
	//builddp(0, 1);
}
bool isWinning(int startIndex) {
	return dp[startIndex];
}
int main()
{
	int n, D, q;
	vector<int> nums;
	cin >> n >> D;
	for (int i = 1; i <= n; i++)
	{
		int x;
		cin >> x;
		nums.push_back(x);
	}
	//cout << "AA";
	init(nums, D);
	cin >> q;
	//cout << "a";
	for (int i = 1; i <= q; i++)
	{
		int cm;
		cin >> cm;
		if (cm == 1)
		{
			int ind, val;
			cin >> ind >> val;
			updateValue(ind, val);
		}
		else
		{
			int ind;
			cin >> ind;
			cout << isWinning(ind) << endl;
		}
	}
	return 0;
}
/*
6 2
1 7 4 9 8 2
2
2 0
2 1


*/