#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <cassert>
#include <assert.h>
#include <stack>
#include <bitset>
using namespace std;

typedef long long ll;

#define ff first
#define ss second
#define pr pair
#define mpr make_pair
#define pb push_back
#define sz(x) (int((x).size()))
#define clr(x) (x).clear()
#define all(x) (x).begin(), (x).end()

bool is_prime(ll x)
{
	if (x == 1) return false;

	for (ll i = 2; i * i <= x; i++) if (x % i == 0) return false;

	return true;
}

// ------------------------------------------------- //

const int N = 1005;
int a[N], ans[N];
int n, k, x;

bitset<N> bs[N];

set<int> st;

bool used[N];

vector<int> v1, v2;

void solve()
{
	int i, j;
	int e;

	cin >> n >> k >> x;

	clr(st);

	for (i = 1; i <= n; i++) {
		cin >> a[i];
		
		e = a[i];

		for (j = 2; j * j <= e; j++) {
			if (e % j == 0) {
				st.insert(j);

				while (e % j == 0) e /= j;
			}
		}

		if (e > 1) st.insert(e);

		bs[i].set();

		used[i] = 0;
	}


	bitset<N> b0;

	for (auto p : st) {
		b0.reset();
		for (i = 1; i <= n; i++) if (a[i] % p == 0) b0[i - 1] = 1;

		if (b0.count() < k) continue;

		for (i = 1; i <= n; i++) {
			if (a[i] % p == 0) {
				bs[i] &= b0;
				//bs[i][i - 1] = 0;
			}
		}
	}

	//for (i = 1; i <= n; i++) cout << bs[i] << "\n";

	for (i = 1; i <= n; i++) {
		if (used[i]) continue;

		clr(v1);
		clr(v2);

		for (j = 0; j < n; j++) {
			if (bs[i][j] && bs[j + 1][i - 1]) {
				if (used[j + 1]) assert(false);

				used[j + 1] = 1;
				v1.pb(j + 1);
				v2.pb(a[j + 1]);
			}
		}

		/*for (j = 0; j < n; j++) {
			if (bs[i][j] || j + 1 == i) {
				v1.pb(j + 1);
				v2.pb(a[j + 1]);
				used[j + 1]++;
			}
		}*/

		sort(all(v2));

		for (j = 0; j < sz(v1); j++) ans[v1[j]] = v2[j];
	}

	for (i = 1; i <= n; i++) cout << ans[i] << ' ';
	cout << "\n";

	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests, tc;
	cin >> tests;

	for (tc = 1; tc <= tests; tc++) {
		solve();
	}

	return 0;
}