#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <cassert>
#include <assert.h>
#include <stack>
#include <bitset>
using namespace std;

typedef long long ll;

#define ff first
#define ss second
#define pr pair
#define mpr make_pair
#define pb push_back
#define sz(x) (int((x).size()))
#define clr(x) (x).clear()
#define all(x) (x).begin(), (x).end()

bool is_prime(ll x)
{
	if (x == 1) return false;

	for (ll i = 2; i * i <= x; i++) if (x % i == 0) return false;

	return true;
}

// ------------------------------------------------- //

ll MX = 1000000002;

const int N = 1005;
ll a[N], ans[N], ans0[N];
int n, k, x;

bitset<N> bs[N];

set<ll> st;

bool used[N];

vector<int> v1;
vector<ll> v2;

void solve1()
{
	int i, j;

	for (i = 1; i <= n; i++) {
		bs[i].set();
		used[i] = 0;
	}

	bitset<N> b0;

	ll p;

	for (auto q : st) {
		p = q;
		while (1) {
			if (p > MX) break;

			b0.reset();
			for (i = 1; i <= n; i++) if (a[i] % p == 0) b0[i - 1] = 1;

			if (b0.count() < k) break;

			for (i = 1; i <= n; i++) if (a[i] % p == 0) bs[i] &= b0;

			p *= q;
		}
	}
	if (x > 1) {
		p = x;
		while (1) {
			if (p > MX) break;

			b0.reset();
			for (i = 1; i <= n; i++) if (a[i] % p == 0) b0[i - 1] = 1;

			if (b0.count() < k) break;

			for (i = 1; i <= n; i++) if (a[i] % p == 0) bs[i] &= b0;

			p *= x;
		}
	}


	for (i = 1; i <= n; i++) {
		if (used[i]) continue;

		clr(v1);
		clr(v2);

		for (j = 0; j < n; j++) {
			if (bs[i][j] && bs[j + 1][i - 1]) {
				if (used[j + 1]) assert(false);

				used[j + 1] = 1;
				v1.pb(j + 1);
				v2.pb(a[j + 1]);
			}
		}

		sort(all(v2));

		for (j = 0; j < sz(v1); j++) ans[v1[j]] = v2[j];
	}

	return;
}

void solve()
{
	int i, j, o;
	ll e;

	cin >> n >> k >> x;

	clr(st);

	for (i = 1; i <= n; i++) {
		cin >> a[i];
		
		e = a[i];

		for (j = 2; j * j <= e; j++) {
			if (e % j == 0) {
				st.insert(j);

				while (e % j == 0) e /= j;
			}
		}

		if (e > 1) st.insert(e);

		ans0[i] = 0;
	}

	solve1();

	for (i = 1; i <= n; i++) ans0[i] = ans[i];

	for (i = 1; i <= n; i++) {
		a[i] *= x;

		solve1();

		for (j = 1; j <= n; j++) if (ans[j] != ans0[j]) break;

		if (j <= n && ans[j] < ans0[j]) for (o = 1; o <= n; o++) ans0[o] = ans[o];

		a[i] /= x;
	}

	for (i = 1; i <= n; i++) cout << ans0[i] << ' ';
	cout << "\n";

	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests, tc;
	cin >> tests;

	for (tc = 1; tc <= tests; tc++) {
		solve();
	}

	return 0;
}