#include <bits/stdc++.h>
#include "game.h"

using namespace std;

const int MXN = 2e5 + 5;

int n, D;
int a[MXN], used[MXN];
bool dp[MXN];
vector<int> adj[MXN];

void calcdp(int a)
{
    dp[a] = 0;
    for (int v : adj[a])
    {
        dp[a] |= !dp[v];
    }
}

void dfs(int a)
{
    used[a] = 1;
    for (int v : adj[a])
    {
        if (!used[v]) dfs(v);
    }
    calcdp(a);
}

void init(vector<int> A, int d)
{
    n = A.size(), D = d;
    for (int i = 0; i < n; i++)
    {
        used[i] = 0;
        dp[i] = 0;
        adj[i].clear();
    }
    for (int i = 0; i < n; i++) a[i] = A[i];
    for (int i = 0; i < n; i++)
    {
        for (int j = max(0, i - D); j < n && j <= i + D; j++)
        {
            if (a[j] > a[i]) adj[i].push_back(j);
        }
    }
    for (int i = 0; i < n; i++) 
    {
        if (!used[i]) dfs(i);
    }
}

void updateValue(int i, int val)
{
    a[i] = val;
    for (int i = 0; i < n; i++)
    {
        used[i] = 0;
        dp[i] = 0;
        adj[i].clear();
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = max(0, i - D); j < n && j <= i + D; j++)
        {
            if (a[j] > a[i]) adj[i].push_back(j);
        }
    }
    for (int i = 0; i < n; i++) 
    {
        if (!used[i]) dfs(i);
    }
}

bool isWinning(int i)
{
    return dp[i];
}