#include <iostream>
#include <vector>
#include <queue>
#include <climits>
#include "game.h"

#define fastio base::sync_with_stdio(false); cin.tie(NULL);

using namespace std;

vector<int> a, localMaxima, greaterLeft, greaterRight, localMaximaLeft, localMaximaRight;
int n, D;

void calculate() {
    int mal, mar;
    localMaxima.push_back(INT_MIN);
    for(int i = 0; i < n; i++) {
        mal = i, mar = i;
        for(int j = i - 1; j >= max(0, i - D); j--) {
            if(a[j] > a[mal]) {
                mal = j;
                break;
            }
        }
        for(int j = i + 1; j < min(i + D + 1, n); j++) {
            if(a[j] > a[mar]) {
                mar = j;
                break;
            }
        }
        if(mal == i && mar == i) localMaxima.push_back(i);
        else {
            if(mal != i) greaterLeft[i] = mal;
            if(mar != i) greaterRight[i] = mar;
        }
        localMaximaLeft[i] = localMaxima[localMaxima.size() - 1];
    }
    localMaxima.push_back(INT_MAX);
    int p = localMaxima.size() - 1;
    for(int i = n - 1; i > -1; i--) {
        if(localMaxima[p - 1] == i) p--;
        localMaximaRight[i] = localMaxima[p];
    }
}
int dist(int i, int j, int t, int d) {
    if(j < 0 || j > n - 1 || i == j) return d;
    if(t == 0) return dist(greaterLeft[i], j, t, d + 1);
    return dist(greaterRight[i], j, t, d + 1);
}

void init(vector<int> ai, int di) {
    a = ai, D = di, n = ai.size();
    greaterLeft = vector<int>(n, INT_MIN), greaterRight = vector<int>(n, INT_MAX), localMaximaLeft = vector<int>(n, INT_MIN), localMaximaRight = vector<int>(n, INT_MAX);
    calculate();
}
void updateValue(int i, int v) {

}
bool isWinning(int i) {
    int L = localMaximaLeft[i], R = localMaximaRight[i], distL = dist(i, L, 0, 0), distR = dist(i, R, 1, 0);
    //cout << L << " " << R << " " << distL << " " << distR << "\n";
    if(i - D <= L || i + D >= R || (L > -1 && distL % 2 == 1) || (R < n && distR % 2 == 1)) return true;
    return false;
}
