#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
#include "game.h"

using namespace std;

vector<int> a, seggy, nah;
vector<bool> res;
vector<pair<int,int>> ma;
int n, d;

void update(int i, int l, int r, int ql, int qr) {
    if(l > qr || r < ql) return;
    if(ql <= l && r <= qr) {
        seggy[i] = 1;
        return;
    }
    update(2 * i, l, (l + r) / 2, ql, qr);
    update(2 * i + 1, (l + r) / 2 + 1, r, ql, qr);
    //cout << l << " " << r << " " << seggy[i] << "\n";
}
int query(int i, int l, int r, int qi, int val) {
    val |= seggy[i];
    //cout << i << " " << l << " " << r << " " << qi << " " << val << " " << seggy[i] << "\n";
    if(l > qi || r < qi) return 0;
    if(l == r) return val;
    int a = query(2 * i, l, (l + r) / 2, qi, val), b = query(2 * i + 1, (l + r) / 2 + 1, r, qi, val);
    //cout << a << " " << b << " " << l << " " << r << "kk\n";
    return val | (a | b);
}
void propagate(int i, int l, int r, int val) {
    //cout << l << " " << r << "\n";
    val |= seggy[i];
    if(l == r) {
        res[l] = val;
        return;
    }
    propagate(2 * i, l, (l + r) / 2, val);
    propagate(2 * i + 1, (l + r) / 2 + 1, r, val);
}

bool srt(pair<int,int> a, pair<int,int> b) {
    return a.second > b.second;
}
void start() {
    ma = vector<pair<int,int>>(n), seggy = vector<int>(4*n, 0), res = vector<bool>(n), nah = vector<int>(n);
    for(int i = 0; i < n; i++) ma[i] = {i, a[i]};
    sort(ma.begin(), ma.end(), srt);
    //
    for(int i = 0; i < n; i++) {
        if(query(1, 0, n - 1, ma[i].first, 0)) continue;
        update(1, 0, n - 1, max(0, ma[i].first - d), min(n - 1, ma[i].first + d));
        //update(1, 0, n - 1, ma[i].first, ma[i].first, 0);
        nah[ma[i].first] = 1;
    }
    propagate(1, 0, n - 1, 0);
}
void init(std::vector<int> A, int D) {
    a = A, d = D, n = A.size();
    start();
}
void updateValue(int index, int newValue) {
    a[index] = newValue;
    start();
}
bool isWinning(int startIndex) {
    return (res[startIndex] && !nah[startIndex]);
}