#include "game.h"
#include "Lgrader.cpp"

int d;

std::vector<int> v;
std::vector<bool> fw;

struct Node{
    Node(int l, int r){
        llim=l;
        rlim=r;
        if(l==r){
            val=l;
            lchild=NULL;
            rchild=NULL;
            return;
        }
        lchild=new Node(l, (l+r)/2);
        rchild=new Node((l+r)/2+1, r);
        if(v[lchild->val]>v[rchild->val]){
            val=lchild->val;
        }else{
            val=rchild->val;
        }
    }
    int llim;
    int rlim;
    Node* lchild;
    Node* rchild;
    int val;
    void update(int i, int x){
        if(i<llim || i>rlim){
            return;
        }
        if(lchild==NULL){
            v[i]=x;
            return;
        }
        lchild->update(i, x);
        rchild->update(i, x);
        if(v[lchild->val]>v[rchild->val]){
            val=lchild->val;
        }else{
            val=rchild->val;
        }
    }
    int query(int l, int r){
        if(l==llim && r==rlim){
            return val;
        }
        if(l>lchild->rlim){
            return rchild->query(l, r);
        }
        if(r<rchild->llim){
            return lchild->query(l, r);
        }
        int lquery=lchild->query(l, r);
        int rquery=rchild->query(l, r);
        if(v[lquery]>v[rquery]){
            return lquery;
        }
        return rquery;
    }
};

Node* root=NULL;

void updateArray(int l, int r){
    if(l>r){
        return;
    }
    int mx=root->query(l, r);
    for(int i=mx+1; i<=mx+d && i<=r; i++){
        fw[i]=false;
    }
    for(int i=mx-1; i>=mx-d && i>=l; i--){
        fw[i]=false;
    }
    fw[mx]=true;
    updateArray(l, mx-d-1);
    updateArray(mx+d+1, r);
}

void init(std::vector<int> A, int D){
    v=A;
    d=D;
    root=new Node(0, A.size()-1);
    fw.reserve(v.size());
    updateArray(0, v.size()-1);
}

void updateValue(int index, int newValue){
    root->update(index, newValue);
    updateArray(0, v.size()-1);
}

bool isWinning(int startIndex){
    return !fw[startIndex];
}
