#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <cassert>
#include <chrono>
#include <queue>
#include <deque>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define lb lower_bound
#define ub upper bound

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<char> vc;
typedef vector<vc> vvc;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}

const int INF = 1e18, MAXN = 5e5 + 10;

vector<int> g[MAXN];
int p[MAXN];

void dfs(int v) {
	for (auto u : g[v]) {
		if (u == p[v])
			continue;
		p[u] = v;
		dfs(u);
	}
}

map<int, int> dp[MAXN];
vi d;

void dfs2(int v) {
	for (auto u : g[v]) {
		if (u == p[v])
			continue;
		dfs2(u);
	}
	if (v != 1) {
		int mx = 0;
		for (auto u : g[v]) {
			if (u == p[v])
				continue;
			if (!mx || dp[mx].size() < dp[u].size())
				mx = u;
		}
		dp[v].swap(dp[mx]);
		for (auto u : g[v]) {
			if (u == p[v] || u == mx)
				continue;
			for (auto [x, y] : dp[u])
				dp[v][x] += y;
		}
		dp[v][d[v]]++;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;
	d.assign(n + 1, INF);
	for (int i = 1; i <= n; ++i) {
		int k;
		cin >> k;
		while (k--) {
			int u;
			cin >> u;
			g[i].push_back(u);
		}
	}
	vi a(m);
	input(a);
	dfs(1);
	vvpi g2(n + 1);
	for (int i = 1; i <= n; ++i) {
		int w = 0;
		for (auto u : g[i]) {
			if (u == p[i]) {
				w = 1;
				continue;
			}
			g2[i].push_back({ u, w });
		}
	}
	deque<int> q;
	d[1] = 0;
	q.push_back(1);
	while (q.size()) {
		int v = q.front();
		q.pop_front();
		for (auto [u, w] : g2[v]) {
			if (minravno(d[u], d[v] + w)) {
				if (w)
					q.push_back(u);
				else
					q.push_front(u);
			}
		}
	}
	if (m == 1) {
		cout << 1;
		return 0;
	}
	dfs2(1);
	vi p(m - 1);
	for (int v = 1; v <= n; ++v) {
		if (d[v] < m - 1)
			p[d[v]]++;
	}
	int now = 1;
	int ans = 1;
	for (int i = 0; i < m - 1; ++i) {
		if (now + g[1].size() <= m) {
			now += g[1].size();
			if (i > 0)
				p[i] += p[i - 1];
			ans += (p[i] - 1) * 2;
		}
		else {
			if (now == m)
				break;
			for (auto u : g[1]) {
				for (auto [x, y] : dp[u])
					if (x <= i)
						ans += y * 2;
				now += 1;
				if (now == m)
					break;
			}
		}
	}
	cout << ans;
	return 0;
}