#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <cassert>
#include <chrono>
#include <queue>
#include "game.h"

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define lb lower_bound
#define ub upper bound

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<char> vc;
typedef vector<vc> vvc;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}

//const int INF = 1e18;

int n, d;
vi a;
vb dp;
vvi build(vi a) {
	vvi g(n);
	for (int i = 0; i < n; ++i) {
		for (int j = max(0, i - d); j <= min(n - 1, i + d); ++j) {
			if (i == j)
				continue;
			if (a[j] > a[i])
				g[i].push_back(j);
		}
	}
	return g;
}

void dfs(vb& used, vb& dp, vvi& g, int v) {
	used[v] = true;
	for (auto u : g[v]) {
		if (!used[u])
			dfs(used, dp, g, u);
		if (!dp[u])
			dp[v] = true;
	}
}

vb solve(vvi g) {
	vb used(n, false), dp(n, false);
	for (int i = 0; i < n; ++i)
		if (!used[i])
			dfs(used, dp, g, i);
	return dp;
}

void init(vi a1, int d1) {
	a = a1;
	d = d1;
	n = a.size();
	dp = solve(build(a));
}

void updateValue(int ind, int val) {
	a[ind] = val;
	dp = solve(build(a));
}

bool isWinning(int ind) {
	return dp[ind];
}