#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <cassert>
#include <chrono>
#include <queue>

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define lb lower_bound
#define ub upper bound

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<char> vc;
typedef vector<vc> vvc;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}

//const int INF = 1e18;

int gcd(int a, int b) {
	return (b == 0 ? a : gcd(b, a % b));
}

bool check(int n, int k, vi a, vi b) {
	bool flag = true;
	for (int mask = 0; mask < (1 << n); ++mask) {
		int sz = 0;
		for (int i = 0; i < n; ++i)
			if (mask >> i & 1)
				sz++;
		if (sz != k)
			continue;
		int g1 = 0, g2 = 0;
		for (int i = 0; i < n; ++i) {
			if (mask >> i & 1) {
				g1 = gcd(g1, a[i]);
				g2 = gcd(g2, b[i]);
			}
		}
		flag &= g1 == g2;
	}
	return flag;
}

vi solve1(int n, int k, vi a) {
	vi b = a;
	sort(all(a));
	do {
		if (check(n, k, a, b))
			return a;
	} while (next_permutation(all(a)));
}

void solve() {
	int n, k, x;
	cin >> n >> k >> x;
	vi a(n);
	input(a);
	vi best = a;
	minravno(best, solve1(n, k, a));
	for (int i = 0; i < n; ++i) {
		a[i] *= x;
		minravno(best, solve1(n, k, a));
		a[i] /= x;
	}
	print(best);
	cout << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}