#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve(int n, int m, vector<vector<int>> adj, vector<int> friends) {
    if (n == 1) {
        return;
    }
    auto stupid = [&]() -> int {
        int j = 0, x = 0, ans = 0;
        vector<int> pnt(n);
        while (true) {
            ans += 1;
            if (x == friends[j]) {
                j += 1;
            }
            if (j == m) {
                break;
            }
            int to = adj[x][pnt[x]++];
            if (pnt[x] == size(adj[x])) {
                pnt[x] = 0;
            }
            x = to;
        }
        return ans;
    };

    int should = stupid();

    vector<int> parent(n);
    vector<pair<int, int>> ord;
    auto dfs = [&](auto self, int v, int it) -> void {
        ord.push_back({v, it});
        int f = find(adj[v].begin(), adj[v].end(), parent[v]) - adj[v].begin();
        for (int i = f + 1; i < size(adj[v]); ++i) {
            parent[adj[v][i]] = v;
            self(self, adj[v][i], it + 1);
            ord.push_back({v, it + 1});
        }
        for (int i = 0; i < f; ++i) {
            parent[adj[v][i]] = v;
            self(self, adj[v][i], it);
            if (v > 0 || i + 1 < f) {
                ord.push_back({v, it});
            }
        }
    };
    dfs(dfs, 0, 0);

    int i = 0;
    int ans = 0;
    for (int j = 0, cnt = 0; j < m; ++j) {
        while (!(ord[i].first == friends[j] && ord[i].second <= cnt)) {
            if (ord[i].second <= cnt) {
                ans += 1;
            }
            i += 1;
            if (i == size(ord)) {
                cnt += 1;
                i = 0;
            }
        }
        ans += 1;
        i += 1;
        if (i == size(ord)) {
            i = 0;
        }
    }

    int got = ans;
    if (should != got) {
        cout << "Found!\n";
        cout << n << " " << m << '\n';
        for (int i = 0; i < n; ++i) {
            cout << size(adj[i]) << " ";
            for (int x : adj[i]) {
                cout << x + 1 << " ";
            }
            cout << '\n';
        }
        for (int x : friends) {
            cout << x + 1 << " ";
        }
        cout << endl;
        cout << "need: " << should << endl << "got: " << ans << endl;
        exit(0);
    }
}

void stress() {
    mt19937 rnd(1);
    while (true) {
        int n = rnd() % 5 + 1;
        int m = rnd() % 5 + 1;
        vector<vector<int>> adj(n);
        for (int i = 1; i < n; ++i) {
            int fa = rnd() % i;
            adj[fa].push_back(i);
            adj[i].push_back(fa);
        }
        vector<int> friends(m);
        for (int &x : friends) {
            x = rnd() % n;
        }
        for (int i = 0; i < n; ++i) {
            std::shuffle(adj[i].begin(), adj[i].end(), rnd);
        }
        solve(n, m, adj, friends);
        static int cnt = 0;
        if (++cnt % 1 == 0) {
            cout << "OK: " << cnt << endl;
        }
    }
}

struct Fenwick {
    vector<int> t;

    void init(int n) {
        t.assign(n + 1, 0);
    }

    void add(int i) {
        for (++i; i < size(t); i += i & -i) {
            t[i] += 1;
        }
    }

    int sum(int x) {
        int ans = 0;
        for (++x; x > 0; x -= x & -x) {
            ans += t[x];
        }
        return ans;
    }

    int rangeSum(int l, int r) {
        return sum(r - 1) - sum(l - 1);
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

//    stress();
//    return 0;

    int n, m;
    cin >> n >> m;

    vector<vector<int>> adj(n);
    vector<int> parent(n), friends(m);
    int sum = 0;

    for (int i = 0; i < n; ++i) {
        int s;
        cin >> s;
        sum += s;
        adj[i].resize(s);
        for (int &to : adj[i]) {
            cin >> to;
            --to;
        }
    }

    assert(sum == 2 * (n - 1));

    for (int &x : friends) {
        cin >> x;
        --x;
    }

    vector<pair<int, int>> ord;
    auto dfs = [&](auto self, int v, int it) -> void {
        ord.push_back({v, it});
        int f = find(adj[v].begin(), adj[v].end(), parent[v]) - adj[v].begin();
        for (int i = f + 1; i < size(adj[v]); ++i) {
            parent[adj[v][i]] = v;
            self(self, adj[v][i], it + 1);
            ord.push_back({v, it + 1});
        }
        for (int i = 0; i < f; ++i) {
            parent[adj[v][i]] = v;
            self(self, adj[v][i], it);
            if (v > 0 || i + 1 < f) {
                ord.push_back({v, it});
            }
        }
    };
    dfs(dfs, 0, 0);

    vector<int> o(size(ord));
    iota(o.begin(), o.end(), 0);
    sort(o.begin(), o.end(), [&](int i, int j) {
        return pair(ord[i].second, i) < pair(ord[j].second, j);
    });

    vector<set<int>> alive(n);
    Fenwick fn;
    fn.init(size(ord));

    int i = 0;
    ll ans = 0;
    for (int j = 0, cnt = -1, p = 0; j < m; ++j) {
        int x = friends[j];
        auto nxt = [&]() {
            i = 0;
            cnt += 1;
            while (p < size(o) && ord[o[p]].second == cnt) {
                fn.add(o[p]);
                alive[ord[o[p]].first].insert(o[p]);
                p += 1;
            }
        };
        while (true) {
            auto it = alive[x].lower_bound(i);
            if (it == alive[x].end()) {
                ans += fn.rangeSum(i, size(ord));
                nxt();
            } else {
                ans += fn.rangeSum(i, *it + 1);
                i = *it + 1;
                if (i == size(ord)) {
                    nxt();
                }
                break;
            }
        }
    }

    cout << ans << '\n';

    return 0;
}