#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using u64 = unsigned long long;

void solve() {
    int n, k, X;
    cin >> n >> k >> X;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<vector<int>> divs(n);
    unordered_map<int, int> mp;
    for (int i = 0; i < n; ++i) {
        int x = a[i];
        for (int d = 1; d * d <= x; ++d) {
            if (x % d == 0) {
                if (d > 1) {
                    divs[i].push_back(d);
                    mp[d] += 1;
                }
                if (d * d < x) {
                    divs[i].push_back(x / d);
                    mp[x / d] += 1;
                }
            }
        }
    }

    vector<int> good;
    for (auto [x, y]: mp) {
        if (y >= k) {
            good.push_back(x);
        }
    }

    mt19937_64 rnd64(228);
    vector<u64> hash_id(size(good));
    for (int i = 0; i < size(hash_id); ++i) {
        hash_id[i] = rnd64();
    }
    vector<u64> h(n);
    for (int i = 0; i < n; ++i) {
        for (int d : divs[i]) {
            auto it = std::lower_bound(good.begin(), good.end(), d);
            if (it != good.end() && *it == d) {
                h[i] += hash_id[it - good.begin()];
            }
        }
    }

    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return pair(h[i], i) < pair(h[j], j);
    });
    vector<int> answer(n);
    for (int i = 0, j = 0; i < n; i = j) {
        vector<int> cur;
        while (j < n && h[ord[i]] == h[ord[j]]) {
            cur.push_back(ord[j++]);
        }
        vector<int> s = cur;
        sort(s.begin(), s.end(), [&](int x, int y) {
            return a[x] < a[y];
        });
        for (int t = 0; t < j - i; ++t) {
            answer[cur[t]] = a[s[t]];
        }
    }

    for (int x: answer) {
        cout << x << " ";
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}