#include <bits/stdc++.h>
using namespace std;

const int maxn = 5e5;
vector<int> g[maxn], order;
long long days;
int curPos;

void dfs(int v, int p) {
    if (p != -1) {
        ++days;
        if (order[curPos] == v) {
            ++curPos;
            if (curPos == (int)order.size()) {
                return;
            }
        }
    }
    int breakpos = (int)g[v].size() - 1;
    for (int i = 0; i < (int)g[v].size(); ++i) {
        int u = g[v][i];
        if (u != p) {
            dfs(u, v);
            if (curPos == (int)order.size()) {
                return;
            }
            ++days;
            if (order[curPos] == v) {
                ++curPos;
                if (curPos == (int)order.size()) {
                    return;
                }
            }
        } else {
            breakpos = i;
            break;
        }
    }
    if (breakpos != (int)g[v].size() - 1) {
        rotate(g[v].begin(), g[v].begin() + breakpos + 1, g[v].end());
    }
}

vector<int> byVertex[maxn], euler;

void dfsEuler(int v, int p) {
    byVertex[v].emplace_back(euler.size());
    euler.emplace_back(v);
    for (const int& u : g[v]) {
        if (u != p) {
            dfsEuler(u, v);
            byVertex[v].emplace_back(euler.size());
            euler.emplace_back(v);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        g[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> g[i][j];
            --g[i][j];
        }
    }
    order.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> order[i];
        --order[i];
    }
    curPos = (order[0] == 0);
    days = 1;
    for (int iter = 0; iter < n && curPos < m; ++iter) {
        dfs(0, -1);
    }
    if (curPos < m) {
        dfsEuler(0, -1);
        int posEuler = 0;
        while (curPos < m) {
            int v = order[curPos];
            if (byVertex[v].back() > posEuler) {
                int nxt = *upper_bound(byVertex[v].begin(), byVertex[v].end(), posEuler);
                days += nxt - posEuler;
                posEuler = nxt;
            } else {
                int nxt = byVertex[v][0];
                days += (int)euler.size() + nxt - posEuler;
                posEuler = nxt;
            }
            ++curPos;
        }
    }
    cout << days << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cerr << "-------------\n";
        cout << "-------------\n";
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif
    
    return 0;
}
