#include <bits/stdc++.h>
#include "game.h"
using namespace std;

vector<int> a, order, posOf;
vector<bool> isWin;
int n, d;

void build() {
    for (const int& i : order) {
        int l = max(0, i - d), r = min(n - 1, i + d);
        isWin[i] = false;
        for (int j = l; j <= r; ++j) {
            if (a[j] > a[i] && !isWin[j]) {
                isWin[i] = true;
                break;
            }
        }
    }
}

void init(vector<int> A, int D) {
    a = A, d = D;
    n = a.size();
    isWin.resize(n);
    order.resize(n);
    iota(order.begin(), order.end(), 0);
    sort(order.begin(), order.end(), [&](const int& i, const int& j) {
        return a[i] > a[j];
    });
    posOf.resize(n);
    for (int i = 0; i < n; ++i) {
        posOf[order[i]] = i;
    }
    build();
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    int i = posOf[index];
    while (i > 0 && a[order[i - 1]] < newValue) {
        swap(order[i], order[i - 1]);
        swap(posOf[order[i]], posOf[order[i - 1]]);
    }
    while (i < n - 1 && a[order[i + 1]] > newValue) {
        swap(order[i], order[i + 1]);
        swap(posOf[order[i]], posOf[order[i + 1]]);
    }
    build();
}

bool isWinning(int startIndex) {
    return isWin[startIndex];
}

/*
void solve() {
    
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cerr << "-------------\n";
        cout << "-------------\n";
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif
    
    return 0;
}
*/
