#include<iostream>
#include<deque>
#include<algorithm>
#include<vector>
#include<map>
#include<random>
#include<time.h>
#include<cassert>
#include<chrono>
#include<set>
#include<unordered_set>
#include<array>
 
using namespace std;
 
#define ull unsigned long long
#define pb push_back
#define ld long double
#define ll long long
#define all(a) a.begin(), a.end()
 
mt19937_64 rnd(51);

bool check(int n, vector<int> a, vector<int> c, int k) {
  for (int mask = 0; mask < (1 << n); mask++) {
    if (__builtin_popcount(mask) == k) {
      int g1 = 0, g2 = 0;
      for (int b = 0; b < n; b++) {
        if (mask & (1 << b)) {
          g1 = gcd(g1, a[b]);
          g2 = gcd(g2, c[b]);
        }
      }
      if (g1 != g2) return 0;
    }
  }
  return 1;
}

vector<int> prime{2, 3, 5, 7, 11, 13, 17};

int binpow(ll a, int n) {
  int res = 1;
  while (n) {
    if (n & 1) {
      res *= a;
    }
    a *= a;
    n /= 2;
  }
  return res;
}

vector<int> solve2(int n, int k, int x, vector<int> a) {
  int res = 1;
  map<int, vector<pair<int, int>>> kek;
  vector<int> a_copy = a;
  for (int i = 0; i < n; i++) {
    int p = 2;
    while (1ll * p * p <= a[i]) {
      if (a[i] % p == 0) {
        int cnt = 0;
        while (a[i] % p == 0) {
          a[i] /= p;
          cnt++;
        }
        kek[p].pb({cnt, i});
      }
      p++;
    }
    if (a[i] > 1) {
      kek[a[i]].pb({1, i});
    }
  }
  for (int i = 0; i < n; i++) {
    a[i] = a_copy[i];
  }
  map<int, int> good;
  for (auto [p, arr] : kek) {
    sort(all(arr));
    reverse(all(arr));
    int target = 0;
    if (arr.size() >= k) {
      target = arr[k - 1].first;
    }
    for (auto [val, i] : arr) {
      if (val >= target) {
        a[i] /= binpow(p, val - target);
      } else {
        if (p == x) {
          good[i] = 1;
        } else {
          break;
        }
      }
    }
    if (p == x) {
      for (int j = 0; j < n; j++) {
        if (a_copy[j] % p != 0) {
          good[j] = 1;
        }
      }
    }
  }
  map<int, multiset<int>> mp;
  for (int i = 0; i < n; i++) {
    mp[a[i]].insert(a_copy[i]);
  }
  vector<int> b;
  int was = 0;
  for (int i = 0; i < n; i++) {
    if (mp[a[i]].size() == 0) {
      assert(was == 1);
      a[i] /= x;
    } else {
      int val = *mp[a[i]].begin();
      if (good[i] && was == 0) {
        if (mp[a[i] * x].size() > 0 && *mp[a[i] * x].begin() < val) {
          was = 1;
          a[i] *= x;
        }
      } else if (was == 1) {
        if (val > *mp[a[i] / x].begin()) {
          a[i] /= x;
          was = 2;
        }
      }
    }
    b.pb(*mp[a[i]].begin());
    mp[a[i]].erase(mp[a[i]].find(b.back()));
  }
  return b;
}

vector<int> solve(int n, int k, vector<int> a) {
  vector<int> b = a;
  sort(all(b));
  do {
    if (check(n, a, b, k)) {
      return b;
    }
  } while (next_permutation(all(b)));
  return vector<int>{};
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif // LOCAL
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  while (0) {
    int n = rnd() % 7 + 1;
    int k = rnd() % n + 1;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
      a[i] = rnd() % 30 + 1;
    }
    auto res1 = solve(n, k, a), res2 = solve2(n, k, 1, a);
    if (res1 != res2) {
      cout << n << ' ' << k << endl;
      for (int i : a) {
        cout << i << ' ';
      }
      cout << endl;
      for (int i : res1) {
        cout << i << ' ';
      }
      cout << endl;
      for (int i : res2) {
        cout << i << ' ';
      }
      cout << endl;
      return 0;
    }
    cout << "Ok" << endl;
  }
  int t;
  cin >> t;
  while (t--) {
    int n, k, x;
    cin >> n >> k >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
      cin >> a[i];
    }
    vector<int> b = solve2(n, k, x, a);
    for (int i : b) {
      cout << i << ' ';
    }
    cout << endl;
  }
  return 0; 
}