#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <iomanip>
#include <time.h>
#include <cstring>
#include <map>
#include <unordered_set>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>
#include <sstream>

#include "game.h"
//#include "Lgrader.cpp"

using namespace std;

typedef long long ll;
typedef long double ld;

struct Elem
{
    int x;
    int ind;

    bool operator<(const Elem& e) const
    {
        if (x == e.x)
            return ind > e.ind;
        return x > e.x;
    }
};

vector<int> a;
vector<bool> win;
vector<bool> visited;
int d = 0;

void compute()
{
    visited.assign(a.size(), false);
    win.assign(a.size(), false);
    vector<Elem> elems(a.size());
    for (int i = 0; i < a.size(); ++i)
    {
        elems[i].x = a[i];
        elems[i].ind = i;
    }
    sort(elems.begin(), elems.end());
    for (int i = 0; i < elems.size(); ++i)
    {
        if (visited[elems[i].ind])
            continue;
        win[elems[i].ind] = true;
        visited[elems[i].ind] = true;
        for (int j = elems[i].ind - 1; j >= max(0, elems[i].ind - d); --j)
        {
            if (visited[j])
                break;
            win[j] = false;
            visited[j] = true;
        }
        for (int j = elems[i].ind + 1; j <= min((int) a.size() - 1, elems[i].ind + d); ++j)
        {
            if (visited[j])
                break;
            win[j] = false;
            visited[j] = true;
        }
    }
}

void init(vector<int> A, int D)
{
    a = A;
    d = D;
    win.resize(a.size());
    visited.resize(a.size());
    compute();
}

void updateValue(int index, int newValue)
{
    a[index] = newValue;
    compute();
}

bool isWinning(int startIndex)
{
    return !win[startIndex];
}
