﻿#include <bits/stdc++.h>
#ifndef LOCAL
#include "game.h"
#endif
#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = int(1e9) + 7;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
const int N = 2e5 + 1;
int a[N];
int n, d;
int cnt_good = 0;
bool good(int i) {
    for (int j = max(0, i - d); j < i; j++) {
        if (a[i] < a[j]) return false;
    }
    for (int j = i + 1; j <= min(n - 1, i + d); j++) {
        if (a[i] < a[j]) return false;
    }
    return true;
}
bool win[N];
void build() {
    vector<int> cnt(n);
    queue<int> q;
    vector<bool> us(n);
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        for (int j = max(0, i - d); j < i; j++) {
            if (a[i] < a[j]) cnt[i]++;
        }
        for (int j = i + 1; j <= min(n - 1, i + d); j++) {
            if (a[i] < a[j]) cnt[i]++;
        }
        if (cnt[i] == 0) {
            us[i] = true;
            win[i] = false;
            q.push(i);
        }
    }
    while (!q.empty()) {
        int i = q.front(); q.pop();
        for (int j = max(0, i - d); j < i; j++) {
            if (!win[i]) {
                us[j] = true;
                q.push(j);
                win[j] = true;
            }
            if (a[i] > a[j]) {
                cnt[j]--;
                if (!us[j] && cnt[j] == 0) {
                    win[j] = false;
                    us[j] = true;
                    q.push(j);
                }
            }
        }
        for (int j = i + 1; j <= min(n - 1, i + d); j++) {
            if (!win[i]) {
                us[j] = true;
                q.push(j);
                win[j] = true;
            }
            if (a[i] > a[j]) {
                cnt[j]--;
                if (!us[j] && cnt[j] == 0) {
                    win[j] = false;
                    us[j] = true;
                    q.push(j);
                }
            }
        }
    }
}
void init(vector<int> A, int D) {
    n = A.size();
    d = D;
    for (int i = 0; i < n; i++) a[i] = A[i];
    build();
}
void updateValue(int pos, int val) {
    a[pos] = val;
    build();
}
bool isWinning(int pos) {
    return win[pos];
}
#ifdef LOCAL
void solve_case() {
    init({1, 7, 4, 9, 30, 2}, 2);
    cout << isWinning(0) << "\n";
    cout << isWinning(1) << "\n";
    updateValue(4, 8);
    cout << isWinning(0) << "\n";
    cout << isWinning(1) << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
#endif