﻿#include <bits/stdc++.h>
#ifndef LOCAL
#include "game.h"
#endif
#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = int(1e9) + 7;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
const int N = 2e5 + 1;
int a[N];
int n, d;
int cnt_good = 0;
bool good(int i) {
    for (int j = max(0, i - d); j < i; j++) {
        if (a[i] < a[j]) return false;
    }
    for (int j = i + 1; j <= min(n - 1, i + d); j++) {
        if (a[i] < a[j]) return false;
    }
    return true;
}
bool wl[N], wr[N];
void build() {
    vector<int> ord(n);
    vector<int> l(n, -1), r(n, n);
    int mx = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] > a[mx]) mx = i;
        wl[i] = wr[i] = false;
        for (int j = max(0, i - d); j < i; j++) {
            if (a[i] < a[j]) {
                l[i] = j;
            }
        }
        for (int j = i + 1; j <= min(n - 1, i + d); j++) {
            if (a[i] < a[j]) {
                r[i] = j;
                break;
            }
        }
    }
    for (int i = mx + 1; i < n; i++) {
        if (l[i] != -1 && !wl[l[i]]) wl[i] = true;
    }
    for (int i = mx - 1; i >= 0; i--) {
        if (r[i] != n && !wr[r[i]]) wr[i] = true;
    }
}
void init(vector<int> A, int D) {
    n = A.size();
    d = D;
    for (int i = 0; i < n; i++) a[i] = A[i];
    build();
}
void updateValue(int pos, int val) {
    a[pos] = val;
    build();
}
bool isWinning(int pos) {
    return wl[pos] || wr[pos];
}
#ifdef LOCAL
void solve_case() {
    init({1, 7, 4, 9, 30, 2}, 2);
    cout << isWinning(0) << "\n";
    cout << isWinning(1) << "\n";
    updateValue(4, 8);
    cout << isWinning(0) << "\n";
    cout << isWinning(1) << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
#endif