﻿#include <bits/stdc++.h>
#ifndef LOCAL
#include "game.h"
#endif
#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = int(1e9) + 7;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
const int N = 2e5 + 1;
int a[N];
int n, d;
bool good[N];
bool is_good(int i) {
    for (int j = max(0, i - d); j < i; j++) {
        if (a[i] < a[j]) return good[i] = false;
    }
    for (int j = i + 1; j <= min(n - 1, i + d); j++) {
        if (a[i] < a[j]) return good[i] = false;
    }
    return good[i] = true;
}
bool win[N];
void build() {
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int l, int r){
        return a[l] > a[r];
    });
    for (int i : ord) {
        is_good(i);
        win[i] = false;
        for (int j = max(0, i - d); j < i; j++) {
            if (a[i] < a[j] && !win[j]) {
                win[i] = true;
            }
        }
        for (int j = i + 1; j <= min(n - 1, i + d); j++) {
            if (a[i] < a[j] && !win[j]) {
                win[i] = true;
            }
        }
    }
}
void init(vector<int> A, int D) {
    n = A.size();
    d = D;
    for (int i = 0; i < n; i++) a[i] = A[i];
    build();
}
void solve(int l, int r) {
    if (l != 0) {
        while (!good[l]) l++;
    }
    if (r != n - 1) {
        while (!good[r]) r--;
    }
    vector<int> ord(r - l + 1);
    iota(ord.begin(), ord.end(), l);
    sort(ord.begin(), ord.end(), [&](int l, int r){
        return a[l] > a[r];
    });
    for (int i : ord) {
        win[i] = false;
        for (int j = max(l, i - d); j < i; j++) {
            if (a[i] < a[j] && !win[j]) {
                win[i] = true;
            }
        }
        for (int j = i + 1; j <= min(r, i + d); j++) {
            if (a[i] < a[j] && !win[j]) {
                win[i] = true;
            }
        }
    }
}
void updateValue(int pos, int val) {
    a[pos] = val;
    for (int i = max(0, pos - d); i <= min(n - 1, pos + d); i++) is_good(i);
}
bool isWinning(int pos) {
    solve(max(0, pos - 6 * d), min(n - 1, pos + 6 * d));
    return win[pos];
}
#ifdef LOCAL
void solve_case() {
    cin >> n;
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    shuffle(p.begin(), p.end(), rnd);
    init(p, 10);
    for (int i = 0; i < n; i++) {
        isWinning(i);
    }
    updateValue(rnd() % n, n);
    for (int i = 0; i < n; i++) {
        isWinning(i);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
#endif