#pragma once

#include <bits/stdc++.h>

using namespace std;

void init(std::vector<int> A, int D);

void updateValue(int index, int newValue);

bool isWinning(int startIndex);

template<class t>
using vc = std::vector<t>;
typedef long long ll;

int d;
std::vector<int> a;

vc<bool> good;
vc<bool> bad;
int n;

vc<int> len;
vc<bool> ud;
vc<int> jump;

int dfs(int v) {
    if (ud[v]) return len[v];
    ud[v] = true;
    if (jump[v] == v) return len[v] = 0;
    return len[v] = dfs(jump[v]) + 1;
}

void build_good() {
    good.assign(n, 0), bad.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        int mx = -1;
        for (int j = max(0, i - d); j < n && j <= i + d; ++j) {
            mx = max(mx, a[j]);
        }
        if (a[i] == mx) {
            good[i] = true;
            for (int j = max(0, i - d); j < n && j <= i + d; ++j) {
                bad[j] = i != j;
            }
        }
    }
}


void build_jump() {
    jump.resize(n), iota(jump.begin(), jump.end(), 0), len.assign(n, 0);
    ud.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        int mx = -1, p;
        for (int j = max(0, i - d); j < n && j <= i + d; ++j) {
            if (good[j]) {
                jump[i] = j;
                break;
            }
            if (!bad[j] && mx < a[j]) mx = a[j], p = j;
        }
        if (mx == -1) jump[i] = i;
        else jump[i] = p;
    }
    for (int i = 0; i < n; ++i) {
        dfs(i);
    }
}

void init(std::vector<int> A, int D) {
    n = A.size();
    a = A, d = D;
    build_good(), build_jump();
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    build_good(), build_jump();
}

vc<vc<int>> us;
bool calc(int v, int c) {
    if (len[v] % 2) return true;
    if (us[v][c]) return !c;
    us[v][c] = true;
    for (int i = max(v - d, 0); i < n && i <= v + d; ++i) {
        if (i == v) continue;
        if (bad[i]) continue;
        if (!calc(i, c ^ 1)) return true;
    }
    return false;
}

bool isWinning(int startIndex) {
    us.clear();
    us.resize(n, vc<int>(2, 0));
    return calc(startIndex, 0);
}

#ifdef __APPLE__
#include <vector>
#include <iostream>

int main() {
    int n, D, q;

    std::vector<int> nums;

    scanf("%d %d", &n, &D);

    for (int i = 1; i <= n; i++) {
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }

    init(nums, D);

    scanf("%d", &q);

    for (int i = 1; i <= q; i++) {
        int cm;

        scanf("%d", &cm);

        if (cm == 1) {
            int ind, val;

            scanf("%d %d", &ind, &val);

            updateValue(ind, val);
        } else {
            int ind;

            scanf("%d", &ind);

            printf("%d\n", (int) isWinning(ind));
        }
    }

    return 0;
}
#endif