#include<bits/stdc++.h>
using namespace std;

using ll = long long;

struct fenwick {
    int n;
    vector<int> fenw;

    fenwick() = default;
    fenwick(int n) : n(n), fenw(n, 0) {}

    int get(int k) {
        int res = 0;
        for (; k >= 0; k &= k + 1, --k) res += fenw[k];
        return res;
    }

    void add(int k) {
        for (; k < n; k |= k + 1) fenw[k]++;
    }

    int size() {
        return get(n - 1);
    }
};

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        g[i].resize(k);
        for (auto& j : g[i]) cin >> j,--j;
    }
    vector<int> verts(m);
    for (auto& i : verts) cin >> i, --i;
    vector<int> sub(n, -1);
    vector<int> ord(n, -1);
    vector<int> parent(n, -1);
    vector<fenwick> fenw_sub(n);
    vector<int> me_ind(n, -1), par_ind(n, -1);
    {
        int ptr = 0;
        auto dfs = [&](auto dfs, int u, int par) -> void {
            parent[u] = par;
            me_ind[u] = ptr++;
            for (auto to: g[u]) {
                if (to != par) {
                    sub[to] = sub[u];
                    dfs(dfs, to, u);
                }
            }
            if (par != 0) par_ind[u] = ptr++;
        };
        for (auto to: g[0]) {
            sub[to] = to;
            ptr = 0;
            dfs(dfs, to, 0);
            fenw_sub[to] = fenwick(ptr);
        }
        for (int i = 0; i < g[0].size(); ++i) {
            ord[g[0][i]] = i;
        }
    }
    vector<vector<int>> to_visit(n);
    for (auto to : g[0]) {
        to_visit[to].push_back(to);
    }
    vector<set<int>> pos(n);
    int ptr = 0;
    ll ans = 0;
    for (int i = 0; i < m; ) {
        if (verts[i] == 0) i++;
        int root = g[0][ptr];
        vector<int> now = to_visit[root];
        to_visit[root].clear();
        auto add = [&](int k, int u) -> void {
//            cerr << k << ' ' << u << endl;
            pos[u].insert(k);
            fenw_sub[root].add(k);
        };
        for (auto y : now) {
            auto dfs = [&](auto dfs, int u, int par) -> void {
//                cout << u << ' ' << par << endl;
                add(me_ind[u], u);
                if (par != 0) add(par_ind[u], par);
                int k = find(g[u].begin(), g[u].end(), par) - g[u].begin();
                vector<int> now(g[u].begin(), g[u].begin() + k);
                vector<int> nnow(g[u].begin() + k + 1, g[u].end());
                reverse(now.begin(), now.end());
                reverse(nnow.begin(), nnow.end());
                for (auto to : now) {
                    dfs(dfs, to, u);
                }
                for (auto to : nnow) {
                    to_visit[sub[u]].push_back(to);
                }
            };
            dfs(dfs, y, parent[y]);
        }
        int num = -1;
        while (i < m) {
            int x = verts[i];
            auto o = pos[x].upper_bound(num);
            if (o == pos[x].end()) break;
            int k = *o;
//            cout << 11 << ' ' << x << ' ' << k << ' ' << fenw_sub[root].get(k) << endl;
            ans += fenw_sub[root].get(k) - fenw_sub[root].get(num);
            num = k;
            i++;
        }
        if (i < m) {
//            cout << 33 << ' ' << num << ' ' << fenw_sub[root].size() << ' ' << fenw_sub[root].get(num) << endl;
            ans += fenw_sub[root].size() - fenw_sub[root].get(num) + 1;
        }
        ptr++;
        if (ptr == g[0].size()) ptr = 0;
    }
    cout << ans + 1;
}

/*
5 9
2 2 3
1 1
3 1 4 5
1 3
1 3
2 1 1 4 5 2 1 3 4
 */

/*
22 1 1 2
22 2 2 4
22 1 3 6
22 2 5 12
22 1 6 14
22 2 9 16
 */