#include<bits/stdc++.h>
using namespace std;
using ll = long long;

struct DSU {
    vector<int> p;

    DSU() = default;
    DSU(int n) : p(n, 0) {
        iota(p.begin(), p.end(), 0);
    }

    int get(int u) {
        while (u != p[u]) u = p[u] = p[p[u]];
        return u;
    }

    void unite(int u, int v) {
        p[get(u)] = get(v);
    }
};

const int N = 1000;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int tests;
    cin >> tests;
    while (tests--) {
        int n, k, BBB;
        cin >> n >> k >> BBB;
        vector<int> a(n);
        vector<int> primes;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        vector<bitset<N>> dv(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (a[j] % a[i] == 0) dv[i][j] = 1;
            }
        }
        DSU dsu(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if ((dv[i] & dv[j]).count() < k - 1) dsu.unite(i, j);
            }
        }
        vector<vector<int>> ind(n);
        for (int i = 0; i < n; ++i) ind[dsu.get(i)].push_back(i);
        vector<int> res(n);
        for (int i = 0; i < n; ++i) {
//            cout << i << endl;
//            for (auto x : ind[i]) cout << x << ' ';
//            cout << endl;
            vector<int> vals;
            for (auto j : ind[i]) vals.push_back(a[j]);
            sort(vals.begin(), vals.end());
            for (int j = 0; j < ind[i].size(); ++j) res[ind[i][j]] = vals[j];
        }
        for (auto i : res) cout << i << ' ';
        cout << '\n';
    }
}