#include<bits/stdc++.h>
using namespace std;
using ll = long long;

struct DSU {
    vector<int> p;

    DSU() = default;
    DSU(int n) : p(n, 0) {
        iota(p.begin(), p.end(), 0);
    }

    int get(int u) {
        while (u != p[u]) u = p[u] = p[p[u]];
        return u;
    }

    void unite(int u, int v) {
        p[get(u)] = get(v);
    }
};

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int tests;
    cin >> tests;
    while (tests--) {
        int n, k, BBB;
        cin >> n >> k >> BBB;
        vector<int> a(n);
        vector<int> primes;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            int b = a[i];
            for (int x = 2; x * x <= b; ++x) {
                if (b % x == 0) {
                    primes.push_back(x);
                    while (b % x == 0) b /= x;
                }
            }
            if (b > 1) primes.push_back(b);
        }
        auto a_ = a;
        sort(primes.begin(), primes.end());
        primes.resize(unique(primes.begin(), primes.end()) - primes.begin());
        vector<vector<int>> ok(n, vector<int>(n));
        for (auto p : primes) {
            vector<int> d(n);
            for (int i = 0; i < n; ++i) {
                while (a[i] % p == 0) {
                    d[i]++;
                    a[i] /= p;
                }
            }
//            cout << p << endl;
//            for (auto i : d) cout << i << ' ';
//            cout << endl;
            auto d_ = d;
            sort(d_.begin(), d_.end(), greater<>());
            vector<pair<int, int>> ss;
            for (auto i : d_) {
                if (ss.empty() || ss.back().first != i) ss.emplace_back(i, 1);
                else ss.back().second++;
            }
            int b;
            int sum = 0;
            for (auto [x, y] : ss) {
                sum += y;
                if (sum >= k) {
                    b = x;
                    break;
                }
            }
//            cout << p << ' ' << b << endl;
//            for (auto [x, y] : ss) cout << x << ' ' << y << endl;
//            cout << endl;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (d[i] == d[j]) {
                        ok[i][j]++;
                    } else if (d[i] >= b && d[j] >= b) {
                        ok[i][j]++;
                    }
                }
            }
        }
        a = a_;
        DSU dsu(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (ok[i][j] == primes.size()) {
//                    cout << i << ' ' << j << endl;
                    dsu.unite(i, j);
                }
            }
        }
        vector<vector<int>> ind(n);
        for (int i = 0; i < n; ++i) ind[dsu.get(i)].push_back(i);
        vector<int> res(n);
        for (int i = 0; i < n; ++i) {
            vector<int> vals;
            for (auto j : ind[i]) vals.push_back(a[j]);
            sort(vals.begin(), vals.end());
            for (int j = 0; j < ind[i].size(); ++j) res[ind[i][j]] = vals[j];
        }
        for (auto i : res) cout << i << ' ';
        cout << '\n';
    }
}