#include<bits/stdc++.h>
using namespace std;
using ll = long long;

struct DSU {
    vector<int> p;

    DSU() = default;
    DSU(int n) : p(n, 0) {
        iota(p.begin(), p.end(), 0);
    }

    int get(int u) {
        while (u != p[u]) u = p[u] = p[p[u]];
        return u;
    }

    void unite(int u, int v) {
        p[get(u)] = get(v);
    }
};

vector<int> primes;

int find(int x) {
    return lower_bound(primes.begin(), primes.end(), x) - primes.begin();
}

vector<ll> go(vector<ll> a, vector<map<int, int>> fact, int k) {
    int n = a.size();
    vector<vector<int>> ok(n, vector<int>(n));
    vector<vector<int>> ev(primes.size());
    vector<int> bound(primes.size());
    for (int i = 0; i < n; ++i) {
        for (auto [x, y] : fact[i]) {
            ev[find(x)].push_back(y);
        }
    }
    for (int c = 0; c < primes.size(); ++c) {
        auto d_ = ev[c];
        sort(d_.begin(), d_.end(), greater<>());
        vector<pair<int, int>> ss;
        for (auto i : d_) {
            if (ss.empty() || ss.back().first != i) ss.emplace_back(i, 1);
            else ss.back().second++;
        }
        ss.emplace_back(n - ev[c].size(), 0);
        int b;
        int sum = 0;
        for (auto [x, y] : ss) {
            sum += y;
            if (sum >= k) {
                b = x;
                break;
            }
        }
        bound[c] = b;
    }
    map<ll, vector<int>> mp;
    for (int i = 0; i < n; ++i) {
        ll res = 1;
        for (auto [x, y] : fact[i]) {
            int pw = min(y, bound[find(x)]);
            for (int c = 0; c < pw; ++c) res *= x;
        }
        mp[res].push_back(i);
    }
    vector<ll> res(n);
    for (auto [trash, ind] : mp) {
        vector<ll> vals;
        for (auto j : ind) vals.push_back(a[j]);
        sort(vals.begin(), vals.end());
        for (int j = 0; j < ind.size(); ++j) res[ind[j]] = vals[j];
    }
    return res;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int tests;
    cin >> tests;
    while (tests--) {
        int n, k, x;
        cin >> n >> k >> x;
        vector<ll> a(n);
        vector<map<int, int>> fact(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            int b = a[i];
            for (int q = 2; q * q <= b; ++q) {
                if (b % q == 0) {
                    primes.push_back(q);
                    while (b % q == 0) b /= q, fact[i][q]++;
                }
            }
            if (b > 1) {
                primes.push_back(b);
                fact[i][b]++;
            }
        }
        if (x > 1) primes.push_back(x);
        sort(primes.begin(), primes.end());
        primes.resize(unique(primes.begin(), primes.end()) - primes.begin());
        auto ans = go(a, fact, k);
        for (auto i : ans) cout << i << ' ';
        cout << '\n';
    }
}