#include <bits/stdc++.h>

#define sz(x) (int)(x).size()

using namespace std;

const int N = 5e5 + 1;
using ll = long long;

int edge[2*N], l[N], r[N], n, m, p[N], k[N], id[N];

long long res = 0, cnt = 0;
bool used[N];

struct Fenwick {
    vector < int > t;

    void init (int _n) {
        t.resize(_n, 0);
        fill (t.begin(), t.end(), 0);
    }

    void upd (int v, int val) {
        for (; v < sz(t); v = v | (v + 1)) t[v] += val;
    }

    int get (int v) {
        int sum = 0;
        for (; v >= 0; v = (v & (v + 1)) - 1) sum += t[v];
        return sum;
    }

    int get (int l, int r) {
        return get (r) - (l ? get (l - 1) : 0);
    }
} t;

int timer = -1, tin[N], tout[N];

vector < int > g[N];
int sz[N], par[N];

void dfs (int v, int p) {
    sz[v] = 1;
    par[v] = p;

    tin[v] = ++ timer;
    for (auto to : g[v]) {
        if (to != p) {
            dfs (to, v);
            sz[v] += sz[to];
        }
    }
    tout[v] = timer;
}

vector < pair < int , int > > update;

void to (int& v) {
    int _v = v;
    v = edge[id[v]];
    if(++ id[_v] > r[_v]) id[_v] = l[_v];
    ++ res;

    if(!used[v]) {
        used[v] = true;
        update.push_back ({tin[v], 1});
    }
}

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    cin >> n >> m;
    int stn = 0;
    for (int i = 1; i <= n; ++ i) {
        cin >> k[i];
        l[i] = stn, r[i] = stn + k[i] - 1;
        id[i] = stn;
        for (int j = l[i]; j <= r[i]; ++ j) cin >> edge[j], g[i].push_back(edge[j]);
        stn += k[i];
    }

    bool ok = true;
    for (int i = 1; i <= m; ++ i) cin >> p[i], ok &= p[i] == 1;
//    ok = false;
    int v = 1;
    if (!ok) {
        for (int i = 1; i <= m; ++ i) {
            while (v != p[i]) to(v);
            to (v);
        }

        cout << res << "\n";
        return 0;
    }

    dfs (1, 1);
    t.init(n);

    for (int i = 1; i <= n; ++ i) used[i] = false;
    cnt = 0;

    v = 1;

    res = 0;
    for (int i = 1; i <= m; ++ i) {
        update.clear();
        while (v != p[i]) {
            if (t.get (tin[v], tout[v]) == sz[v]) {
                res += 2 * sz[v] - 1;
                v = par[v];
            } else to (v);
        }
        to (v);
        for (auto& it : update) t.upd (it.first, it.second);
    }

    cout << res << "\n";

    return 0;
}
