#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
struct seg_tree
{
    vector<int>tree;
    seg_tree(int sz)
    {
        tree.resize(sz*4);
    }
    void update(int pos,int v,int tl,int tr)
    {
        if(tr<pos||tl>pos)return;
        if(tl==pos&&tl==tr)
        {
            tree[v]=1;
            return;
        }
        int tm=(tl+tr)/2;
        update(pos,v*2,tl,tm),update(pos,v*2+1,tm+1,tr);
        tree[v]=tree[v*2]+tree[v*2+1];
    }
    int seg_sum(int l,int r,int v,int tl,int tr)
    {
        if(tr<l||tl>r)return 0;
        if(tr<=r&&tl>=l)return tree[v];
        int tm=(tl+tr)/2;
        return seg_sum(l,r,v*2,tl,tm)+seg_sum(l,r,v*2+1,tm+1,tr);
    }
};
const int maxN=1e5;
vector<vector<int>>adj(maxN),fixed_adj(maxN);
vector<int>euler_tour={0},parent(maxN);
vector<int>req;
vector<vector<pair<int,int>>>adj_push(maxN);
int it=0;
int n,m;
long long int ans=0;
void calc_parent(int x,int p)
{
    parent[x]=p;
    for(auto &y:adj[x])if(y!=p)calc_parent(y,x);
}
void calc_euler_tour(int x,int p)
{
    for(auto &y:fixed_adj[x])
    {
            euler_tour.push_back(y);
            adj_push[x].push_back({euler_tour.size()-1,y});
        if(y!=p)calc_euler_tour(y,x);
    }
}
int main()
{
   // ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    cin>>n>>m;
    for(int i=0;i<n;i++)
    {
        int sz;
        cin>>sz;
        adj[i].resize(sz);
        for(auto &x:adj[i])cin>>x,x--;
    }
    for(int i=0;i<m;i++)
    {
        int x;
        cin>>x;
        x--;
        req.push_back(x);
    }
    calc_parent(0,0);
    for(int i=0;i<n;i++)
    {
        if(i==0)
        {
            fixed_adj[i]=adj[i];
            continue;
        }
        int pos=find(adj[i].begin(),adj[i].end(),parent[i])-adj[i].begin();
        pos=(pos+1)%adj[i].size();
        while(adj[i][pos]!=parent[i])fixed_adj[i].push_back(adj[i][pos]),pos=(pos+1)%adj[i].size();
        fixed_adj[i].push_back(parent[i]);
    }
    calc_euler_tour(0,0);
    set<int>st[maxN];
    set<pair<int,int>>have_to_fix;
    vector<int>f_adj(maxN);
    for(int i=euler_tour.size()-1;i>=0;i--)f_adj[euler_tour[i]]=i;
    seg_tree s_tree(euler_tour.size());
    s_tree.update(0,1,0,euler_tour.size()-1);
    st[0].insert(0);
    have_to_fix.insert({0,0});
    vector<vector<pair<int,int>>>base_push(maxN);
    for(int i=0;i<n;i++)
    {
        if(adj_push[i].size()==0)continue;
        if(i==0)
        {
            base_push[i]=adj_push[i];
            continue;
        }
        int it=0;
        for(int j=0;j<adj_push[i].size();j++)
        {
            if(adj_push[i][j].second==adj[i][0])
            {
                it=j;
                break;
            }
        }
        while(adj_push[i][it].second!=parent[i])
        {
            base_push[i].push_back(adj_push[i][it]);
            it=(it+1)%adj_push[i].size();
        }
        base_push[i].push_back(adj_push[i][it]);
    }
 //   cout<<"tour"<<" ";
  //  for(auto &x:euler_tour)cout<<x<<" ";
 //   cout<<endl;
    int cur_pos=0;
  //  cout<<"sz"<<" "<<euler_tour.size()<<endl;
    vector<pair<int,int>>full_insert;
    pair<int,int>max_val={0,0};
    while(it<m)
    {
        auto tmp_val=st[req[it]].lower_bound(cur_pos);
        int val=(tmp_val!=st[req[it]].end()?*tmp_val:1e9);
        if(have_to_fix.size()&&have_to_fix.begin()->first<val)
        {
            pair<int,int>v=*have_to_fix.begin();
            have_to_fix.erase(have_to_fix.begin());
        //    cout<<"val"<<" "<<v.second<<" "<<base_push[v.second].size()<<endl;
            for(auto &x:base_push[v.second])
            {
                st[x.second].insert(x.first);
                s_tree.update(x.first,1,0,euler_tour.size()-1);
                max_val=max(max_val,x);
           //     cout<<"pushing"<<" "<<x.first<<" "<<x.second<<endl;
                if(x.second!=parent[v.second]&&x.first)have_to_fix.insert(x);
            }
            for(auto &x:adj_push[v.second])full_insert.push_back(x);
            continue;
        }
        if(val==1e9)
        {
            ans+=s_tree.seg_sum(cur_pos,euler_tour.size()-1,1,0,euler_tour.size()-1);
            for(auto &x:full_insert)
            {
              //  cout<<"all_pushing"<<" "<<x.first<<" "<<x.second<<endl;
                if(x.first==f_adj[x.second]&&s_tree.seg_sum(x.first,x.first,1,0,euler_tour.size()-1)==0)have_to_fix.insert(x);
                st[x.second].insert(x.first);
                s_tree.update(x.first,1,0,euler_tour.size()-1);
                max_val=max(max_val,x);
            }
            full_insert.clear();
            cur_pos=max_val.second==0;
            continue;
        }
        ans+=s_tree.seg_sum(cur_pos,val,1,0,euler_tour.size()-1);
        it++;
//        cout<<"got"<<" "<<ans<<" "<<it<<" "<<cur_pos<<endl;
        cur_pos=val+1;
    }
    cout<<ans;
}
