#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <queue>
#pragma GCC optimize("Ofast,unroll-loops")
using namespace std;
struct seg_tree
{
    vector<int>tree;
    seg_tree(int sz)
    {
        tree.resize(sz*4);
    }
    void update(int pos,int v,int tl,int tr)
    {
        tree[v]++;
        if(tl==pos&&tl==tr)return;
        int tm=(tl+tr)>>1;
        if(pos<=tm)update(pos,v<<1,tl,tm);
        else update(pos,(v<<1)^1,tm+1,tr);
        tree[v]=tree[v<<1]+tree[(v<<1)^1];
    }
    int seg_sum(int l,int r,int v,int tl,int tr)
    {
        if(tr<l||tl>r)return 0;
        if(tr<=r&&tl>=l)return tree[v];
        int tm=(tl+tr)/2;
        return seg_sum(l,r,v*2,tl,tm)+seg_sum(l,r,v*2+1,tm+1,tr);
    }
};
const int maxN=5e5;
vector<int>adj[maxN],fixed_adj[maxN];
vector<int>euler_tour={0};
int parent[maxN];
vector<int>req;
vector<pair<int,int>>adj_push[maxN];
int it=0;
int n,m;
long long int ans=0;
void calc_parent(int x,int p)
{
    parent[x]=p;
    for(auto &y:adj[x])if(y!=p)calc_parent(y,x);
}
void calc_euler_tour(int x,int p)
{
    for(auto &y:fixed_adj[x])
    {
            euler_tour.push_back(y);
            adj_push[x].push_back({euler_tour.size()-1,y});
        if(y!=p)calc_euler_tour(y,x);
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m;
    for(int i=0;i<n;i++)
    {
        int sz;
        cin>>sz;
        adj[i].resize(sz);
        for(auto &x:adj[i])cin>>x,x--;
    }
    for(int i=0;i<m;i++)
    {
        int x;
        cin>>x;
        x--;
        req.push_back(x);
    }
    calc_parent(0,0);
    for(int i=0;i<n;i++)
    {
        if(i==0)
        {
            fixed_adj[i]=adj[i];
            continue;
        }
        int pos=find(adj[i].begin(),adj[i].end(),parent[i])-adj[i].begin();
        pos=(pos+1)%adj[i].size();
        while(adj[i][pos]!=parent[i])fixed_adj[i].push_back(adj[i][pos]),pos=(pos+1)%adj[i].size();
        fixed_adj[i].push_back(parent[i]);
    }
    calc_euler_tour(0,0);
    set<int>st[maxN];
    priority_queue<pair<int,int>>have_to_fix;
    vector<int>f_adj(maxN);
    for(int i=euler_tour.size()-1;i>=0;i--)f_adj[euler_tour[i]]=i;
    seg_tree s_tree(euler_tour.size());
    s_tree.update(0,1,0,euler_tour.size()-1);
    st[0].insert(0);
    have_to_fix.push({-0,0});
 //   cout<<"tour"<<" ";
  //  for(auto &x:euler_tour)cout<<x<<" ";
 //   cout<<endl;
    int cur_pos=0;
  //  cout<<"sz"<<" "<<euler_tour.size()<<endl;
    vector<pair<int,int>>full_insert;
    pair<int,int>max_val={0,0};
    vector<bool>pick(euler_tour.size());
    vector<int>seen(n);
    vector<vector<int>>q_tmp(maxN);
    for(auto &x:req)seen[x]=true;
    while(it<m)
    {
        int val;
        if(seen[req[it]]>=100)
        {
                    auto tmp_val=st[req[it]].lower_bound(cur_pos);
          val=(tmp_val!=st[req[it]].end()?*tmp_val:1e9);
        }
        else
        {
            val=1e9;
            for(auto &x:q_tmp[req[it]])if(x>=cur_pos)val=min(val,x);
        }
        if(have_to_fix.size()&&-have_to_fix.top().first<val)
        {
            pair<int,int>v=have_to_fix.top();
            have_to_fix.pop();
        if(adj_push[v.second].size()==0);
        else if(v.second==0)
        {
            for(auto &x:adj_push[v.second])
            {
                if(pick[x.first])continue;
                pick[x.first]=true;
                if(seen[x.second]>=100)st[x.second].insert(x.first);
                else q_tmp[x.second].push_back(x.first);
                s_tree.update(x.first,1,0,euler_tour.size()-1);
                max_val=max(max_val,x);
           //     cout<<"pushing"<<" "<<x.first<<" "<<x.second<<endl;
                if(x.second!=parent[v.second]&&x.first)have_to_fix.push({-x.first,x.second});
            }
        }
        else
        {
                    int it=0;
        for(int j=0;j<adj_push[v.second].size();j++)
        {
            if(adj_push[v.second][j].second==adj[v.second][0])
            {
                it=j;
                break;
            }
        }
        while(adj_push[v.second][it].second!=parent[v.second])
        {
            pair<int,int>x=adj_push[v.second][it];
             if(pick[x.first])
             {
                 it=(it+1)%adj_push[v.second].size();
                 continue;
             }
                pick[x.first]=true;
                if(seen[x.second]>=100)st[x.second].insert(x.first);
                else q_tmp[x.second].push_back(x.first);
                s_tree.update(x.first,1,0,euler_tour.size()-1);
                max_val=max(max_val,x);
           //     cout<<"pushing"<<" "<<x.first<<" "<<x.second<<endl;
                if(x.second!=parent[v.second]&&x.first)have_to_fix.push({-x.first,x.second});
            it=(it+1)%adj_push[v.second].size();
        }
                    pair<int,int>x=adj_push[v.second][it];
             if(pick[x.first])
             {
                 it=(it+1)%adj_push[v.second].size();
                 continue;
             }
                pick[x.first]=true;
                if(seen[x.second]>=100)st[x.second].insert(x.first);
                else q_tmp[x.second].push_back(x.first);
                s_tree.update(x.first,1,0,euler_tour.size()-1);
                max_val=max(max_val,x);
           //     cout<<"pushing"<<" "<<x.first<<" "<<x.second<<endl;
                if(x.second!=parent[v.second]&&x.first)have_to_fix.push({-x.first,x.second});
        }

            for(auto &x:adj_push[v.second])if(!pick[x.first])full_insert.push_back(x);
            continue;
        }
        if(val==1e9)
        {
            ans+=s_tree.seg_sum(cur_pos,euler_tour.size()-1,1,0,euler_tour.size()-1);
            for(auto &x:full_insert)
            {
                if(pick[x.first])continue;
                pick[x.first]=true;
              //  cout<<"all_pushing"<<" "<<x.first<<" "<<x.second<<endl;
                if(x.first==f_adj[x.second])have_to_fix.push({-x.first,x.second});
                if(seen[x.second]>=100)st[x.second].insert(x.first);
                else q_tmp[x.second].push_back(x.first);
                s_tree.update(x.first,1,0,euler_tour.size()-1);
                max_val=max(max_val,x);
            }
            full_insert.clear();
            cur_pos=max_val.second==0;
            continue;
        }
        ans+=s_tree.seg_sum(cur_pos,val,1,0,euler_tour.size()-1);
        it++;
//        cout<<"got"<<" "<<ans<<" "<<it<<" "<<cur_pos<<endl;
        cur_pos=val+1;
    }
    cout<<ans;
}
