#include <bits/stdc++.h>

using namespace std;
vector<int> a;
int d;
int n;

struct segtree {
    int siz;
    struct node {
        int mx, ind;
    };
    vector<node> tree;

    inline node comb(node a1, node b1) {
        if (a1.mx > b1.mx)return a1;
        else return b1;
    }

    inline void build(int v, int l, int r) {
        if (r - l == 1) {
            if (l < n) {
                tree[v] = {a[l], l};
            }
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        tree[v] = comb(tree[2 * v + 1], tree[2 * v + 2]);
    }

    inline void init() {
        siz = 1;
        while (siz < n) {
            siz *= 2;
        }
        tree.assign(2 * siz - 1, {INT_MIN, -1});
        build(0, 0, siz);
    }

    inline void upd(int v, int l, int r, int i, int val) {
        if (r - l == 1) {
            tree[v] = {val, l};
            return;
        }
        int mid = (l + r) / 2;
        if (i < mid) {
            upd(2 * v + 1, l, mid, i, val);
        } else {
            upd(2 * v + 2, mid, r, i, val);
        }
        tree[v] = comb(tree[2 * v + 1], tree[2 * v + 2]);
    }

    inline node ind(int v, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql)return {INT_MIN, -1};
        if (ql <= l && r <= qr)return tree[v];
        int mid = (l + r) / 2;
        return comb(ind(2 * v + 1, l, mid, ql, qr), ind(2 * v + 2, mid, r, ql, qr));
    }
};

segtree st;
set<int> bads;
bool ex;

void init(vector<int> A, int D) {
    a = A;
    n = (int) a.size();
    st.init();
    d = D;
    queue<pair<int, int>> q;
    bads.clear();
    q.push({0, n});
    while (!q.empty()) {
        auto [l, r] = q.front();
        q.pop();
        int mxind = st.ind(0, 0, st.siz, l, r).ind;
        bads.insert(mxind);
        int l1 = l;
        int r1 = max(mxind - d, l);
        if (l1 != r1) {
            q.push({l1, r1});
        }
        r1 = r;
        l1 = min(mxind + 1 + d, r);
        if (l1 != r1) {
            q.push({l1, r1});
        }
    }
    ex = false;
}

void updateValue(int index, int newValue) {
    st.upd(0, 0, st.siz, index, newValue);
    ex = false;
}

bool isWinning(int startIndex) {
    if (!ex) {
        int cn = (int) sqrt(n / d);
        queue<pair<int, int>> q;
        bads.clear();
        q.push({0, n});
        while (!q.empty() && cn--) {
            auto [l, r] = q.front();
            q.pop();
            int mxind = st.ind(0, 0, st.siz, l, r).ind;
            bads.insert(mxind);
            int l1 = l;
            int r1 = max(mxind - d, l);
            if (l1 != r1) {
                q.push({l1, r1});
            }
            r1 = r;
            l1 = min(mxind + 1 + d, r);
            if (l1 != r1) {
                q.push({l1, r1});
            }
        }
    }
    ex = true;
    if (bads.count(startIndex)) {
        return false;
    } else {
        auto itr = bads.upper_bound(startIndex);
        int rx;
        int lx;
        if (itr == bads.end()) {
            rx = n - 1;
            lx = *--bads.end();
        } else {
            rx = *itr;
            if (itr == bads.begin()) {
                lx = 0;
            } else {
                lx = *--itr;
            }
        }
        queue<pair<int, int>> q;
        q.push({lx, rx + 1});
        while (!q.empty()) {
            auto [l, r] = q.front();
            q.pop();
            int mxind = st.ind(0, 0, st.siz, l, r).ind;
            bads.insert(mxind);
            if (abs(mxind - startIndex) <= d)break;
            int l1 = l;
            int r1 = max(mxind - d, l);
            if (l1 != r1 && l1 <= startIndex && startIndex < r1) {
                q.push({l1, r1});
            }
            r1 = r;
            l1 = min(mxind + 1 + d, r);
            if (l1 != r1 && l1 <= startIndex && startIndex < r1) {
                q.push({l1, r1});
            }
        }
        if (bads.count(startIndex)) {
            return false;
        } else {
            return true;
        }
    }
}