#include <iostream>
#include <vector>
#include <set>
#include <cstring>
#include "game.h"

using namespace std;

const int maxn = 2e5 + 5;

bool winPos[maxn];
vector<int> cur;
set<pair<int, int>, greater<pair<int, int>>> sorted;
int d;

void recalc() {
	memset(winPos, 0, sizeof(winPos));
	for (auto [v, i] : sorted) {
		for (int j = max(0, i - d); j < min((int)cur.size(), i + d + 1); ++j) {
			if (j == i) continue;
			if (cur[j] > cur[i] && !winPos[j]) {
				//cout << "FOR " << i << " FINDED " << j << endl;
				winPos[i] = 1;
				break;
			}
		}
		//cout << "CALCED " << winPos[i] << " FOR " << v << ' ' << i << endl;
	}
}

void init(std::vector<int> A, int D) {
	sorted.clear();
	cur = A;
	d = D;
	for (int i = 0; i < A.size(); ++i) {
		sorted.insert({ A[i], i });
	}
	recalc();
}

void updateValue(int index, int newValue) {
	sorted.erase({ cur[index], index });
	cur[index] = newValue;
	sorted.insert({ newValue, index });
	recalc();
}

bool isWinning(int startIndex) {
	return winPos[startIndex];
}