#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

map<int, int> cnt;

void primeDivs(int n) {
	int l = sqrt(n);
	for (int i = 2; i <= l && i <= n; ++i) {
		if (n % i == 0) {
			cnt[i]++;
			while (n % i == 0) {
				n /= i;
			}
		}
	}
	if (n != 1) {
		cnt[n]++;
	}
}

void solve() {
	cnt.clear();
	int n, k, x;
	cin >> n >> k >> x;
	vector<int> a(n);
	for (auto& i : a) {
		cin >> i;
		primeDivs(i);
	}

	bool best = 0;
	bool best2 = 1;
	bool good = 0;
	int goodDiv = 2e9;
	int iToChange = -1;

	for (auto [div, cnt2] : cnt) {
		if (cnt2 > k - 1) {
			best2 = 0;
		}
		if (cnt2 == n) {
			best = 1;
		}
		if (cnt2 == n - 1) {
			if (good == 0) {
				good = 1;
				goodDiv = div;
				for (int i = 0; i < n; ++i) {
					if (a[i] % div != 0)
						iToChange = i;
				}
			}
			else {
				for (int i = 0; i < n; ++i) {
					if (a[i] % div != 0) {
						if (a[i] > a[iToChange]) {
							goodDiv = div;
							iToChange = i;
						}
						break;
					}
				}
			}
		}
	}

	if (!good && !best && !best2) {
		cout << "!?\n";
		exit(-1);
	}

	if (best || best2) {
		sort(a.begin(), a.end());
		for (auto v : a) {
			cout << v << ' ';
		}
	}
	else {
		a[iToChange] *= goodDiv;
		sort(a.begin(), a.end());
		for (auto v : a) {
			cout << v << ' ';
		}
	}
}

signed main() {
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}