#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

map<int, int> cnt;

void primeDivs(int n) {
	int l = sqrt(n);
	for (int i = 2; i <= l && i <= n; ++i) {
		if (n % i == 0) {
			cnt[i]++;
			while (n % i == 0) {
				n /= i;
			}
		}
	}
	if (n != 1) {
		cnt[n]++;
	}
}

void solve() {
	cnt.clear();
	int n, k, x;
	cin >> n >> k >> x;
	vector<int> a(n);
	for (auto& i : a) {
		cin >> i;
		primeDivs(i);
	}

	bool canSolve = 1;
	int iToChange = -1;

	for (auto [div, cnt2] : cnt) {
		if (cnt2 <= k - 1) {
			continue;
		}
		if (cnt2 == n) {
			continue;
		}
		if (cnt2 != n - 1) {
			canSolve = 0;
			break;
		}
		if (div != x) {
			canSolve = 0;
			break;
		}
		for (int i = 0; i < n; ++i) {
			if (a[i] % x != 0) {
				iToChange = i;
				break;
			}
		}
	}

	if (!canSolve) {
		cout << "!?\n";
		exit(-1);
	}
	
	if (iToChange != -1) {
		a[iToChange] *= x;
	}

	sort(a.begin(), a.end());

	for (auto v : a) {
		cout << v << ' ';
	}
}

signed main() {
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}