#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

map<int, int> cnt;
map<int, vector<int>> divs;

void primeDivs(int n, int ind) {
	int l = sqrt(n);
	for (long long i = 2; i <= l && i <= n; ++i) {
		if (n % i == 0) {
			divs[ind].push_back(i);
			int tmp = 1;
			while (n % i == 0) {
				n /= i;
				tmp *= i;
				cnt[tmp]++;
			}
		}
	}
	if (n != 1) {
		cnt[n]++;
	}
}

void solve() {
	cnt.clear();
	int n, k, x;
	cin >> n >> k >> x;
	vector<int> a(n);
	int nw = 0;
	for (auto& i : a) {
		cin >> i;
		primeDivs(i, nw++);
	}
	
	map<int, vector<int>> equv;
	map<int, int> equCnt;
	vector<int> EqHashes(n);
	
	nw = 0;
	for (auto v : a) {
		int eqHash = 1;
		int vCopy = v;
		for (auto i : divs[nw]) {
			if (v % i == 0) {
				int tmp = 1;
				while (v % i == 0) {
					v /= i;
					if(cnt[tmp * i] >= k)
						tmp *= i;
				}
				eqHash *= tmp;
			}
		}
		if (v != 1) {
			if(cnt[v] >= k)
				eqHash *= v;
		}
		equv[eqHash].push_back(vCopy);
		EqHashes[nw++] = eqHash;
	}

	for (auto& [key, v] : equv) {
		sort(v.begin(), v.end());
	}

	for (auto v : EqHashes) {
		cout << equv[v][equCnt[v]++] << ' ';
	}
}

signed main() {
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}