//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <cstring>

using namespace std;

vector<int> PRECALCPRIMES;

void solve() {
	int n, k, x;
	cin >> n >> k >> x;
	vector<int> a(n);
	map<int, int> cnt;
	for (auto& v : a) {
		cin >> v;
		int vCopy = v;
		for (auto i : PRECALCPRIMES) {
			if (i > vCopy)
				break;
			if (vCopy % i == 0) {
				int tmp = 1;
				while (vCopy % i == 0) {
					vCopy /= i;
					tmp *= i;
					cnt[tmp]++;
				}
			}
		}
		if (vCopy != 1) {
			cnt[vCopy]++;
		}
	}
	
	map<int, vector<int>> equv;
	map<int, int> equCnt;
	vector<int> EqHashes(n);
	
	int nw = 0;
	for (auto v : a) {
		int eqHash = 1;
		int vCopy = v;
		for (auto i : PRECALCPRIMES) {
			if (i > n)
				break;
			if (v % i == 0) {
				int tmp = 1;
				while (v % i == 0) {
					v /= i;
					if(cnt[tmp * i] >= k)
						tmp *= i;
				}
				eqHash *= tmp;
			}
		}
		if (v != 1) {
			if(cnt[v] >= k)
				eqHash *= v;
		}
		equv[eqHash].push_back(vCopy);
		EqHashes[nw++] = eqHash;
	}

	for (auto& [key, v] : equv) {
		sort(v.begin(), v.end());
	}

	for (auto v : EqHashes) {
		cout << equv[v][equCnt[v]++] << ' ';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	bool erat[50000];
	memset(erat, 0, sizeof(erat));
	for (long long i = 2; i < 50000; ++i) {
		if (!erat[i]) {
			PRECALCPRIMES.push_back(i);
			for (long long j = i * i; j < 50000; j += i)
				erat[j] = 1;
		}
	}

	//cout << PRECALCPRIMES.size() << " Primes size\n";

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}