#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <cstring>

using namespace std;

map<int, int> cnt;
vector<int> PRECALCPRIMES;

void primeDivs(int n, int ind) {
    int l = sqrt(n);
    for (auto i : PRECALCPRIMES) {
        if (n % i == 0) {
            int tmp = 1;
            while (n % i == 0) {
                n /= i;
                tmp *= i;
                cnt[tmp]++;
            }
        }
    }
    if (n != 1) {
        cnt[n]++;
    }
}

void resolve(int n, int k, vector<int>& a) {
    cnt.clear();
    int nw = 0;

    for (auto& i : a) {
        primeDivs(i, nw++);
    }

    map<int, vector<int>> equv;
    map<int, int> equCnt;
    vector<int> EqHashes(n);

    nw = 0;
    for (auto v : a) {
        int eqHash = 1;
        bool canReach = 0;
        int vCopy = v;
        for (auto i : PRECALCPRIMES) {
            if (v % i == 0) {
                int tmp = 1;
                while (v % i == 0) {
                    v /= i;
                    if (cnt[tmp * i] >= k) {
                        tmp *= i;
                    }
                }
                eqHash *= tmp;
            }
        }
        if (v != 1) {
            if (cnt[v] >= k)
                eqHash *= v;
        }
        equv[eqHash].push_back(vCopy);
        EqHashes[nw++] = eqHash;
    }

    for (auto& [key, v] : equv) {
        sort(v.begin(), v.end());
    }

    for (auto v : EqHashes) {
        cout << equv[v][equCnt[v]++] << ' ';
    }
}

void solve() {
    cnt.clear();
    int n, k, x;
    cin >> n >> k >> x;
    vector<int> a(n);
    int nw = 0;

    for (auto& i : a) {
        cin >> i;
        //primeDivs(i, nw++);
    }

    if (x == 1) {
        resolve(n, k, a);
        return;
    }

    for (auto& i : a) {
        primeDivs(i, nw++);
    }

    map<int, vector<int>> equv;
    map<int, int> equCnt;
    vector<int> EqHashes(n);

    int minSwap = 2e9;

    nw = 0;
    for (auto v : a) {
        int eqHash = 1;
        int vCopy = v;
        for (auto i : PRECALCPRIMES) {
            if (v % i == 0) {
                int tmp = 1;
                while (v % i == 0) {
                    v /= i;
                    if (cnt[tmp * i] >= k) {
                        tmp *= i;
                    } else if (cnt[tmp * i] == k - 1 && cnt[tmp] >= k && i == x) {
                        minSwap = min(minSwap, a[nw]);
                    }
                }
                eqHash *= tmp;
            }
        }
        if (v != 1) {
            if (cnt[v] >= k)
                eqHash *= v;
        }
        equv[eqHash].push_back(vCopy);
        EqHashes[nw++] = eqHash;
    }

    for (auto& [key, v] : equv) {
        sort(v.begin(), v.end());
    }

    vector<int> ans;
    int nwnw = 0;
    for (auto v : EqHashes) {
        int var1 = equv[v][equCnt[v]];
        long long XPower = 1;
        {
            long long tmp = x;
            while (v % tmp == 0) {
                XPower = tmp;
                tmp *= x;
            }
        }
        int var2 = 2e9;
        if (cnt[XPower * x] >= k) {
            if (equv[v * x].size() > 0)
                var2 = min(a[nwnw] * x, equv[v * x][equCnt[v * x]]);
        }
        if (cnt[XPower * x] == k - 1) {
            var2 = min(a[nwnw] * x, minSwap);
        }
        if (var2 < var1) {
            a[nwnw] *= x;
            resolve(n, k, a);
            return;
        }
        ans.push_back(var1);
        equCnt[v]++;
        nwnw++;
    }

    for (auto v : ans) {
        cout << v << ' ';
    }

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    bool erat[50000];
    memset(erat, 0, sizeof(erat));
    for (long long i = 2; i < 50000; ++i) {
        if (!erat[i]) {
            PRECALCPRIMES.push_back(i);
            for (long long j = i * i; j < 50000; j += i)
                erat[j] = 1;
        }
    }

    //cout << PRECALCPRIMES.size() << " Primes size\n";

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}