#include <bits/stdc++.h>
#define f first
#define s second

using namespace std;
using ll = long long;
using pi = pair<int,int>;

const int MAX_N = 5e5+5;
int deg[MAX_N];
vector<int> nei[MAX_N];
vector<int> cs[MAX_N];
int offset[MAX_N];

void dfs(int node, int par = -1) {
    int d = deg[node];
    vector<int> ord;
    bool aft = false;
    int tmp = d;
    for(int ne : nei[node]) {
        tmp--;
        if(ne == par) {
            aft = true;
            offset[node] = tmp;
            continue;
        }
        if(aft) {
            ord.push_back(ne);
        }
        dfs(ne,node);
    }
    for(int ne : nei[node]) {
        if(ne == par) { break; }
        ord.push_back(ne);
    }
    cs[node] = ord;
}

int L[MAX_N], R[MAX_N];
int EUL[MAX_N*2];
int IDX[MAX_N*2];
vector<int> upos[MAX_N];

int uidx = 0;
// int cidx = 0;
void tour(int node) {
    upos[node].push_back(uidx);
    IDX[uidx] = 0;
    EUL[uidx++] = node;
    // L[node] = cidx++;
    int tmp = 0;
    for(int ne : cs[node]) {
        tour(ne);
        upos[node].push_back(uidx);
        IDX[uidx] = ++tmp;
        EUL[uidx++] = node;
    }
    // R[node] = cidx;
}

int n, m;
set<int> blocks;
int ptr = 0;
int dests[MAX_N];
int pos = 0;

// inline std::vector<int>::const_iterator cyc_bound(const std::vector<int> &vec, const int &val) {
//     auto it = lower_bound(vec.begin(),vec.end(),val);
//     if(it == vec.end()) { return vec.begin(); }
//     return it; 
// }

ll res = 1;
void adv(int x) {
    if(pos == x) { return; }
    int old_pos = pos;
    while(ptr < m) {
        int nxt = dests[ptr];
        auto it = lower_bound(upos[nxt].begin(),upos[nxt].end(),pos);
        if(it == upos[nxt].end() || *it >= x) {
            break;
        }
        pos = *it;
        ptr++;
        if(ptr == m) {
            res += pos-old_pos;
            return;
        }
        pos++;
        if(pos == uidx) { pos = 0; break; }
    }
    res += x-old_pos;
    pos = x;
    if(pos == uidx) {
        pos = 0;
    }
}

void rec() {
    if(blocks.empty()) {
        while(ptr < m) {
            adv(uidx);
        }
        return;
    }
    auto it = blocks.lower_bound(pos);
    if(it == blocks.end()) {
        it = blocks.begin();
        adv(uidx);
        adv(*it);
    } else {
        adv(*it);
    }
    int node = EUL[pos];
    pos = upos[node][offset[node]];
    for(int up : upos[node]) {
        blocks.erase(up);
    }
    offset[node] = 0;
    rec();
}

ll solve(int N, int M, vector<vector<int>> adj, vector<int> path) {
    n = N;
    m = M;
    blocks.clear();
    ptr = 0;
    pos = 0;
    res = 1;
    for(int i = 1; i <= n; i ++) {
        deg[i] = adj.size();
        nei[i] = adj[i];
        upos[i].clear();
    }
    for(int i = 0; i < m;i ++) {
        dests[i] = path[i];
    }
    dfs(1);
    tour(1);
    uidx--;
    upos[1].pop_back();

    for(int i = 1; i <= n; i ++) {
        if(offset[i]) {
            for(int p : upos[i]) {
                blocks.insert(p);
            }
        }
    }
    rec();
    return res;
}

ll brute(int N, int M, vector<vector<int>> adj, vector<int> path) {
    int pos = 1;
    vector<int> cnt(n);
    ll res = 0;
    auto nxt = [&] () {
        int c = (cnt[pos]++)%adj[pos].size();
        pos = adj[pos][c];
        res++;
    };
    for(int p : path) {
        while(pos != p) {
            nxt();
        }
        nxt();
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m;
    vector<vector<int>> adj(n+1);
    vector<int> path(m);
    for(int i = 1; i <= n; i ++) {
        int d;
        cin >> d;
        adj[i].resize(d);
        for(int &ne : adj[i]) {
            cin >> ne;
        }
    }
    for(int &p : path) {
        cin >> p;
    }
    cout << brute(n,m,adj,path) << '\n';
    return 0;
}

/*
4 6
2 2 3
1 1
2 1 4
1 3
2 1 3 3 1 3
*/