

#include <bits/stdc++.h>

#include "game.h"
#define f first
#define s second

using namespace std;
using pi = pair<int,int>;

const int INF = 2e9;

struct Seg {
    vector<pi> seg;
    int n;
    Seg() {}
    Seg(vector<int> A): seg(A.size()*2), n(A.size()) {
        for(int i = 0; i < n; i ++) {
            seg[i+n] = {A[i],i};
        }
        for(int i = n-1; i; i--) {
            seg[i] = max(seg[i<<1],seg[(i<<1)|1]);
        }
    }
    void update(int i, int x) {
        seg[i+n] = {x,i};
        for(i=((i+n)>>1); i; i>>=1) {
            seg[i] = max(seg[i<<1],seg[(i<<1)|1]);
        }
    }
    pi query(int a, int b) {
        if(a >= n || b <= 0) { return {-INF,-INF}; }
        a = max(a,0);
        b = min(b,n);
        pi res = {-INF,-INF};
        for(a += n, b += n; a < b; a >>= 1, b >>= 1) {
            if(a&1) {
                res = max(res,seg[a++]);
            }
            if(b&1) {
                res = max(res,seg[--b]);
            }
        }
        return res;
    }
};

Seg seg;
int L, N;

void init(std::vector<int> A, int D) {
    seg = Seg(A);
    L = D;
    N = A.size();
    updateValue(0,A[0]);
}
vector<int> lose;
void build(int l, int r) {
    if(l >= r) { return; }
    pi mx = seg.query(l,r);
    lose[mx.s] = true;
    build(mx.s+L+1,r);
    build(l,mx.s-L);

}
void updateValue(int index, int newValue) {
    seg.update(index, newValue);
    lose = vector<int>(N);
    build(0,N);
}

bool isTop(int i) {
    return seg.query(i-L,i+L+1).s == i;
}

bool isWinning(int startIndex) {
    return !lose[startIndex];
}
