#include<bits/stdc++.h>
using namespace std;
template<class T>using vec=vector<T>;
template<class T>using vvec=vec<vec<T>>;
using vi=vec<int>;
using vvi=vvec<int>;
using vb=vec<bool>;
using di=deque<int>;
using vdi=vec<di>;

#ifdef LOCAL
constexpr bool DEBUG = 1;
#else
constexpr bool DEBUG = 0;
#endif // LOCAL

vvi cons; vi paridx;
vi friends; int nextf = 0;
vi phase1hist, resthist;

vvi inphase1, inrest;
vi inphase1next, inrestnext;

void getpar(int c, int p = -1)
{
    for(int i = 0; i < cons[c].size(); ++i)
    {
        if(cons[c][i] == p)
        {
            paridx[c] = i;
            continue;
        }
        getpar(cons[c][i], c);
    }
}

void calcphase1(int c)
{
    inphase1[c].push_back(phase1hist.size());
    phase1hist.push_back(c);
    int upto = paridx[c] == -1 ? cons[c].size() : paridx[c];
    for(int i = 0; i < upto; ++i)
    {
        calcphase1(cons[c][i]);
        inphase1[c].push_back(phase1hist.size());
        phase1hist.push_back(c);
    }
}

void calcrest(int c)
{
    inrest[c].push_back(resthist.size());
    resthist.push_back(c);
    int days = 0;
    for(int i = paridx[c]+1; i < cons[c].size(); ++i)
    {
        calcrest(cons[c][i]);
        inrest[c].push_back(resthist.size());
        resthist.push_back(c);
    }
    for(int i = 0; i < paridx[c]; ++i)
    {
        calcrest(cons[c][i]);
        inrest[c].push_back(resthist.size());
        resthist.push_back(c);
    }
}

void read_input()
{
    cin.tie(0)->sync_with_stdio(0);
    int n,m; cin>>n>>m;
    cons = vvi(n); paridx = vi(n, -1);
    for(int i = 0; i < n; ++i)
    {
        int k; cin>>k;
        for(int j = 0; j < k; ++j)
        {
            int x; cin>>x; --x;
            cons[i].push_back(x);
        }
    }
    friends = vi(m);
    for(int i = 0; i < m; ++i)
    {
        int p; cin>>p; --p;
        friends[i] = p;
    }
    inphase1 = vvi(n); inrest = vvi(n);
    inphase1next = vi(n, 0); inrestnext = vi(n, 0);
}

int main()
{
    read_input();
    getpar(0); calcphase1(0); calcrest(0);
    int days = 1;
    if(DEBUG)
    {
        for(int i = 0; i < phase1hist.size(); ++i)
        {
            cout << (phase1hist[i]+1) << ' ';
        }
        cout << '\n';
        for(int i = 0; i < resthist.size(); ++i)
        {
            cout << (resthist[i]+1) << ' ';
        }
        cout << '\n';
    }

    int phase1idx = 0, restidx = 1;
    for(int i = 0; i < friends.size(); ++i)
    {
        int f = friends[i];
        if(DEBUG) cout << "reaching " << (f+1) << '\n';
        //still in phase 1
        if(phase1idx < phase1hist.size())
        {
            if(DEBUG) cout << "in phase 1\n";
            int nextone = inphase1next[f];
            while(nextone < inphase1[f].size() && inphase1[f][nextone] < phase1idx)
            {
                nextone = ++inphase1next[f];
            }
            //still has places
            if(nextone < inphase1[f].size())
            {
                int findpos = inphase1[f][nextone];
                if(DEBUG) cout << "moving from " << phase1idx << " to " << findpos << '\n';
                days += findpos - phase1idx;
                phase1idx = findpos;
                inphase1next[f]++;
            }
            //ran out of places. end phase 1.
            else
            {
                if(DEBUG) cout << "ending: moving from " << phase1idx << " to " << phase1hist.size() << '\n';
                days += phase1hist.size() - phase1idx;
                phase1idx = phase1hist.size();
            }
        }

        //rest
        if(phase1idx == phase1hist.size())
        {
            if(DEBUG) cout << "doing rest " << '\n';
            int nextone = inrestnext[f];
            while(nextone < inrest[f].size() && inrest[f][nextone] < restidx)
            {
                nextone = ++inrestnext[f];
            }
            //need to loop back
            if(nextone == inrest[f].size())
            {
                nextone = inrestnext[f] = 0;
                if(DEBUG) cout << "ending: moving from " << restidx << " to " << resthist.size() << '\n';
                days += resthist.size() - restidx;
                restidx = 1;
            }
            int findpos = inrest[f][nextone];
            if(DEBUG) cout << "moving from " << restidx << " to " << findpos << '\n';
            days += findpos - restidx;
            restidx = findpos;
            inrestnext[f]++;
        }
    }

    cout << days << '\n';
}
