#include<bits/stdc++.h>
using namespace std;
template<class T>using vec=vector<T>;
template<class T>using vvec=vec<vec<T>>;
using vi=vec<int>;
using vvi=vvec<int>;
using vb=vec<bool>;
using di=deque<int>;
using vdi=vec<di>;

#ifdef LOCAL
constexpr bool DEBUG = 1;
#else
constexpr bool DEBUG = 0;
#endif // LOCAL

vvi cons; vi paridx;
vi friends; int nextf = 0;
vi phase1hist, phase2hist;

vvi inphase1, inphase2;
vi inphase1next, inphase2next;

void getpar(int c, int p = -1)
{
    for(int i = 0; i < cons[c].size(); ++i)
    {
        if(cons[c][i] == p)
        {
            paridx[c] = i;
            continue;
        }
        getpar(cons[c][i], c);
    }
}

void calcphase1(int c)
{
    inphase1[c].push_back(phase1hist.size());
    phase1hist.push_back(c);
    int upto = paridx[c] == -1 ? cons[c].size() : paridx[c];
    for(int i = 0; i < upto; ++i)
    {
        calcphase1(cons[c][i]);
        inphase1[c].push_back(phase1hist.size());
        phase1hist.push_back(c);
    }
}

void calcphase2(int c)
{
    inphase2[c].push_back(phase2hist.size());
    phase2hist.push_back(c);
    for(int i = paridx[c]+1; i < cons[c].size(); ++i)
    {
        calcphase2(cons[c][i]);
        inphase2[c].push_back(phase2hist.size());
        phase2hist.push_back(c);
    }
    for(int i = 0; i < paridx[c]; ++i)
    {
        calcphase2(cons[c][i]);
        inphase2[c].push_back(phase2hist.size());
        phase2hist.push_back(c);
    }
}

void read_input()
{
    cin.tie(0)->sync_with_stdio(0);
    int n,m; cin>>n>>m;
    cons = vvi(n); paridx = vi(n, -1);
    for(int i = 0; i < n; ++i)
    {
        int k; cin>>k;
        for(int j = 0; j < k; ++j)
        {
            int x; cin>>x; --x;
            cons[i].push_back(x);
        }
    }
    friends = vi(m);
    for(int i = 0; i < m; ++i)
    {
        int p; cin>>p; --p;
        friends[i] = p;
    }
    inphase1 = vvi(n); inphase2 = vvi(n);
    inphase1next = vi(n, 0); inphase2next = vi(n, 0);
}

int main()
{
    read_input();
    getpar(0); calcphase1(0); calcphase2(0);
    int days = 1;
    if(DEBUG)
    {
        for(int i = 0; i < phase1hist.size(); ++i)
        {
            cout << (phase1hist[i]+1) << ' ';
        }
        cout << '\n';
        for(int i = 0; i < phase2hist.size(); ++i)
        {
            cout << (phase2hist[i]+1) << ' ';
        }
        cout << '\n';
    }

    int phase1idx = 0, phase2idx = 0;
    bool canmovenext = false;
    for(int i = 0; i < friends.size(); i += canmovenext, canmovenext = false)
    {
        int f = friends[i];
        if(DEBUG) cout << "reaching " << (f+1) << '\n';
        //still in phase 1
        if(phase1idx < phase1hist.size())
        {
            if(DEBUG) cout << "in phase 1\n";
            int nextone = inphase1next[f];
            while(nextone < inphase1[f].size() && inphase1[f][nextone] < phase1idx)
            {
                nextone = ++inphase1next[f];
            }
            //still has places
            if(nextone < inphase1[f].size())
            {
                int findpos = inphase1[f][nextone];
                if(DEBUG) cout << "moving from " << phase1idx << " to " << findpos << '\n';
                days += findpos - phase1idx;
                phase1idx = findpos;
                inphase1next[f]++;
                canmovenext = true;
            }
            //ran out of places. move to phase 2
            else
            {
                inphase1next[f] = 0;
                if(DEBUG) cout << "ending: moving from " << phase1idx << " to " << phase1hist.size() << '\n';
                days += phase1hist.size() - phase1idx;
                phase1idx = phase1hist.size();
                phase2idx = 1;
            }
        }
        //phase 2
        else
        {
            if(DEBUG) cout << "doing phase 2 " << '\n';
            int nextone = inphase2next[f];
            while(nextone < inphase2[f].size() && inphase2[f][nextone] < phase2idx)
            {
                nextone = ++inphase2next[f];
            }
            //still has places
            if(nextone < inphase2[f].size())
            {
                int findpos = inphase2[f][nextone];
                if(DEBUG) cout << "moving from " << phase2idx << " to " << findpos << '\n';
                days += findpos - phase2idx;
                phase2idx = findpos;
                inphase2next[f]++;
                canmovenext = true;
            }
            //return to phase 1
            else
            {
                inphase2next[f] = 0;
                if(DEBUG) cout << "ending: moving from " << phase2idx << " to " << phase2hist.size() << '\n';
                days += phase2hist.size() - phase2idx;
                phase1idx = 1;
            }
        }
    }

    cout << days << '\n';
}
