#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> v;
typedef vector<v> vv;
typedef vector<vv> vvv;
typedef pair<ll, ll> p;
typedef vector<p> vp;
typedef vector<vp> vvp;
typedef vector<vvp> vvvp;
typedef pair<ll, p> tri;
typedef vector<tri> vtri;
typedef vector<vtri> vvtri;
typedef vector<vvtri> vvvtri;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<vvb> vvvb;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
typedef tree<ll, null_type,less<ll>,rb_tree_tag,tree_order_statistics_node_update> ost;

#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(),(v).end()

const ll INF = 1e18;
const ll mod = 1e9 + 7;

void getApperanceTime(vector<deque<ll>> &graph, v &parent, ll i, v &res,vb &afterParent)
{
    if (res[i] != -1) return;
    if (i == 0) res[i] = 0;
    else
        res[i] = res[parent[i]] + (afterParent[i]? 1 : 0);
    for (ll x : graph[i]) if (x != parent[i]) getApperanceTime(graph, parent, x, res, afterParent);
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    ll N, M;
    cin >> N >> M;
    vector<deque<ll>> graph(N);
    for (ll i= 0 ; i < N; i++)
    {
        ll k;
        cin >> k;
        for (ll j= 0 ; j < k; j++)
        {
            ll cur;
            cin >> cur;
            cur--;
            graph[i].pb(cur);
        }
    }
    v cities(M);
    for (ll i =0 ; i < M; i++) {cin >> cities[i]; cities[i]--;}
    v parent(N, -1);
    stack<p> dfs;
    dfs.emplace(0, -1);
    while (!dfs.empty())
    {
        auto top = dfs.top();
        dfs.pop();
        parent[top.f] = top.s;
        for (ll x : graph[top.f]) if (x != top.s) dfs.emplace(x, top.f);
    }
    vector<deque<ll>> graphCpy(N);
    for (ll i = 0; i < N; i++) for (ll x : graph[i]) graphCpy[i].pb(x);
    for (ll i= 1 ; i < N; i++) while (graphCpy[i].back() != parent[i]) {graphCpy[i].push_back(graphCpy[i].front()); graphCpy[i].pop_front();}
    v order;
    ll cur = 0;
    ll first = graph[0][0];
    while (cur != 0 || graphCpy[cur][0] != first || order.empty())
    {
        order.pb(cur);
        ll next = graphCpy[cur][0];
        graphCpy[cur].pop_front();
        graphCpy[cur].push_back(next);
        cur = next;
    }

    v appearanceTime(N, -1);
    vb afterParent(N, false);
    for (ll i =1 ; i < N; i++)
    {
        bool parAppeared = false;
        for (ll x : graph[i])
        {
            if (x == parent[i]) parAppeared = true;
            else afterParent[x] = parAppeared;
        }
    }
    getApperanceTime(graph, parent, 0, appearanceTime, afterParent);
    vv orderIndices(N);
    for (ll i = 0; i < order.size(); i++) orderIndices[order[i]].pb(i);
    v otherIndex(N, -1);
    for (ll i = 1; i < N; i++)
    {
        auto ptr = upper_bound(all(orderIndices[parent[i]]), orderIndices[i].back());
        if (ptr != orderIndices[parent[i]].end()) otherIndex[i] = *ptr;
    }
    vv appearing(N);
    for (ll i = 0; i < N; i++)
    {
        appearing[appearanceTime[i]].pb(orderIndices[i][0]);
        if (otherIndex[i] != -1) appearing[appearanceTime[i]].pb(otherIndex[i]);
    }
    vector<set<ll>> orderIndicesLive(N);
    ost allOrder;
    allOrder.insert(-1);
    for (ll x : appearing[0])
    {
        orderIndicesLive[order[x]].insert(x);
        allOrder.insert(x);
    }
    ll iteration = 0;
    ll steps = 0;
    cur = -1;
    for (ll i = 0; i < M; i++)
    {
        ll ap = appearanceTime[cities[i]];
        ll nt = max(iteration, ap);
        if (ap <= iteration)
        {
            auto ptr = orderIndicesLive[cities[i]].upper_bound(cur);
            if (ptr == orderIndicesLive[cities[i]].end()) nt++;
        }
        if (nt > iteration)
        {
            steps += allOrder.size() - 1 - allOrder.order_of_key(cur);
            for (iteration = iteration + 1; iteration <= nt; iteration++)
            {
                if (iteration < N)
                {
                    for (ll x : appearing[i])
                    {
                        orderIndicesLive[order[x]].insert(x);
                        allOrder.insert(x);
                    }
                }
                if (iteration < nt)
                {
                    steps += allOrder.size() - 1;
                }
            }
            cur = -1;
            nt = iteration;
        }
        auto ptr = orderIndicesLive[cities[i]].upper_bound(cur);
        steps += *ptr - cur;
        cur = *ptr;
    }
    cout << steps << "\n";
    return 0;
}