#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef vector<ll> v;
typedef vector<v> vv;
typedef vector<vv> vvv;
typedef pair<ll, ll> p;
typedef vector<p> vp;
typedef vector<vp> vvp;
typedef vector<vvp> vvvp;
typedef pair<ll, p> tri;
typedef vector<tri> vtri;
typedef vector<vtri> vvtri;
typedef vector<vvtri> vvvtri;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<vvb> vvvb;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
typedef tree<ll, null_type,less<ll>,rb_tree_tag,tree_order_statistics_node_update> ost;

#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(),(v).end()

const ll INF = 1e18;
const ll mod = 1e9 + 7;

void getApperanceTime(vv &graph, v &parent, ll i, v &res,vb &afterParent)
{
    if (res[i] != -1) return;
    if (i == 0) res[i] = 0;
    else
        res[i] = res[parent[i]] + (afterParent[i]? 1 : 0);
    for (ll x : graph[i]) if (x != parent[i]) getApperanceTime(graph, parent, x, res, afterParent);
}

ll query(v &st, ll l, ll r)
{
    ll N = st.size() / 2;
    l += N; r += N;
    ll res = 0;
    while (l <= r)
    {
        if (l % 2 == 1)
        {
            res += st[l];
            l++;
        }
        if (r % 2 == 0)
        {
            res += st[r];
            r--;
        }
        l /= 2; r /= 2;
    }
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    ll N, M;
    cin >> N >> M;
    vv graph(N);
    for (ll i= 0 ; i < N; i++)
    {
        ll k;
        cin >> k;
        for (ll j= 0 ; j < k; j++)
        {
            ll cur;
            cin >> cur;
            cur--;
            graph[i].pb(cur);
        }
    }
    v cities(M);
    for (ll i =0 ; i < M; i++) {cin >> cities[i]; cities[i]--;}
    v parent(N, -1);
    stack<p> dfs;
    dfs.emplace(0, -1);
    while (!dfs.empty())
    {
        auto top = dfs.top();
        dfs.pop();
        parent[top.f] = top.s;
        for (ll x : graph[top.f]) if (x != top.s) dfs.emplace(x, top.f);
    }
    vector<deque<ll>> graphCpy(N);
    for (ll i = 0; i < N; i++) for (ll x : graph[i]) graphCpy[i].pb(x);
    for (ll i= 1 ; i < N; i++) while (graphCpy[i].back() != parent[i]) {graphCpy[i].push_back(graphCpy[i].front()); graphCpy[i].pop_front();}
    v order;
    ll cur = 0;
    ll first = graph[0][0];
    while (cur != 0 || graphCpy[cur][0] != first || order.empty())
    {
        order.pb(cur);
        ll next = graphCpy[cur][0];
        graphCpy[cur].pop_front();
        graphCpy[cur].push_back(next);
        cur = next;
    }
    vb afterParent(N, false);
    for (ll i =1 ; i < N; i++)
    {
        bool parAppeared = false;
        for (ll x : graph[i])
        {
            if (x == parent[i]) parAppeared = true;
            else afterParent[x] = parAppeared;
        }
    }
    v appearanceTime(N, -1);
    getApperanceTime(graph, parent, 0, appearanceTime, afterParent);
    vv orderIndices(N);
    for (ll i = 0; i < order.size(); i++) orderIndices[order[i]].pb(i);
    vv appearing(N);
    for (ll i = 0; i < N; i++)
    {
        appearing[appearanceTime[i]].pb(orderIndices[i][0]);
    }
    for (ll i = 1; i < N; i++)
    {
        auto ptr = upper_bound(all(orderIndices[parent[i]]), orderIndices[i].back());
        if (ptr != orderIndices[parent[i]].end()) appearing[appearanceTime[i]].pb(*ptr);
    }
    vector<set<ll>> orderIndicesLive(N);
    ll O = pow(2, ceil(log2(order.size())));
    v st(2 * O, 0);
    for (ll x : appearing[0])
    {
        orderIndicesLive[order[x]].insert(x);
        st[x + O]++;
    }
    for (ll i = O - 1; i > 0; i--) st[i] = st[2 * i] + st[2 * i + 1];
    ll iteration = 0;
    long long steps = 0;
    cur = -1;
    for (ll i = 0; i < M; i++)
    {
        ll ap = appearanceTime[cities[i]];
        ll nt = max(iteration, ap);
        if (ap <= iteration && iteration < N - 1)
        {
            auto ptr = orderIndicesLive[cities[i]].upper_bound(cur);
            if (ptr == orderIndicesLive[cities[i]].end()) nt++;
        }
        if (nt > iteration)
        {
            steps += st[1] - query(st, 0, cur);
            iteration++;
            for (;iteration <= min(N - 1, nt); iteration++)
            {
                for (ll x : appearing[iteration])
                {
                    orderIndicesLive[order[x]].insert(x);
                    ll i = x + O;
                    while (i > 0)
                    {
                        st[i]++; i /= 2;
                    }
                }
                if (iteration < nt)
                    steps += st[1];
            }
            if (iteration < nt && iteration >= N)
                steps += order.size() * (nt - iteration);
            cur = -1;
            iteration = nt;
        }
        auto ptr = orderIndicesLive[cities[i]].upper_bound(cur);
        ll num;
        if (ptr == orderIndicesLive[cities[i]].end())
        {
            steps += order.size() - cur - 1;
            iteration++;
            cur = -1;
            num = orderIndices[cities[i]][0];
        }
        else num = *ptr;
        if (iteration < N - 1)
            steps += query(st, cur + 1, num);
        else
            steps += num - cur;
        cur = num;
    }
    cout << steps << "\n";
    return 0;
}