#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")

using namespace std;

typedef int ll;
typedef vector<ll> v;
typedef vector<v> vv;
typedef vector<vv> vvv;
typedef pair<ll, ll> p;
typedef vector<p> vp;
typedef vector<vp> vvp;
typedef vector<vvp> vvvp;
typedef pair<ll, p> tri;
typedef vector<tri> vtri;
typedef vector<vtri> vvtri;
typedef vector<vvtri> vvvtri;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<vvb> vvvb;

#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(),(v).end()

const ll INF = 1e18;
const ll mod = 1e9 + 7;

ll query(v &st, ll l, ll r)
{
    ll N = st.size() / 2;
    l += N; r += N;
    ll res = 0;
    while (l <= r)
    {
        if (l % 2 == 1)
        {
            res += st[l];
            l++;
        }
        if (r % 2 == 0)
        {
            res += st[r];
            r--;
        }
        l /= 2; r /= 2;
    }
    return res;
}

constexpr ll maxM = 5e5, maxN = 5e5;

ll cities[maxM], parent[maxN], appearanceTime[maxN],order[2 * maxN - 1], pending[maxN];
deque<ll> graph[maxN];
bool afterParent[maxN];
set<ll> orderIndicesLive[maxN];
v orderIndices[maxN], appearing[maxN];

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    ll N, M;
    cin >> N >> M;
    for (ll i= 0 ; i < N; i++)
    {
        ll k;
        cin >> k;
        graph[i].resize(k);
        for (ll j= 0 ; j < k; j++)
        {
            ll cur;
            cin >> graph[i][j];
            graph[i][j]--;
        }
    }
    for (ll i =0 ; i < M; i++) {cin >> cities[i]; cities[i]--;}
    appearanceTime[0] = 0;
    stack<p> dfs;
    dfs.emplace(0, -1);
    while (!dfs.empty())
    {
        auto top = dfs.top();
        dfs.pop();
        parent[top.f] = top.s;
        if (top.f > 0)
        {
            appearanceTime[top.f] = appearanceTime[top.s] + afterParent[top.f];
        }
        bool parAppeared = false;
        for (ll x : graph[top.f])
        {
            if (x == top.s) parAppeared = true;
            else
            {
                afterParent[x] = parAppeared;
                dfs.emplace(x, top.f);
            }
        }
    }
    for (ll i = 1; i < N; i++)
    {
        while (graph[i].back() != parent[i])
        {
            graph[i].push_back(graph[i].front());
            graph[i].pop_front();
        }
    }
    ll orderIndex = 0;
    ll cur = 0;
    ll first = graph[0][0];
    while (cur != 0 || graph[cur][0] != first || orderIndex == 0)
    {
        order[orderIndex] = cur;
        ll next = graph[cur][0];
        graph[cur].pop_front();
        graph[cur].push_back(next);
        cur = next;
        orderIndex++;
    }
    ll o = orderIndex;
    for (ll i = 0; i < o; i++) orderIndices[order[i]].pb(i);
    for (ll i = 0; i < N; i++)
    {
        appearing[appearanceTime[i]].pb(orderIndices[i][0]);
    }
    for (ll i = 0 ;i < N; i++) pending[i] = -1;
    for (ll i = 0 ;i < o; i++)
    {
        if (pending[order[i]] > -1)
        {
            appearing[appearanceTime[pending[order[i]]]].pb(i);
            pending[order[i]] = -1;
        }
        if (order[i] > 0) pending[parent[order[i]]] = order[i];
    }
    ll O = pow(2, ceil(log2(o)));
    v st(2 * O, 0);
    v last(N, -1);
    for (ll x : appearing[0])
    {
        orderIndicesLive[order[x]].insert(x);
        last[order[x]] = max(last[order[x]], x);
        st[x + O]++;
    }
    for (ll i = O - 1; i > 0; i--) st[i] = st[2 * i] + st[2 * i + 1];
    ll iteration = 0;
    long long steps = 0;
    cur = -1;
    for (ll i = 0; i < M; i++)
    {
        if (appearanceTime[cities[i]] > iteration)
        {
            ll ap = appearanceTime[cities[i]];
            steps += st[1] - query(st, 0, cur);
            iteration++;
            for (;iteration <= min(N - 1, ap); iteration++)
            {
                for (ll x : appearing[iteration])
                {
                    orderIndicesLive[order[x]].insert(x);
        last[order[x]] = max(last[order[x]], x);
                    ll i = x + O;
                    while (i > 0)
                    {
                        st[i]++; i /= 2;
                    }
                }
                if (iteration < ap)
                    steps += st[1];
            }
            cur = -1;
            iteration = appearanceTime[cities[i]];
        }
        ll num;
        if (cur > last[cities[i]])
        {
            steps += st[1] - (iteration >= N - 1? cur : (query(st, 0, cur) - 1)) - 1;
            iteration++;
            if (iteration <= N - 1)
            {
                for (ll x : appearing[iteration])
                {
                    orderIndicesLive[order[x]].insert(x);
        last[order[x]] = max(last[order[x]], x);
                    ll i = x + O;
                    while (i > 0)
                    {
                        st[i]++; i /= 2;
                    }
                }
            }
            cur = -1;
            num = orderIndices[cities[i]][0];
        }
        else
        {
            num = *orderIndicesLive[cities[i]].upper_bound(cur);
        }
        if (iteration < N - 1)
            steps += query(st, cur + 1, num);
        else
            steps += num - cur;
        cur = num;
    }
    cout << steps << "\n";
    return 0;
}