#include "game.h"
#include <vector>
#include <iostream>
#include <queue>
using namespace std;

#define s second
#define f first

typedef pair<int, int> ii;

/*


w l w w l  w
1 7 4 9 30 2
		 
guess:
If I lose because of what's left of me,
and I continue to be larger than what's right of me
I don't change the result

same for right

If I lose because I am a local maximum,
and I stay one, I don't change.

0 - undecided
1 - lose from local
2 - win  from local

*/

vector<int> a;
vector<int> v;
int d;

void init(std::vector<int> A, int D) {
	a = A;
	d = D;

	int n = (int)a.size();
	v.resize(n);

	priority_queue<ii> pq;
	for (int i = 0; i < n; ++i) pq.emplace(a[i], i);

	while (!pq.empty()) {
		ii front = pq.top(); pq.pop();
		if (v[front.s]) continue;

		v[front.s] = 2;

		for (int i = max(0, front.s - d); i <= min(n - 1, front.s + d); ++i)
			if (i != front.s)
				v[i] = 1;
	}
}

void updateValue(int index, int newValue) {
	a[index] = newValue;
}

bool isWinning(int startIndex) {
	return v[startIndex] == 1;
}