#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

struct Fenw{
    vector <int> fenw;
    int n;
    Fenw(int n) : fenw(n + 1, 0), n(n) {}
    void upd(int i, int val){
        for (; i <= n; i += i & -i ){
            fenw[i] += val;
        }
    }
    int get(int i){
        int cnt = 0;
        for (; i > 0; i -= i & -i ){
            cnt += fenw[i];
        }
        return cnt;
    }
    int get(int l, int r){
        return get(r) - get(l - 1);
    }
};

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m; cin >> n >> m;
    vector <vector<int>> adj(n);
    for ( auto &u: adj ){
        int k; cin >> k;
        u.resize(k);
        for ( auto &v: u ){
            cin >> v; --v;
        }
    }
    vector <int> q(m);
    for ( auto &u: q ){
        cin >> u; --u;
    }
    vector <int> tour, tin(n), tout(n), fa(n);
    auto pre_dfs = [&](auto pre_dfs, int u, int p) -> void{
        fa[u] = p;
        tin[u] = (int)tour.size();
        tour.pb(u);
        vector <int> nxt, tmp;
        bool vis = false;
        for ( auto &v: adj[u] ){
            if ( v == p ){
                vis = true;
                continue;
            }
            if ( vis > 0 ){
                nxt.pb(v);
            } else tmp.pb(v);
        }
        for ( auto &v: tmp ){
            nxt.pb(v);
        }
        for ( auto &v: nxt ){
            pre_dfs(pre_dfs, v, u);
            tour.pb(u);
        }
        tout[u] = (int)tour.size();
    };
    pre_dfs(pre_dfs, 0, -1);
    tour.pop_back();
    vector <int> dp(n);
    vector <vector<int>> upd(n);
    auto dfs = [&](auto dfs, int u, int p) -> void{
        bool vis = false;
        upd[dp[u]].pb(u);
        for ( auto &v: adj[u] ){
            if ( v == p ){
                vis = true;
                continue;
            }
            dp[v] = dp[u] + vis;
            dfs(dfs, v, u);
        }
    };
    dfs(dfs, 0, -1);
    vector <set<int>> st(n);
    Fenw fn(n * 2);
    auto add = [&](int u){
        st[u].insert(tin[u]);
        fn.upd(tin[u] + 1, 1);
        if ( fa[u] != -1 && tout[u] < tour.size() ){
            st[fa[u]].insert(tout[u]);
            fn.upd(tout[u] + 1, 1);
        }
    };
    int ans = 0, j = 0, lst = -1;
    for ( int i = 0; i < n; i++ ){
        for ( auto &v: upd[i] ){
            add(v);
        }
        int mx = -1;
        while ( j < m ){
            auto it = st[q[j]].lower_bound(mx + 1);
            if ( it == st[q[j]].end() ){
                break;
            }
            mx = *it;
            j++;
        }
        if ( j == m ){
            lst = fn.get(mx + 1);
            break;
        } ans += fn.get(n * 2);
    }
    while ( j < m ){
        int mx = -1;
        while ( j < m ){
            auto it = st[q[j]].lower_bound(mx + 1);
            if ( it == st[q[j]].end() ){
                break;
            }
            mx = *it;
            j++;
        }
        if ( j == m ){
            lst = fn.get(mx + 1);
            break;
        } ans += fn.get(n * 2);
    }
    cout << ans + lst;

    cout << '\n';
}
