#include <bits/stdc++.h>
#include "game.h"

using ll = long long;
using pii = std::pair<int, int>;

std::vector < int > a;
int n, d;

std::vector < bool > win;

void fillWin() {
    std::fill(win.begin(), win.end(), false);

    std::vector < pii > arr;

    for (int i = 0; i < n; i++)
        arr.push_back({ a[i], i });

    std::sort(arr.begin(), arr.end(), std::greater < pii >());

    for (auto p : arr) {
        int i = p.second;

        if (win[i])
            continue;

        for (int j = i - 1; j >= 0 && i - j <= d; j--)
            if (a[j] <= a[i])
                win[j] = true;

        for (int j = i + 1; j < n && j - i <= d; j++)
            if (a[j] <= a[i])
                win[j] = true;
    }
}

void init(std::vector < int > A, int D) {
    n = A.size();
    a = A;
    d = D;

    win.resize(n);

    fillWin();
}

bool isWinning(int i) {
    return win[i];
}

void updateValue(int i, int val) {
    a[i] = val;
    fillWin();
}
/*
int main()
{
    int n, D, q;

    std::vector<int> nums;

    scanf("%d %d", &n, &D);

    for (int i = 1; i <= n; i++)
    {
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }

    init(nums, D);

    scanf("%d", &q);

    for (int i = 1; i <= q; i++)
    {
        int cm;

        scanf("%d", &cm);

        if (cm == 1)
        {
            int ind, val;

            scanf("%d %d", &ind, &val);

            updateValue(ind, val);
        }
        else
        {
            int ind;

            scanf("%d", &ind);

            printf("%d\n", (int)isWinning(ind));
        }
    }
}
*/
