#include <iostream>
#include <algorithm>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <chrono>
#include <random>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <cassert>
#include "game.h"

using namespace std;

#define sc second
#define fr first

int D, n;
vector<int> A;
vector<int> winning;

mt19937 rng(69);

void init(vector<int> a, int d)
{
    A = a;
    D = d;
    n = A.size();
    vector<pair<int, int>> s;
    winning.assign(n, 0);
    for(int i = 0; i < n; i++)
    {
        s.push_back({a[i], i});
    }
    sort(s.begin(), s.end());
    for(int j = n-1; j >= 0; j--)
    {
        if(winning[s[j].sc] == 0)
        {
            winning[s[j].sc] = 2;
            for(int i = max(0, s[j].sc-d); i <= min(n-1, s[j].sc+d); i++)
            {
                if(winning[i] == 0)
                {
                    winning[i] = 1;
                }
            }
        }
    }
    return;
}

void update(int l, int r)
{
    l = max(l, 0);
    r = min(n-1, r);
    vector<pair<int, int>> s;
    for(int i = l; i <= r; i++)
    {
        winning[i] = 0;
        s.push_back({A[i], i});
    }
    sort(s.begin(), s.end());
    for(int j = s.size()-1; j >= 0; j--)
    {
        if(winning[s[j].sc] == 0)
        {
            winning[s[j].sc] = 2;
            for(int i = max(0, s[j].sc-D); i <= min(n-1, s[j].sc+D); i++)
            {
                if(winning[i] == 0)
                {
                    winning[i] = 1;
                }
            }
        }
    }
    return;
}

multiset<int> changed;

void updateValue(int index, int newValue)
{
    A[index] = newValue;
}

bool isWinning(int start)
{
    update(start-100, start+100);
    if(rng()%1000 == 0)
    {
        init(A, D);
    }
    if(winning[start] == 1)
    {
        return true;
    }
    return false;
}

/*
int main()
{
    int n, D, q;

    std::vector<int> nums;

    scanf("%d %d", &n, &D);

    for (int i = 1; i <= n; i++)
    {
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }

    init(nums, D);

    scanf("%d", &q);

    for (int i = 1; i <= q; i++)
    {
        int cm;

        scanf("%d", &cm);

        if (cm == 1)
        {
            int ind, val;

            scanf("%d %d", &ind, &val);

            updateValue(ind, val);
        }
        else
        {
            int ind;

            scanf("%d", &ind);

            printf("%d\n", (int)isWinning(ind));
        }
    }

    return 0;
}
*/
/*
6 2
1 7 4 9 30 2
5
2 0
2 1
1 4 8
2 0
2 1
 */
