#include <bits/stdc++.h>
#define int long long

using namespace std;

const int nmax = 5e5;

int n,m;
int p[nmax + 5];

vector<int> G[nmax + 5], A[nmax + 5];

bool sel[nmax + 5];
int nrsel = 0;

vector<int> l[nmax + 5];
set<int> s[nmax + 5];

vector<pair<int,int>> u;

int poz_eu[nmax + 5];

struct arbore_indexat_binar
{
    int aib[2 * nmax + 5];
private:
    int ub(int x)
    {
        return (x & (-x));
    }
public:
    void update(int poz, int val)
    {
        for(int i=poz; i<=2*n; i+=ub(i))
        {
            aib[i] += val;
        }
    }
    int query(int qa, int qb)
    {
        int rez = 0;
        for(int i=qb; i>=1; i-=ub(i))
        {
            rez += aib[i];
        }
        for(int i=qa-1; i>=1; i-=ub(i))
        {
            rez -= aib[i];
        }
        return rez;
    }
};

arbore_indexat_binar aib;

void root_tree(int nod, int dad = 0)
{
    if(nod == 1)
    {
        for(auto it : G[nod])
        {
            A[nod].push_back(it);
        }
    }
    else
    {
        int poz = 0;
        for(int i=0; i<G[nod].size(); i++)
        {
            if(G[nod][i] == dad)
            {
                poz = i;
                break;
            }
        }
        for(int i=poz+1; i<G[nod].size(); i++)
        {
            A[nod].push_back(G[nod][i]);
        }
        for(int i=0; i<poz; i++)
        {
            A[nod].push_back(G[nod][i]);
        }
    }
    for(auto it : A[nod])
    {
        root_tree(it, nod);
    }
}

void Add(int nod, int poz)
{
    int cp = l[nod][poz];
    aib.update(cp, +1);
    s[nod].insert(cp);
}

void dfs_brut(int nod, int dad = 0)
{
    Add(nod, 0);
    bool found = false;
    int nr_son = 0;
    int poz_dad = 0;
    for(auto it : G[nod])
    {
        ++nr_son;
        if(it == dad)
        {
            poz_dad = nr_son;
        }
    }
    if(!poz_dad)
    {
        poz_dad = nr_son;
    }
    int poz_son = 0;
    for(auto it : G[nod])
    {
        ++poz_son;
        if(it == dad)
        {
            found = true;
            continue;
        }
        if(!found)
        {
            dfs_brut(it, nod);
            if(nod == 1 && it == G[nod].back())
            {
                break;
            }
            Add(nod, (nr_son - poz_dad) + poz_son);
        }
        else
        {
            u.push_back({it, nod});
        }
    }
}

void unlock()
{
    vector<pair<int,int>> aux_u = u;
    u.clear();
    for(auto it : aux_u)
    {
        int nod = it.first;
        int dad = it.second;
        dfs_brut(nod, dad);
        Add(dad,++poz_eu[dad]);
    }
}

int nr_nod = 0;

void euler(int nod)
{
    ++nr_nod;
    l[nod].push_back(nr_nod);
    for(auto it : A[nod])
    {
        euler(it);
        if(nod == 1 && it == A[nod].back())
        {
            break;
        }
        ++nr_nod;
        l[nod].push_back(nr_nod);
    }
}

int get_poz(int poz, int val)
{
    auto it = s[val].upper_bound(poz);
    if(it == s[val].end())
    {
        it = s[val].begin();
    }
    return *it;
}

void brut(int nod)
{
    euler(1);
    dfs_brut(1);
    int len = 2 * (n - 1);
    int ind = 0;
    long long rez = 0;
    for(int i=1; i<=m; i++)
    {
        int new_ind = get_poz(ind, p[i]);
        if(new_ind <= ind)
        {
            rez += aib.query(ind + 1, len);
            unlock();
            new_ind = get_poz(0, p[i]);
            rez += aib.query(1, new_ind);
        }
        else
        {
            rez += aib.query(ind + 1, new_ind);
        }
        ind = new_ind;
    }
    cout<<rez<<'\n';
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef home
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
#endif // home
    cin>>n>>m;
    for(int i=1; i<=n; i++)
    {
        int nr;
        cin>>nr;
        for(int j=1; j<=nr; j++)
        {
            int x;
            cin>>x;
            G[i].push_back(x);
        }
    }
    for(int i=1; i<=m; i++)
    {
        cin>>p[i];
    }
    root_tree(1);
    brut(1);
    return 0;
}
