#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 5e5 + 5;
constexpr int MMAX = 5e5 + 5;
typedef long long LL;

int N, M;
int DadNode[NMAX];

deque <int> G[NMAX];
int C[NMAX];
int posDadinG[NMAX];

int Lin[NMAX];

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> M;

    for (int i = 1; i <= N; ++ i ) {
        int k;
        cin >> k;
        C[i] = 0;

        for (int j = 1; j <= k; ++ j ) {
            int x;
            cin >> x;

            G[i].push_back(x);
        }
    }
}

void Dfs (int Node, int dad = -1) {
    DadNode[Node] = dad;

    for (int i = 0; i < G[Node].size(); ++ i ) {
        int v = G[Node][i];

        if (v == dad) {
            posDadinG[Node] = i;
            continue;
        }

        Dfs(v, Node);
    }
}

int posInLin[NMAX];
int SubTree[NMAX];
int vf = 0;

void SecondDfs (int Node, int dad = -1) {
    Lin[++vf] = Node;
    posInLin[Node] = vf;
    SubTree[Node] = 1;
    for (int i = 1; i < G[Node].size(); ++ i ) {
        int v = G[Node][i];

        if (v == dad) continue;

        SecondDfs(v, Node);
        SubTree[Node] += SubTree[v];
    }
}

int Search;
LL ans;

void Precompute () {
    Dfs(1);
    posDadinG[1] = -2;

    for (int i = 2; i <= N; ++ i ) {
        while (DadNode[i] != G[i][0]) {
            G[i].push_back(G[i][0]);
            G[i].pop_front();
        }
        C[i] = (G[i].size() - posDadinG[i]) % G[i].size();
    }

    SecondDfs(1);
}

int aint[4 * NMAX];
void Update (int nod, int a, int b, int pos, int val) {
    if (a == b) {
        aint[nod] = val;
        return;
    }

    int mij = (a + b) / 2;

    if (pos <= mij) Update(2*nod, a, mij, pos, val);
    else Update(2*nod+1, mij+1, b, pos, val);

    aint[nod] = aint[2*nod] + aint[2*nod+1];
}

int Query (int nod, int a, int b, int qa, int qb) {
    if (qa <= a && b <= qb) return aint[nod];

    int mij = (a + b) / 2;
    int ans_st = 0, ans_dr = 0;

    if (qa <= mij) ans_st = Query(2*nod, a, mij, qa, qb);
    if (mij < qb) ans_dr = Query(2*nod+1, mij+1, b, qa, qb);

    return ans_st + ans_dr;
}

int LastGood[4 * NMAX];
void UpdateLastGood (int nod, int a, int b, int pos, int val) {
    if (a == b) {
        LastGood[nod] = val;
        return;
    }

    int mij = (a + b) / 2;

    if (pos <= mij) Update(2*nod, a, mij, pos, val);
    else Update(2*nod+1, mij+1, b, pos, val);

    aint[nod] = (LastGood[2*nod] == 0 ? LastGood[2*nod+1] : LastGood[2 * nod]);
}

int QueryLastGood (int nod, int a, int b, int qa, int qb) {
    if (qa <= a && b <= qb) return aint[nod];

    int mij = (a + b) / 2;
    int ans_st = 0, ans_dr = 0;

    if (qa <= mij) ans_st = Query(2*nod, a, mij, qa, qb);
    if (mij < qb) ans_dr = Query(2*nod+1, mij+1, b, qa, qb);

    return (ans_st == 0 ? ans_dr : ans_st);
}

bool good[NMAX];

int CntReturn (int Node) {
    int ans = 1;

    if (G[Node].size() == 1 && Node != 1) {
        Update(1, 1, N, posInLin[Node], 1);
        UpdateLastGood(1, 1, N, posInLin[Node], 0);
        return 1;
    }

    if (C[Node] == 0) {
        ++ C[Node];
        Update(1, 1, N, posInLin[Node], G[Node].size());
        UpdateLastGood(1, 1, N, posInLin[Node], posInLin[Node]);

        return 1;
    }

    if (!good[Node]) {
        for (int i = C[Node]; i < G[Node].size(); ++ i ) {
            ans += (CntReturn(G[Node][i]) + 1);
        }
        good[Node] = true;
        Update(1, 1, N, posInLin[Node], G[Node].size());
        UpdateLastGood(1, 1, N, posInLin[Node], posInLin[Node]);

        return ans;
    }

    int st = posInLin[Node] + 1;
    int dr = st + SubTree[Node];
    ans += Query(1, 1, N, st, dr);

    while (st <= dr) {
        int p = QueryLastGood(1, 1, N, st, dr);

        if (p == 0) break;

        st = p + 1;
        UpdateLastGood(1, 1, N, p, 0);
        for (int i = 1; i < G[Lin[p]].size(); ++ i ) {
            ans += CntReturn(G[Lin[p]][i]);
        }
    }

    return ans;
}

void Solve () {
    int ans = 1;
    for (int i = 2; i <= M; ++ i ) {
        ans += 1 + CntReturn(G[1][(C[1] + i) % G[1].size()]);
    }

    cout << ans << '\n';
}

int main()
{
    Read();
    Precompute();
    Solve();

    return 0;
}
