#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e5 + 5;
const int VMAX = 1e5;

int a[NMAX + 5];
int b[NMAX + 5];
int n, k, x;

bool p[VMAX + 5];
vector<int> primes;

void ciur(int t) {
    p[0] = p[1] = 1;
    for (int i = 2; i <= t; i++) {
        if (!p[i]) {
            primes.push_back(i);
            for (int j = i + i; j <= t; j += i)
                p[j] = 0;
        }
    }
}

vector<pair<int, int>> factori[NMAX + 5];

void descompunere(int x, vector<pair<int, int>> & out) {
    int cnt = -1;
    while (x > 1) {
        cnt++;
        if (primes[cnt] * primes[cnt] > x) break;
        if (x % primes[cnt] == 0) {
            pair<int, int> p = make_pair(primes[cnt], 0);
            while (x % primes[cnt] == 0) {
                x /= primes[cnt];
                p.second++;
            }
            out.push_back(p);
        }
    }
    if (x > 1)
        out.push_back(make_pair(x, 1));
}

map<pair<int, int>, int> mp; //de cate ori apare in sir (factor, exponent);
set<pair<int, int>> fc[NMAX + 5]; //set cu pair(factor, exponent) pt fiecare numar
map<int, int> celMaiMareExpFix; //cel mai mare exponent cu fr >= k al numarului dat
map<int, int> pozitie; // o pozitie din sir care are valoarea val
bool esteBunDeja[NMAX + 5];

bool potSwap(int x, int y) {
    //pot da Swap intre valorile x si y?
    int i = pozitie[x];
    int j = pozitie[y];
    for (auto & pr : factori[i]) {
        //
        int t1 = min(celMaiMareExpFix[pr.first], pr.second);
        int t2 = 0;
        auto it = fc[j].lower_bound(make_pair(pr.first, 0));
        if (it != fc[j].end() && (*it).first == pr.first) {
            t2 = min(celMaiMareExpFix[pr.first], (*it).second);
        }
        if (t1 != t2)
            return 0;
    }

    for (auto & pr : factori[j]) {
        //
        int t1 = min(celMaiMareExpFix[pr.first], pr.second);
        int t2 = 0;
        auto it = fc[i].lower_bound(make_pair(pr.first, 0));
        if (it != fc[i].end() && (*it).first == pr.first) {
            t2 = min(celMaiMareExpFix[pr.first], (*it).second);
        }
        if (t1 != t2)
            return 0;
    }
    return 1;
}

void solve() {
    mp.clear();
    pozitie.clear();
    celMaiMareExpFix.clear();

    cin >> n >> k >> x;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pozitie[a[i]] = i;
        fc[i].clear();
        factori[i].clear();
        esteBunDeja[i] = 0;
        b[i] = a[i];
        //b[i] = a[i];
    }
    //sort(b + 1, b + n + 1);

    for (int i = 1; i <= n; i++) {
        descompunere(a[i], factori[i]);
        for (auto &it : factori[i]) {
            //cout << i << ' ' << a[i] << ' ' << it.first << ' ' << it.second << '\n';
            fc[i].insert(it);
            for (int j = 1; j <= it.second; j++)
                mp[make_pair(it.first, j)]++;
        }
    }

    vector<int> pozitiiLibere;
    vector<int> valoriLibere;

    for (int i = 1; i <= n; i++) {
        bool doarRar = 1;
        for (auto &it : factori[i]) {
            if (mp[make_pair(it.first, 1)] >= k) {
                doarRar = 0;
            }
        }
        if (doarRar) {
            //cout << "RAR " << i << '\n';
            pozitiiLibere.push_back(i);
            valoriLibere.push_back(a[i]);
        }
    }

    for (auto &it : mp) {
        if (it.second >= k) {
            celMaiMareExpFix[it.first.first] = max(celMaiMareExpFix[it.first.first], it.first.second);
        }
    }



    sort(valoriLibere.begin(), valoriLibere.end());
    for (int i = 0; i < pozitiiLibere.size(); i++) {
        b[pozitiiLibere[i]] = valoriLibere[i];
        esteBunDeja[pozitiiLibere[i]] = 1;
    }

    //acum avem doar valori care sunt fixate de cel putin un factor
    for (int i = 1; i <= n; i++) {
        if (esteBunDeja[i]) continue;
        for (int j = i + 1; j <= n; j++) {
            if (esteBunDeja[j]) continue;
            if (b[j] < b[i] && potSwap(b[i], b[j])) {
                swap(b[i], b[j]);
            }
        }
    }
    for (int i = 1; i <= n; i++)
        cout << b[i] << ' ';
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ciur(VMAX);
    int t;
    cin >> t;
    while (t--)
        solve();

    return 0;
}
