#include "game.h"
#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 2e5;
int n, d, maxReachL[MAX_N], maxReachR[MAX_N];
vector<int> a;
void init( vector<int> A, int D ) {
	n = A.size();
	a = A;
	d = D;
	for ( int i = 0; i < n; i++ )
		maxReachL[i] = maxReachR[i] = 0;
	for ( int i = 0; i < n; i++ ) {
		for ( int j = i; j >= 0 && j >= i - d; j-- ) {
			if ( maxReachL[j] <= a[j] )
				maxReachL[i] = max( maxReachL[i], a[j] );
		}
	}
	for ( int i = n - 1; i >= 0; i-- ) {
		for ( int j = i; j < n && j <= i + d; j++ ) {
			if ( maxReachR[j] <= a[j] )
				maxReachR[i] = max( maxReachR[i], a[j] );
		}
	}
}

void calcL( int i ) {
	int oldValue = 0;
	maxReachL[i] = 0;
	for ( int j = i; j >= 0 && j >= i - d; j-- ) {
		if ( maxReachL[j] <= a[j] )
			maxReachL[i] = max( maxReachL[i], a[j] );
	}
	
	if ( oldValue == maxReachL[i] )
		return;
		
	for ( int j = i + 1; j < n && j <= i + d; j++ )
		calcL( j );
}

void calcR( int i ) {
	int oldValue = maxReachR[i];
	maxReachR[i] = 0;
	for ( int j = i; j < n && j <= i + d; j++ ) {
		if ( maxReachR[j] <= a[j] )
			maxReachR[i] = max( maxReachR[i], a[j] );
	}
	
	if ( oldValue == maxReachR[i] )
		return;
		
	for ( int j = i - 1; j >= 0 && j >= i - d; j-- )
		calcR( j );
}

void updateValue( int index, int newValue ) {
	a[index] = newValue;
	calcL( index );
	calcR( index );
}

bool isWinning( int startIndex ) {
	if ( max( maxReachL[startIndex], maxReachR[startIndex] ) == a[startIndex] )
		return false;
	return true;
}
