#include "game.h"
#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 2e5;
bool vis[MAX_N];
int n, d, maxReachL[MAX_N], maxReachR[MAX_N];
vector<int> a;
void init( vector<int> A, int D ) {
    n = A.size();
    a = A;
    d = D;
    for ( int i = 0; i < n; i++ )
        maxReachL[i] = maxReachR[i] = 0;
    for ( int i = 0; i < n; i++ ) {
        for ( int j = i; j >= 0 && j >= i - d; j-- ) {
            if ( maxReachL[j] <= a[j] )
                maxReachL[i] = max( maxReachL[i], a[j] );
        }
    }
    for ( int i = n - 1; i >= 0; i-- ) {
        for ( int j = i; j < n && j <= i + d; j++ ) {
            if ( maxReachR[j] <= a[j] )
                maxReachR[i] = max( maxReachR[i], a[j] );
        }
    }
}

struct info {
    int i, oldA;
    bool first;
};

void calcL( int i, int oldA, bool first ) {
    queue<info> q;
    q.push( { i, oldA, true } );
    while ( !q.empty() ) {
        int i = q.front().i, oldA = q.front().oldA, first = q.front().first;
        vis[i] = false;
        q.pop();
        int oldStatus = (maxReachL[i] <= oldA);
        maxReachL[i] = 0;
        for ( int j = i; j >= 0 && j >= i - d; j-- ) {
            if ( maxReachL[j] <= a[j] )
                maxReachL[i] = max( maxReachL[i], a[j] );
        }
        int newStatus = (maxReachL[i] <= a[i]);
        
        if ( oldStatus == newStatus && !first )
            continue;
            
        for ( int j = i + 1; j < n && j <= i + d; j++ ) {
            if ( !vis[j] )
                q.push( { j, a[j], false } );
            vis[j] = true;
        }
    }
}

void calcR( int i, int oldA, bool first ) {
    queue<info> q;
    q.push( { i, oldA, true } );
    while ( !q.empty() ) {
        int i = q.front().i, oldA = q.front().oldA, first = q.front().first;
        vis[i] = false;
        q.pop();
        int oldStatus = (maxReachR[i] <= oldA);
        maxReachR[i] = 0;
        for ( int j = i; j < n && j <= i + d; j++ ) {
            if ( maxReachR[j] <= a[j] )
                maxReachR[i] = max( maxReachR[i], a[j] );
        }
        int newStatus = (maxReachR[i] <= a[i]);
        
        if ( oldStatus == newStatus && !first )
            continue;
            
        for ( int j = i - 1; j >= 0 && j >= i - d; j-- ) {
            if ( !vis[j] )
                q.push( { j, a[j], false } );
            vis[j] = true;
        }
    }
}

void updateValue( int index, int newValue ) {
    int oldA = a[index];
    a[index] = newValue;
    calcL( index, oldA, true );
    calcR( index, oldA, true );
}

bool isWinning( int startIndex ) {
    if ( max( maxReachL[startIndex], maxReachR[startIndex] ) == a[startIndex] )
        return false;
    return true;
}
