#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 4e5;
bool vis[MAX_N];
long long a[MAX_N];
long long b[MAX_N];
vector<pair<int, int>> desc[MAX_N];
map<int, map<int, int>> countGreater;
map<int, int> maxim;
vector<int> adj[MAX_N];

vector<int> pos, val;
void dfs( int u, int l ) {
	vis[u] = true;
	if ( u < l ) {
		pos.push_back( u );
		val.push_back( u );
	}
	for ( int v: adj[u] ) {
		if ( !vis[v] )
			dfs( v, l );
	}
}

vector<int> solve( int n, int k ) {
	vector<int> ans( n );
	
	countGreater.clear();
	maxim.clear();
	for ( int i = 0; i < 2 * n; i++ ) {
		desc[i].clear();
		adj[i].clear();
		vis[i] = false;
	}
	for ( int i = 0; i < n; i++ ) {
		int x = a[i], d = 2;
		while ( d * d <= x ) {
			int p = 0;
			while ( x % d == 0 ) {
				p++;
				x /= d;
			}
			if ( p > 0 )
				desc[i].push_back( { d, p } );
			d++;
		}
		if ( x > 1 ) 
			desc[i].push_back( { x, 1 } );
				
		for ( auto p: desc[i] ) {
			countGreater[p.first][p.second]++;
			maxim[p.first] = max( maxim[p.first], p.second );
		}
	}
		
	for ( auto p: countGreater )
		countGreater[p.first][0] += 0;
	for ( auto p: countGreater ) {
		int cnt = 0;
		for ( auto q: p.second ) {
			cnt += q.second;
			countGreater[p.first][q.first] = cnt;
		}
		for ( auto q: p.second ) 
			countGreater[p.first][q.first] = cnt - countGreater[p.first][q.first];
	}
		
	for ( int i = 0; i < n; i++ ) {
		b[i] = a[i];
		for ( int j = 0; j < (int)desc[i].size(); j++ ) {
			auto p = desc[i][j];
			int d = p.first;
			if ( countGreater[d][p.second] < k ) {
				if ( countGreater[d][0] >= k ) {
					while ( p.second <= maxim[d] )  {
						p.second++;
						b[i] *= d;
					}
				} else {
					while ( p.second > 0 )  {
						p.second--;
						b[i] /= d;
					}
				}
						
			}
		}
	}
	unordered_map<long long, int> vert;
	for ( int i = 0; i < n; i++ ) 
		vert[b[i]] = 0;
	int cnt = n;
	for ( auto p: vert )
		vert[p.first] = cnt++;
	for ( int i = 0; i < n; i++ ) {
		adj[i].push_back( vert[b[i]] );
		adj[vert[b[i]]].push_back( i );
	}
		
	for ( int i = 0; i < n; i++ ) {
		if ( !vis[i] ) {
			pos.clear();
			val.clear();
			dfs( i, n );
			sort( pos.begin(), pos.end() );
			sort( val.begin(), val.end(), []( int i, int j ) {
				return a[i] < a[j];
			} );
				
			for ( int j = 0; j < (int)pos.size(); j++ )
				ans[pos[j]] = a[val[j]];
		}
	}
	
	return ans;
}

signed main() {
	cin.tie( NULL );
	ios_base::sync_with_stdio( false );
	int t;
	
	cin >> t;
	while ( t-- ) {
		int n, k, x;
		cin >> n >> k >> x;
		
		for ( int i = 0; i < n; i++ ) 
			cin >> a[i];
			
		vector<int> ans = solve( n, k );
		for ( int i = 0; i < n; i++ ) {
			a[i] *= x;
			vector<int> v = solve( n, k );
			ans = min( ans, v );
			a[i] /= x;
		}
		
		for ( int i = 0; i < n; i++ )
			cout << ans[i] << " ";
		cout << "\n";
	}
	
	return 0;
}
