#include <iostream>
#include <iomanip>
#include <vector>
#include <cassert>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ordered_set(x) tree<x, null_type, less<x>, rb_tree_tag, tree_order_statistics_node_update>
#define MAXN 500000
#define MAXM 500000

int n, m, k, x, v[MAXM+5], vi, passes[MAXN+5], euler[2*MAXN+5], t, lastEulerPoz, nrGottem;
bool gottem[2*MAXN+5];
long long sumaSz;
int p[MAXN+5], sz[MAXN+5], ch1[MAXN+5];
vector<int> nb[MAXN+5], ch[MAXN+5], eulerPoz[MAXN+5], todo, aux;
set<int> activeEulerPoz[MAXN+5];
set<int>::iterator it;

void dfs1(int node)
{
    sz[node] = 1;
    int nrch = 0;
    bool seenParent = false;
    for (auto x : nb[node]) {
        if (!p[x]) {
            nrch++;
            if (seenParent) {
                ch[node].push_back(x);
            }
            p[x] = node;
            dfs1(x);
            sz[node] += sz[x];
        }
        else {
            seenParent = true;
            ch1[node] = nrch;
        }
    }
    for (auto x : nb[node]) {
        if (p[x] == node) {
            ch[node].push_back(x);
        }
        else {
            break;
        }
    }
}
void dfs2(int node)
{
    if (node != 1) {
        euler[++t] = node;
        eulerPoz[node].push_back(t);
    }
    for (auto x : ch[node]) {
        dfs2(x);
        euler[++t] = node;
        eulerPoz[node].push_back(t);
    }
}

void dfsStupid(int node)
{
    assert(passes[node] <= 1);
    if (node == 1) {
        passes[node] = 2;
        for (int i = 0; i < ch[node].size(); i++) {
            dfsStupid(ch[node][i]);
            gottem[eulerPoz[node][i]] = true;
            nrGottem++;
            activeEulerPoz[node].insert(eulerPoz[node][i]);
        }
        return;
    }
    if (!passes[node]) {
        passes[node] = 1;
        aux.push_back(node);
        gottem[eulerPoz[node][0]] = true;
        nrGottem++;
        activeEulerPoz[node].insert(eulerPoz[node][0]);
        for (int i = ch[node].size() - ch1[node]; i < ch[node].size(); i++) {
            dfsStupid(ch[node][i]);
            gottem[eulerPoz[node][i+1]] = true;
            nrGottem++;
            activeEulerPoz[node].insert(eulerPoz[node][i+1]);
        }
        return;
    }
    passes[node] = 2;
    for (int i = 0; i < ch[node].size() - ch1[node]; i++) {
        dfsStupid(ch[node][i]);
        gottem[eulerPoz[node][i+1]] = true;
        nrGottem++;
        activeEulerPoz[node].insert(eulerPoz[node][i+1]);
    }
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        cin >> k;
        for (int j = 1; j <= k; j++) {
            cin >> x;
            nb[i].push_back(x);
        }
    }
    for (int i = 1; i <= m; i++) {
        cin >> v[i];
    }
    p[1] = 1;
    dfs1(1);
    dfs2(1);

    sumaSz = 1;
    passes[1] = 1;
    todo.push_back(1);
    vi = 1;
    while (vi <= m) {
        sumaSz = sumaSz + nrGottem;
        for (auto x : todo) {
            dfsStupid(x);
        }
        todo.clear();
        swap(todo, aux);
        lastEulerPoz = -1;
        while (vi <= m && (it = activeEulerPoz[v[vi]].upper_bound(lastEulerPoz)) != activeEulerPoz[v[vi]].end()) {
            lastEulerPoz = (*it);
            vi++;
        }
    }
    for (int i = 1; i <= lastEulerPoz; i++) {
        if (gottem[i]) {
            sumaSz++;
        }
    }
    cout << sumaSz;
    return 0;
}
