#include "game.h"
#include <deque>

using namespace std;

#define MAXN 200010
#define BSIZE 316

int n, nrb, bmap[MAXN+BSIZE+5], a[MAXN+BSIZE+5], i, d, pr[MAXN+BSIZE+5], pl[MAXN+BSIZE+5], nrupd;
int bpr[MAXN+BSIZE+5], bpl[MAXN+BSIZE+5]; /// out of the bucket
bool ans[MAXN+BSIZE+5];

void calcPr(int i)
{
    pr[i] = min(i+d, n) + 1;
    for (int j = i+1; j <= min(i+d, n); j++) {
        if (a[j] > a[i]) {
            pr[i] = j;
            break;
        }
    }
    bpr[i] = pr[i];
    if (bpr[i] <= bmap[i] * BSIZE) bpr[i] = bpr[bpr[i]];
}
void calcPl(int i)
{
    pl[i] = max(1, i-d) - 1;
    for (int j = i-1; j >= max(1, i-d); j--) {
        if (a[j] > a[i]) {
            pl[i] = j;
            break;
        }
    }
    bpl[i] = pl[i];
    if (bpl[i] > (bmap[i]-1) * BSIZE) bpl[i] = bpl[bpl[i]];
}

void calcInitialAns()
{
    int i = 1;
    for (int j = 2; j <= n; j++) {
        while (pr[i] < j) i = pr[i];
        if (i >= j-d && a[i] > a[j]) ans[j] = true;
    }
    i = n;
    for (int j = n-1; j >= 1; j--) {
        while (pl[i] > j) i = pl[i];
        if (i <= j+d && a[i] > a[j]) ans[j] = true;
    }
}

void init(vector<int> A, int D)
{
    n = A.size();
    for (int i = 1; i <= n; i++) {
        a[i] = A[i-1];
    }
    d = D;
    nrb = (n + BSIZE - 1) / BSIZE;
    for (int bucket = 1; bucket <= nrb; bucket++) {
        for (int i = (bucket-1) * BSIZE + 1; i <= bucket * BSIZE; i++) {
            bmap[i] = bucket;
        }
    }

    pl[0] = bpl[0] = 0;
    pr[n+1] = bpr[n+1] = n+1;
    for (int i = 1; i <= n; i++) {
        calcPl(i);
    }
    for (int i = n; i >= 1; i--) {
        calcPr(i);
    }
    calcInitialAns();
}

void updateValue(int index, int newValue)
{
    nrupd++;
    index++;
    a[index] = newValue;
    for (int i = index; i >= max(1, index-d); i--) {
        calcPr(i);
    }
    for (int i = index; i <= min(n, index+d); i++) {
        calcPl(i);
    }
}

bool isWinning(int startIndex)
{
    startIndex++;
    if (!nrupd) {
        return ans[startIndex];
    }
    if (startIndex != 1) {
        int i = 1;
        while (bpr[i] < startIndex) {
            i = bpr[i];
        }
        while (pr[i] < startIndex) {
            i = pr[i];
        }
        if (i >= startIndex - d && a[i] > a[startIndex]) return true;
    }
    if (startIndex != n) {
        int i = n;
        while (bpl[i] > startIndex) {
            i = bpl[i];
        }
        while (pl[i] > startIndex) {
            i = pl[i];
        }
        if (i <= startIndex + d && a[i] > a[startIndex]) return true;
    }
    return false;
}
