#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <chrono>
#include <random>

using namespace std;

int t, n, k, x, i, a[100010], apoz[100010], b[100010], d, ans;
bool viz[100010];

int euclid(int a, int b)
{
    int c;
    while (b) {
        c = a%b;
        a = b;
        b = c;
    }
    return a;
}

bool aPozCmp(int x, int y)
{
    return a[x] < a[y];
}

bool isValid()
{
    for (int mask = 0; mask < (1 << n); mask++) {
        int da = 0, db = 0, cnt = 0;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                cnt++;
                da = euclid(da, a[i+1]);
                db = euclid(db, b[i+1]);
            }
        }
        if (cnt == k && da != db) return false;
    }
    return true;
}

bool genPerm(int index)
{
    if (index > n) {
        return isValid();
    }
    for (int i = 1; i <= n; i++) {
        int poz = apoz[i];
        if (!viz[poz]) {
            viz[poz] = true;
            b[index] = a[poz];
            bool rez = genPerm(index+1);
            viz[poz] = false;
            if (rez) return true;
        }
    }
    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> t;
    while (t--) {
        cin >> n >> k >> x;
        for (int i = 1; i <= n; i++) {
            cin >> a[i];
            apoz[i] = i;
        }
        sort(apoz+1, apoz+n+1, aPozCmp);
        genPerm(1);
        for (int i = 1; i <= n; i++) {
            cout << b[i] << ' ';
        }
        cout << '\n';
    }
    return 0;
}
