#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 500000;
const int M_MAX = 500000;

int N, M;
vector <int> out[N_MAX + 2];
int A[M_MAX + 2];

int parent[N_MAX + 2];
int depth[N_MAX + 2];

vector <int> times[N_MAX + 2];
int curr_time;

void dfs (int u) {
    times[u].push_back(++curr_time);
    bool flag = false;
    for (int v : out[u]) {
        depth[v] = depth[u] + 1;
        if (v == parent[u]) {
            flag = true;
        } else if (flag == true) {
            parent[v] = u;
            dfs(v);
            times[u].push_back(++curr_time);
        }
    }
    for (int v : out[u]) {
        if (v == parent[u]) {
            break;
        }
        parent[v] = u;
        dfs(v);
        times[u].push_back(++curr_time);
    }
}

int curr[N_MAX + 2];

bool seen[N_MAX + 2];
vector <int> unsat;
int cnt_seen;

void sim (int root) {
    int u = root;
    do {
        if (seen[u] == false) {
            seen[u] = true;
            cnt_seen++;
        }
        int v = out[u][curr[u]];
        if (++curr[u] == (int) out[u].size()) {
            curr[u] = 0;
        } else if (v == parent[u]) {
            unsat.push_back(root);
        }
        u = v;
    } while (u != root || curr[root] > 0);
}

int first_time (int u, int t) {
    int l = 0, r = (int) times[u].size();
    while (l < r) {
        int mid = (l + r) / 2;
        if (t < times[u][mid]) {
            r = mid;
        } else {
            l = mid + 1;
        }
    }
    return (l < (int) times[u].size() ? times[u][l] : -1);
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> N >> M;
    for (int u = 1; u <= N; u++) {
        int cnt;
        cin >> cnt;
        out[u].resize(cnt);
        for (int &v : out[u]) {
            cin >> v;
        }
    }
    for (int i = 1; i <= M; i++) {
        cin >> A[i];
    }
    dfs(1);
    unsat.push_back(1);
    int q = 1;
    long long answer = 1;
    while (true) {
        vector <int> now = unsat;
        unsat.clear();
        for (int u : now) {
            sim(u);
        }
        int t = 0;
        while (seen[A[q]] == true) {
            t = first_time(A[q], t);
            if (t != -1) {
                q++;
            } else {
                break;
            }
        }
        if (q <= M) {
            answer += (cnt_seen - 1) * 2;
        } else {
            int old = answer;
            for (int u = 1; u <= N; u++) {
                if (seen[u] == true) {
                    for (int t1 : times[u]) {
                        if (t1 < t) {
                            answer += 2;
                        }
                    }
                }
            }
            answer -= depth[A[M]];
            break;
        }
    }
    cout << answer << "\n";

    return 0;
}
