#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 500000;
const int M_MAX = 500000;

int N, M;
vector <int> out[N_MAX + 2];
int A[M_MAX + 2];

int parent[N_MAX + 2];
int depth[N_MAX + 2];

vector <int> times[N_MAX + 2];
int bad_pref[N_MAX + 2];
int curr_time;

void dfs (int u) {
//    cout << "dfs(" << u << ")\n";
    times[u].push_back(++curr_time);
    bool flag = false;
    for (int v : out[u]) {
        depth[v] = depth[u] + 1;
        if (v == parent[u]) {
            flag = true;
        } else if (flag == true) {
            parent[v] = u;
            dfs(v);
            times[u].push_back(++curr_time);
//            cout << "add " << u << "\n";
        }
    }
    bad_pref[u] = (int) times[u].size();
    for (int v : out[u]) {
        if (v == parent[u]) {
            break;
        }
        parent[v] = u;
        dfs(v);
        times[u].push_back(++curr_time);
//        cout << "add " << u << "\n";
    }
}

int curr[N_MAX + 2];

bool seen[N_MAX + 2], sat[N_MAX + 2];
vector <int> unsat;
int cnt_seen;

void sim (int root) {
    int u = root;
    do {
//        cout << "  visit " << u << "\n";
        if (seen[u] == false) {
            seen[u] = true;
            cnt_seen++;
        }
        int v = out[u][curr[u]];
        if (++curr[u] == (int) out[u].size()) {
//            cout << "  winds around\n";
            curr[u] = 0;
            sat[u] = true;
        } else if (v == parent[u]) {
//            cout << "  unsatisfied\n";
            unsat.push_back(root);
        }
        u = v;
    } while (u != root || curr[root] > 0);
}

int first_time (int u, int t) {
    if (t < times[u][0]) {
        return times[u][0];
    }
    int l = (sat[u] == true ? 1 : bad_pref[u]);
    int r = (int) times[u].size();
    while (l < r) {
        int mid = (l + r) / 2;
        if (t < times[u][mid]) {
            r = mid;
        } else {
            l = mid + 1;
        }
    }
    return (l < (int) times[u].size() ? times[u][l] : -1);
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> N >> M;
    for (int u = 1; u <= N; u++) {
        int cnt;
        cin >> cnt;
        out[u].resize(cnt);
        for (int &v : out[u]) {
            cin >> v;
        }
    }
    for (int i = 1; i <= M; i++) {
        cin >> A[i];
    }
    dfs(1);
    unsat.push_back(1);
    int q = 1;
    long long answer = 0;
    while (true) {
//        cout << "ROUND!\n";
        vector <int> now = unsat;
        unsat.clear();
        for (int u : now) {
//            cout << "explore " << u << "\n";
            sim(u);
        }
        int t = 0;
        while (seen[A[q]] == true) {
            t = first_time(A[q], t);
            if (t != -1) {
                q++;
            } else {
                break;
            }
        }
        if (q <= M) {
            answer += (cnt_seen - 1) * 2;
//            cout << "full tour costs " << (cnt_seen - 1) * 2 << "\n";
//            cout << "solved the first " << q - 1 << " visits\n";
        } else {
            int old = answer;
            for (int u = 1; u <= N; u++) {
                if (seen[u] == true) {
                    if (times[u][0] <= t) {
//                        cout << u << " at " << times[u][0] << "\n";
                        answer++;
                    }
                    for (int i = (sat[u] == true ? 1 : bad_pref[u]);
                    i < (int) times[u].size(); i++) {
                        if (times[u][i] <= t) {
//                            cout << u << " at " << times[u][i] << "\n";
                            answer++;
                        }
                    }
                }
            }
//            cout << "partial tour costs " << answer - old << "\n";
            break;
        }
    }
    cout << answer << "\n";

    return 0;
}
