#include <bits/stdc++.h>
#include "game.h"

using namespace std;

const int N_MAX = 200000;
const int Q_MAX = 200000;

int N, D;
int A[N_MAX];

int seg_tree[N_MAX * 4 + 2];

int get_max (const int &i, const int &j) {
    return (A[i] > A[j] ? i : j);
}

void build (int node, int l, int r) {
    if (l == r) {
        seg_tree[node] = l;
        return;
    }
    int mid = (l + r) / 2;
    int left = node * 2, right = node * 2 + 1;
    build(left, l, mid);
    build(right, mid + 1, r);
    seg_tree[node] = get_max(seg_tree[left], seg_tree[right]);
}
void build () {
    build(1, 0, N - 1);
}
void update (int node, int l, int r, int pos) {
    if (l == r) {
        seg_tree[node] = l;
        return;
    }
    int mid = (l + r) / 2;
    int left = node * 2, right = node * 2 + 1;
    if (pos <= mid) {
        update(left, l, mid, pos);
    } else {
        update(right, mid + 1, r, pos);
    }
    seg_tree[node] = get_max(seg_tree[left], seg_tree[right]);
}
void update (int pos) {
    update(1, 0, N - 1, pos);
}

int query (int node, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return seg_tree[node];
    }
    int mid = (l + r) / 2;
    int left = node * 2, right = node * 2 + 1;
    if (ql <= mid && mid + 1 <= qr) {
        return get_max(query(left, l, mid, ql, qr),
                       query(right, mid + 1, r, ql, qr));
    } else if (qr <= mid) {
        return query(left, l, mid, ql, qr);
    } else {
        return query(right, mid + 1, r, ql, qr);
    }
}
int query (int ql, int qr) {
    return query(1, 0, N - 1, ql, qr);
}

bool win[N_MAX];

void solve () {
    fill(win, win + N, true);
    win[seg_tree[1]] = false;
    int x = seg_tree[1];
    while (x >= D + 1) {
        x = query(max(0, x - D * 2 - 1), x - D - 1);
        win[x] = false;
    }
    x = seg_tree[1];
    while (x <= N - D) {
        x = query(x + D + 1, min(N - 1, x + D * 2 + 1));
        win[x] = false;
    }
}

void init (vector <int> _A, int _D) {
    N = (int) _A.size(); D = _D;
    for (int i = 0; i < N; i++) {
        A[i] = _A[i];
    }
    build();
    solve();
}

void updateValue (int pos, int val) {
    A[pos] = val;
    update(pos);
    solve();
}
bool isWinning (int pos) {
    return win[pos];
}

