#include <bits/stdc++.h>
#include "game.h"
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll 

#define sz(x) ((int)(x).size())
using pii = pair<int,int>;
using tii = tuple<int,int,int>;

const int nmax = 2e5 + 5;
const int dmax = 25 + 1;
#define left asda
#define right asdaadas

int left[4 * nmax][dmax];
int right[4 * nmax][dmax];

int v[nmax];
int dummy[nmax];

int D;
#define threshold (D * 3 + 2)

void filldummy(vector<int> idx, int l, int r) {
	for(int x = l; x <= r; x++) dummy[x] = 0;
	for(auto a : idx) {
		if(!(l <= a && a <= r)) continue;
		if(dummy[a] == 0) {
			for(int j = max(l, a - D); j <= min(a + D, r); j++)
				dummy[j] = 1;
			dummy[a] = 0;
		}
	}
	return;
}


void update(int node, int cl, int cr, int p, bool pula = 0) {
	if(!(cl <= p && p <= cr) && !pula) return;
	
	if(cr - cl <= threshold) {
		vector<int> idx;
		for(int i = cl; i <= cr; i++)
			idx.emplace_back(i);
		sort(all(idx), [&](int a, int b) { return v[a] > v[b]; });
		
		for(int i = cl, T = 0; T <= D; i++, T++) {
			filldummy(idx, i, cr);
			left[node][T] = cr;
			while(dummy[left[node][T]] == 1) left[node][T]--;
		}
		
		for(int i = cr, T = 0; T <= D; i--, T++) {
			filldummy(idx, cl, i);
			right[node][T] = cl;
			while(dummy[right[node][T]] == 1) right[node][T]++;
		}
		return;
	}
	
	int mid = cl + cr >> 1;
	update(2 * node, cl, mid, p, pula);
	update(2 * node + 1, mid + 1, cr, p, pula);
	
	auto cover = [&](int start, int p) {
		return D - abs(start - p) + 1;
	};
	
	for(int T = 0; T <= D; T++) { // cut din dreapta
		int midFromRight = right[2 * node + 1][T];
		int midFromLeft = left[2 * node][0];
		if(v[midFromRight] > v[midFromLeft]) right[node][T] = right[2 * node][cover(midFromRight, mid)];
		else right[node][T] = right[2 * node][0];
	}
	
	for(int T = 0; T <= D; T++) { // cut din stanga
		int midFromRight = right[2 * node + 1][0];
		int midFromLeft = left[2 * node][T];
		if(v[midFromRight] > v[midFromLeft]) left[node][T] = left[2 * node + 1][0];
		else left[node][T] = left[2 * node + 1][cover(midFromLeft, mid + 1)];
	}
	
	return;
}

bool query(int node, int cl, int cr, int cutL, int cutR, int p) {
	if(cr - cl - (cutL + cutR) <= threshold) {
		// cerr << "jerpulea " << node << '\n';
		cl += cutL;
		cr -= cutR;
		vector<int> idx(cr - cl + 1);
		iota(all(idx), cl);
		sort(all(idx), [&](int a, int b) { return v[a] > v[b]; });
		filldummy(idx, cl, cr);
		return dummy[p];
	}
	
	auto cover = [&](int start, int p) {
		return D - abs(start - p) + 1;
	};
	
	int mid = cl + cr >> 1;
	
	int midFromRight = right[2 * node + 1][cutR];
	int midFromLeft = left[2 * node][cutL];
	
	// cerr << cl << ' ' << cr << '\t' << cl + cutL << ' ' << cr - cutR << '\t' << midFromLeft << ' ' <<  midFromRight << '\t' << v[midFromLeft] << ' ' << v[midFromRight] << '\t' << p << '\n';
	
	
	if(v[midFromRight] > v[midFromLeft]) {
		if(p == midFromRight) return 0;
		if(abs(midFromRight - p) <= D) return 1;
		if(p <= mid)
			return query(2 * node, cl, mid, cutL, cover(midFromRight, mid), p);
		else
			return query(2 * node + 1, mid + 1, cr, 0, cutR, p);
	}
	else {
		if(p == midFromLeft) return 0;
		if(abs(midFromLeft - p) <= D) return 1;
		if(p <= mid)
			return query(2 * node, cl, mid, cutL, 0, p);
		else
			return query(2 * node + 1, mid + 1, cr, cover(midFromLeft, mid + 1), cutR, p);
	}
}

int n;

void init(std::vector<int> A, int D_) {
	n = sz(A);
	D = D_;
	for(int i = 0; i < sz(A); i++) v[i] = A[i];
	update(1, 0, n - 1, 0, 1);
}
void updateValue(int index, int newValue) {
	v[index] = newValue;
	update(1, 0, n - 1, index);
}
bool isWinning(int startIndex) {
	return query(1, 0, n - 1, 0, 0, startIndex);
}
