#ifndef DLOCAL
	#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#endif
	
#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll 

#define sz(x) ((int)(x).size())
using pii = pair<int,int>;
using tii = tuple<int,int,int>;

const int vmax = 32e3 + 5;
const int nmax = 1e5 + 5;

bitset<vmax> ciur;
vector<int> prime;

vector<pii> desc[nmax];
int n, k;
vector<ll> v;

vector<ll> generate() {
    unordered_map<int,vector<int>> exps;
    unordered_map<int, int> market_cap;
    for(int i = 0; i < n; i++) {
        for(auto [a, b] : desc[i])
            exps[a].emplace_back(b);
    }
    
    for(auto [a, v] : exps) {
        if(sz(v) < k) market_cap[a] = 0;
        else {
            sort(all(v));
            market_cap[a] = rbegin(v)[k - 1];
        }
    }
    
    vector<ll> atribute(n);
    unordered_map<ll, vector<ll>> tval;
    for(int i = 0; i < n; i++) {
        int act = 1;
        for(auto [d, cnt] : desc[i]) {
            cnt = min(cnt, market_cap[d]);
            while(cnt) act *= d, cnt--;
        
        }
        
        atribute[i] = act;
        tval[act].emplace_back(v[i]);
    }
    for(auto &[a, b] : tval) sort(all(b), greater<ll>());
    vector<ll> REZ;
    for(auto x : atribute) {
        REZ.emplace_back(tval[x].back());
        tval[x].pop_back();
    }
    return REZ;
}

void testcase() {
    int X;
    cin >> n >> k >> X;
    v.resize(n);
    for(int i = 0; i < n; i++) {
        desc[i].clear();
        int a;
        cin >> a;
        v[i] = a;
        for(auto d : prime) {
            if(d * d > a) break;
            if(a % d == 0) {
                int cnt = 0;
                while(a % d == 0) cnt++, a /= d;
                desc[i].emplace_back(d, cnt);
            }
        }
        if(a > 1) {
            desc[i].emplace_back(a, 1);
        }
    }
    
    auto R = generate();
    
    if(X != 1) {	
        for(int i = 0; i < 4; i++) {
            bool fail = 0;
            for(auto &[a, b] : desc[i])
                if(a == X) fail = 1, b++;
            if(!fail) {
                desc[i].emplace_back(X, 1);
            }
            v[i] *= X;
            
            // for(auto x : generate()) cerr << x << ' ';
            // cerr << '\n';
            
            R = min(generate(), R);
            
            for(auto &[a, b] : desc[i])
                if(a == X) b--;
            if(!fail) desc[i].pop_back();
            v[i] /= X;
        }
    }
    
    for(auto x : R) cout << x << ' ';
    cout << '\n';
}

signed main() {
    for(int i = 2; i < vmax; i++) {
        if(ciur[i] == 0) {
            prime.emplace_back(i);
            for(int j = i * i; j < vmax; j += i) ciur[j] = 0;
        }
    }
    int T;
    cin >> T;
    while(T--) testcase();
}
