#include "game.h"
#include <algorithm>
#include <iostream>

//#define int __int128
//#define int long long
#define pii pair <int, int>
#define all(a) (a).begin(), (a).end()
#define fr first
#define sc second
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define vt vector
#define sz(x) (x).size()

using namespace std;

const int NMAX = 2e5;

vt <int> adj[NMAX + 1];
bool dp[NMAX + 1];

bool viz[NMAX + 1];
vt <int> topo;
void dfs(int node){
    viz[node] = 1;
    for(int vec : adj[node]){
        if(!viz[vec]){
            dfs(vec);
        }
    }
    topo.pb(node);
}

int n, D;
vt <int> A;

void init(vector<int> aa, int d){
    A = aa, D = d;
    n = sz(A);
    for(int i = 0; i < n; i++){
        for(int j = max(0, i - D); j <= min(n - 1, i + D); j++){
            if(A[i] < A[j]){
                adj[i].pb(j);
            }
        }
    }
    for(int i = 0; i < n; i++){
        if(!viz[i]){
            dfs(i);
        }
    }

    reverse(all(topo));

    for(int i = n - 1; i >= 0; i--){
        if(sz(adj[topo[i]]) == 0){
            dp[topo[i]] = 0;
        }else{
            bool andd = 1;
            for(int vec : adj[topo[i]]){
                andd &= dp[vec];
            }
            if(andd){
                dp[topo[i]] = 0;
            }else{
                dp[topo[i]] = 1;
            }
        }
    }
}

void updateValue(int index, int newValue){
    for(int i = 0; i < n; i++){
        adj[i].clear();
        dp[i] = 0;
        viz[i] = 0;
    }
    topo.clear();
    A[index] = newValue;

    for(int i = 0; i < n; i++){
        for(int j = max(0, i - D); j <= min(n - 1, i + D); j++){
            if(A[i] < A[j]){
                adj[i].pb(j);
            }
        }
    }


    for(int i = 0; i < n; i++){
        if(!viz[i]){
            dfs(i);
        }
    }

    reverse(all(topo));

    for(int i = n - 1; i >= 0; i--){
        if(sz(adj[topo[i]]) == 0){
            dp[topo[i]] = 0;
        }else{
            bool andd = 1;
            for(int vec : adj[topo[i]]){
                andd &= dp[vec];
            }
            if(andd){
                dp[topo[i]] = 0;
            }else{
                dp[topo[i]] = 1;
            }
        }
    }
}

bool isWinning(int startIndex){
    return dp[startIndex];
}

/*
6 2
1 7 4 9 30 2
2
2 0
2 1

8 1
1 2 3 4 5 6 7 8
8
2 0
2 1
2 2
2 3
2 4
2 5
2 6
2 7

8 1
8 7 6 5 4 3 2 1
8
2 0
2 1
2 2
2 3
2 4
2 5
2 6
2 7

*/
