#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using ll = long long;

//#define int __int128
//#define int long long
#define pii pair <int, int>
#define all(a) (a).begin(), (a).end()
#define fr first
#define sc second
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define vt vector

#define sz(x) (int)(x).size()

using namespace std;

const int NMAX = 1e5;

ll v[NMAX + 1];
vt <pii> facts[NMAX + 1];
ll base[NMAX + 1];

map <pii, int> f;

ll ans[NMAX + 1];

vt <ll> solve(int n, int k, int X, vt <ll> w, int changed){
    for(int i = 1; i <= n; i++){
        facts[i].clear();
        v[i] = w[i - 1];
    }

    for(int i = 1; i <= n; i++){
        if(i == changed){
            v[i] /= X;
            facts[i].pb({X, 1});
        }
        int div = 2, x = v[i];
        while(div * div <= x){
            if(x % div == 0){
                int p = 0;
                while(x % div == 0){
                    x /= div;
                    p++;
                }
                facts[i].pb({div, p});
            }
            div++;
        }
        if(x > 1){
            facts[i].pb({x, 1});
        }

        for(pii y : facts[i]){
            for(int j = 1; j <= y.sc; j++){
                f[{y.fr, j}]++;
            }
        }

        if(i == changed){
            v[i] *= X;
        }
    }

    vt <pair <ll, int>> aux;
    for(int i = 1; i <= n; i++){
        base[i] = 1;
        for(pii y : facts[i]){
            for(int j = 1; j <= y.sc; j++){
                if(f[{y.fr, j}] >= k){
                    base[i] *= y.fr;
                }
            }
        }

        aux.pb({base[i], i});
    }
    sort(all(aux));

    vt <ll> buff_val;
    vt <int> buff_pos;
    for(int i = 0; i < n; i++){
        buff_val.pb(v[aux[i].sc]);
        buff_pos.pb(aux[i].sc);
        if(i == n - 1 || aux[i].fr != aux[i + 1].fr){
            sort(all(buff_val));
            for(int j = 0; j < sz(buff_pos); j++){
                ans[buff_pos[j]] = buff_val[j];
            }

            buff_pos.clear();
            buff_val.clear();
        }
    }

    /// clear umap!!!
    for(int i = 1; i <= n; i++){
        for(pii y : facts[i]){
            for(int j = 1; j <= y.sc; j++){
                f[{y.fr, j}] = 0;
            }
        }
    }

    vt <ll> Ans;
    for(int i = 1; i <= n; i++){
        Ans.pb(ans[i]);
    }
    return Ans;
}

bool lexico(vt <ll> v1, vt <ll> v2){
    for(int i = 0; i < sz(v1); i++){
        if(v1[i] < v2[i]){
            return 1;
        }else if(v1[i] > v2[i]){
            return 0;
        }
    }

    return 0;
}

void Solve(){
    int n, k, X;
    cin >> n >> k >> X;

    vt <ll> a;

    for(int i = 1; i <= n; i++){
        int x;
        cin >> x;
        a.pb(x);
    }

    vt <ll> Ans = solve(n, k, X, a, -1);
    for(int i = 1; i <= n; i++){
        if(X == 1){
            break;
        }
        a[i - 1] *= X;
        vt <ll> tmp = solve(n, k, X, a, i);
        a[i - 1] /= X;

        if(lexico(tmp, Ans)){
            Ans = tmp;
        }
    }

    for(int i = 0; i < n; i++){
        cout << Ans[i] << ' ';
    }
    cout << '\n';
}


signed main(){

    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);

    int T;
    cin >> T;

    while(T--){
        Solve();
    }

    return 0;
}

/*

1
4 2 3
7 3 6 9

1
3 2 1
2 6 4
*/
