#include <iostream>
#include <deque>
#include <vector>

using namespace std;

const int N = 1e3 + 7, INF = 1e9 + 7;

deque < int > nevizitate;
deque < int > adia[N];

bool fixat[N];
int pozCycle[N];

int n;

int moves;

void checkVizitate(int nod) {
    if (nevizitate.front() == nod)
        nevizitate.pop_front();
    if (nevizitate.empty())
        cout << moves, exit(0);
}

bool eReady() {
    for (int i = 2; i <= n; ++i)
        if (!fixat[i])
            return 0;
    return 1;
}

vector < int > eCycle;

void simulare(int nod = 1, int t = 0, bool e = 0) {
    if (e)
        eCycle.push_back(nod);
    if (nod == 1 && eReady() && eCycle.size() != 1) ///sa nu opresc calcularea ciclului asa instant
        return;

    ++moves;
    checkVizitate(nod);

    if (adia[nod].front() == t)
        fixat[nod] = 1;
    else
        fixat[nod] = 0;

    adia[nod].push_back(adia[nod].front());
    adia[nod].pop_front();
    simulare(adia[nod].back(), nod, e);
}

int main()
{
    int m;
    cin >> n >> m;
    for (int u = 1; u <= n; ++u) {
        int k;
        cin >> k;
        while (k--) {
            int v;
            cin >> v;
            adia[u].push_back(v);
        }
    }
    while (m--) {
        int nod;
        cin >> nod;
        nevizitate.push_back(nod);
    }
    simulare();
//    assert(eulerReady());
    for (int u = 1; u <= n; ++u)
        pozCycle[u] = INF;
    for (int i = 0; i < eCycle.size(); ++i)
        pozCycle[eCycle[i]] = min(pozCycle[eCycle[i]], i + 1);

    int lastPoz(0);
    while (nevizitate.size()) {
        int u = nevizitate.front();
        nevizitate.pop_front();
        if (pozCycle[u] > lastPoz)
            moves += pozCycle[u] - lastPoz;
        else
            moves += eCycle.size() - lastPoz + pozCycle[u];
        lastPoz = pozCycle[u];
    }
    cout << moves;
    return 0;
}
