#include <iostream>
#include <deque>
#include <vector>

using namespace std;

const int N = 1e3 + 7, INF = 1e9 + 7;

deque < int > nevizitate;
deque < int > adia[N];

bool fixat[N];
int nextPoz[2 * N][N];

int n;

int moves;

void checkVizitate(int nod) {
    if (nevizitate.front() == nod)
        nevizitate.pop_front();
    if (nevizitate.empty())
        cout << moves, exit(0);
}

bool eReady() {
    for (int i = 2; i <= n; ++i)
        if (!fixat[i])
            return 0;
    return 1;
}

vector < int > eCycle;

int t[N];
bool viz[N];

void simulare(bool e = 0, int nod = 1) {
    if (nod == 1 && eReady() && (e ^ eCycle.size() == 0)) ///cand e = 0 sa se op, cand e = 1 cand se term
        return;

    ++moves;
    checkVizitate(nod);
    viz[nod] = 1;

//    cout << nod << ' ';
//    cout.flush();

    if (e)
        eCycle.push_back(nod);

    if (adia[nod].front() == t[nod])
        fixat[nod] = 1;
    else
        fixat[nod] = 0;

    adia[nod].push_back(adia[nod].front());
    adia[nod].pop_front();
    if (!viz[adia[nod].back()])
        t[adia[nod].back()] = nod;
    simulare(e, adia[nod].back());
}

int main()
{
    int m;
    cin >> n >> m;
    for (int u = 1; u <= n; ++u) {
        int k;
        cin >> k;
        while (k--) {
            int v;
            cin >> v;
            adia[u].push_back(v);
        }
    }
    while (m--) {
        int nod;
        cin >> nod;
        nevizitate.push_back(nod);
    }
    simulare();
//    cout << '\n';
//    assert(eulerReady());
    simulare(1);
//    cout << '\n';
    for (int i = 1; i <= n; ++i)
        for (int j = 0; j < eCycle.size(); ++j)
            nextPoz[j + 1][i] = INF;

    for (int i = 0; i < eCycle.size(); ++i)
        for (int j = 0; j <= i; ++j)
            nextPoz[j + 1][eCycle[i]] = min(nextPoz[j + 1][eCycle[i]], i + 1);

    int lastPoz(0);
    while (nevizitate.size()) {
        int u = nevizitate.front();
//        cout << u << ' ' << nextPoz[lastPoz + 1][u] << '\n';
        if (nextPoz[lastPoz + 1][u] != INF)
            moves += nextPoz[lastPoz + 1][u] - lastPoz, nevizitate.pop_front(), lastPoz = nextPoz[lastPoz + 1][u];
        else
            moves += eCycle.size() - lastPoz, lastPoz = 0;
    }
    cout << moves;
    return 0;
}
/**
4 10
1 2
2 1 3
2 2 4
1 3
4 3 2 1 4 3 2 1 4 3

4 4
2 2 3
1 1
2 1 4
1 3
2 1 1 4
*/
