#include "game.h"
#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>

using namespace std;

const int N = 2e5 + 7;

bool loser[N];
vector < int > cost;
int dist;

void solveLoser() {
    vector < int > leBonBon(cost.size());
    iota(leBonBon.begin(), leBonBon.end(), 0);
    sort(leBonBon.rbegin(), leBonBon.rend(), [&cost](int a, int b) {
            return cost[a] < cost[b];
        });
    for (int i : leBonBon) {
        for (int j = max(i - dist, 0); j <= min((int)cost.size() - 1, i + dist); ++j)
            if (cost[j] > cost[i])
                loser[i] |= loser[j];
        loser[i] ^= 1;
    }
}

void init(vector < int > A, int D) {
    cost = A;
    dist = D;
    solveLoser();
}

void updateValue(int index, int newValue) {
    cost[index] = newValue;
    solveLoser();
}

bool isWinning(int startIndex) {
    return !loser[startIndex];
}
