#include <bits/stdc++.h>

using namespace std;

using vi = vector<int>;
using ll = long long;

#define int ll

struct tree {
    int n;

    vi euler;
    vi blc;

    vector<vi> L;
    vector<vi> ord;

    vector<vi> DeActivat; /// pozitii de activat pt fiecare tura
    
    vector<set<int> > Poz;

    tree(int N, vector<vi> ord0) : n(N), L(N), ord(ord0), Poz(N) {}

    void add_edge(int u, int v) {
        L[u].push_back(v);
        L[v].push_back(u);
    }

    void init() {
        for(int i = 0; i < n; ++i) {
            L[i] = ord[i];
        }
        blc.resize(2 * n + 2, 0);
        function<void(int, int)> dfs = [&](int u, int p) {
            euler.push_back(u);
            int ok = 0;
            if(p != -1)
                ++blc[int(euler.size()) - 1];
            for(auto it : L[u]) {
                if(it == p) {
                    ok = 1;
                } else {
                    if(ok) {
                        dfs(it, u);
                        euler.push_back(u);
                    }
                }   
            }
            if(p != -1)
                --blc[int(euler.size()) - 1];
            for(auto it : L[u]) {
                if(it == p) {
                    break;
                } else {
                    dfs(it, u);
                    euler.push_back(u);
                }   
            }
        };
        dfs(0, -1);
        for(int i = 1; i < blc.size(); ++i) {
            blc[i] += blc[i - 1];
        }
        euler.pop_back(); // ultimul nu se pune
        blc.resize(euler.size());

        DeActivat.resize(n + 3);
        for(int i = 0; i < blc.size(); ++i) {
            DeActivat[blc[i]].push_back(i);
        }

//        for(auto it : euler)
//            cout << it << " ";
//        cout << "\n";
//        for(auto it : blc)
//            cout << it << " ";
//        cout << "\n";
    }

    int p = 0, nrtot = 0;
    int re = 0;

    void enable(int v) {
        p = 0;
        re += nrtot; /// ai facut o tura
        if(v >= DeActivat.size()) {
            return;
        }
        for(auto it : DeActivat[v]) {
            Poz[euler[it]].insert(it);
            ++nrtot;
        }
    }

    int get_urm(int val) {
        auto it = Poz[val].lower_bound(p);
        if(it == Poz[val].end()) return 0;
        p = *it;
        ++p;
        return 1;
    }

    int get_re() {
        for(auto S : Poz) {
            for(auto it : S)
                if(it < p) ++re;
        }
        return re;
        ///sper ca e suficient
    }
};

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vi> ord(n);
    for(int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for(int j = 0; j < k; ++j) {
            int v;
            cin >> v;
            --v;
            ord[i].push_back(v);
        }
    }
    tree T(n, ord);
    T.init();
    vi P(m);
    for(int i = 0; i < m; ++i) {
        cin >> P[i];
        --P[i];
    }

    int v = 0;
    for(auto it : P) {
        while(!T.get_urm(it)) T.enable(v++);
    }
    cout << T.get_re() << "\n";
    return 0;
}
