#include <bits/stdc++.h>
using namespace std;

const int sieveN = 1e5 + 69;
int sieve[sieveN] = {};
int64_t pr[sieveN];
int primecnt = 0;

const int HP = 31;
int64_t HPOW[1200] = {};
const int mod = 1e9 + 7;

const int N = 1e5 + 3;
int ar[N];

void pre() {
    HPOW[0] = 1;
    for (int i = 1; i < 1200; ++i) {
        HPOW[i] = 1ll * HPOW[i - 1] * HP % mod;
    }
    iota(sieve, sieve + sieveN, 0);
    for (int i = 2; i * i <= sieveN; ++i) {
        if (sieve[i] == i) {
            pr[primecnt++] = i;
        }
        else continue;
        for (int j = 2 * i; j < sieveN; j += i) {
            sieve[j] = i;
        }
    }
}

vector<pair<int, int>> factorize(int A) {
    vector<pair<int, int>> res;
    for (int j = 0; j < primecnt && pr[j]*pr[j] <= A; ++j) {
        int c = 0;
        while (A % pr[j] == 0) {
            A /= pr[j];
            ++c;
        }
        if (c > 0) {
            res.push_back({pr[j], c});
        }
    }
    if (A > 1) res.push_back({A, 1});
    return res;
}

vector<int> get_divs(int A) {
    vector<int> x{1};
    vector<pair<int, int>> facs = factorize(A);
    for (int i = 0; i < facs.size(); ++i) {
        int p = 1;
        int ptr = x.size();
        for (int j = 0; j < facs[i].second; ++j) {
            p *= facs[i].first;
            for (int k = 0; k < ptr; ++k) {
                x.push_back(x[k] * p);
            }
        }
    }
    return x;
}

void solve() {
    int n, k, x;
    cin >> n >> k >> x;
    map<int, int> cnt;
    map<int, vector<int>> tied;
    map<int, vector<int>> divs;
    vector<int> ha(n);
    for (int i = 0; i < n; ++i) {
        cin >> ar[i];
        vector<int> y;
        if (divs.find(ar[i]) == divs.end()) {
            y = get_divs(ar[i]);
            divs[ar[i]] = y;
        }
        else
            y = divs[ar[i]];
        for (int j : y) cnt[j]++;
    }
    for (int i = 0; i < n; ++i) {
        int A = ar[i];
        vector<int> y{1};
        int hptr = 0;
        int point = 1;
        int64_t tieHash = 0;
        for (int j = 0; j < primecnt && pr[j]*pr[j] <= A; ++j) {
            int P = 1;
            point = y.size();
            while (A % pr[j] == 0) {
                P *= pr[j];
                for (int z = 0; z < point; ++z) {
                    y.push_back(y[z] * P);
                    if (cnt[y.back()] >= k) {
                        tieHash += 1ll * y.back() * HPOW[hptr] % mod;
                        tieHash %= mod;
                        hptr++;
                    }  
                }
                A /= pr[j];
            }
        }
        if (A > 1) {
            int P = A;
            for (int z = 0; z < point; ++z) {
                int now = y[z] * P;
                if (cnt[now] >= k) {
                    tieHash += 1ll * now * HPOW[hptr] % mod;
                    tieHash %= mod;
                    hptr++;
                }  
            }
        }
        // cerr << tieHash << " ";
        tied[tieHash].push_back(i);
        // cerr << "\n";
    }
    vector<pair<int, int>> res;
    for (auto [key, val] : tied) {
        vector<int> init_inds = val;
        sort(val.begin(), val.end(), [&] (int a, int b) {
            return ar[a] < ar[b];
        });
        for (int i = 0; i < val.size(); ++i) {
            res.push_back({ar[val[i]], init_inds[i]});
        }
    }
    sort(res.begin(), res.end(), [&] (const auto& a, const auto& b) {
        return a.second < b.second; 
    });
    for (int i = 0; i < n; ++i) {
        ar[i] = res[i].first;
        cout << ar[i] << " ";
    }
    cout << "\n";
}

int main() {
    cin.tie(0)->sync_with_stdio(false);
    pre();

    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
}