#include <iostream>
#include<vector>
#include<map>
#include<algorithm>
#include<math.h>

long long fpow(long long a, int b) {
    if (b == 0)return 1;
    long long ans = fpow(a, b / 2);
    return ans * ans * (b % 2 == 0 ? 1 : a);
}

using namespace std;
int main()
{
    int T;
    cin >> T;
    for (int q = 0; q < T; q++) {
        int N, K;
        long long X;
        cin >> N >> K >> X;
        vector<long long>a(N);
        for (int i = 0; i < N; i++) cin >> a[i];

        vector<map<long long, int>> pr(N);
        for (int i = 0; i < N; i++) {
            long long x = a[i];
            for (long long p = 2; p <= sqrt(x); p++) {
                if (x % p==0) {
                    x /= p;
                    if (pr[i].find(p)==pr[i].end())
                        pr[i][p]=1;
                    else pr[i][p]++;
                    p--;
                }
            }
            if (x != 1) {
                if (pr[i].find(x) == pr[i].end())
                    pr[i][x] = 1;
                else pr[i][x]++;
            }
        }

        map<long long, vector<int>> pow;
        
        for (int i = 0; i < N; i++) {
            for (auto j = pr[i].begin(); j != pr[i].end(); ++j) {
                if (pow.find(j->first) == pow.end()) {
                    pow[j->first] = vector<int>(j->second,0);
                    pow[j->first][j->second - 1] = 1;
                }
                else {
                    if (pow[j->first].size() < j->second)
                        pow[j->first].resize(j->second,0);
                    pow[j->first][j->second - 1]++;
                }
            }
        }

        map<long long, int> maxpow;
        for (auto it = pow.begin(); it != pow.end(); ++it) {
            maxpow[it->first] = 0;
            int count = 0;
            for (int i = (it->second).size() - 1; i >= 0; i--) {
                count += (it->second)[i];
                if (count >= K) {
                    maxpow[it->first] = i + 1;
                    break;
                }
            }
        }
        map<long long, pair<vector<long long>, vector<int>>> val;
        for (int i = 0; i < N; i++) {
            long long real = a[i];
            for (auto it = maxpow.begin(); it != maxpow.end(); ++it) {
                auto p = pr[i].find(it->first);
                if (p == pr[i].end()) continue;
                if (it->second >= p->second) continue;
                real /= fpow(it->first, p->second - it->second);
            }
            auto pos = val.find(real);
            if (pos == val.end()) val[real] = { {a[i]},{i} };
            else {
                val[real].first.push_back(a[i]);
                val[real].second.push_back(i);
            }
        }
        for (auto it = val.begin(); it != val.end(); ++it) {
            sort((it->second).first.begin(), (it->second).first.end());
        }
        vector<long long> finale(N);
        for (auto it = val.begin(); it != val.end(); ++it) {
            for (int i = 0; i < (it->second).first.size(); i++)
                finale[(it->second).second[i]] = (it->second).first[i];
        }
        for (int i = 0; i < N; i++) {
            cout << finale[i] << " ";
        }
        cout << endl;
    }
}
