#include "game.h"
using namespace std;


int n, d;
vector<pair<int, int>> a;
vector<bool> vining;

void build(int id, int l, int r, vector<int>& A) {
	if (l == r) {
		a[id] = {A[l], l};
		return;
	}
	int m = (l + r) / 2;
	build(2 * id, l, m, A);
	build(2 * id + 1, m + 1, r, A);
	a[id] = max(a[id] = a[2 * id], a[2 * id + 1]);
}

pair<int, int> get(int id, int l, int r, int tl, int tr) {
	if (tr < l or r < tl) return { -1e9, -1 };
	if (tl <= l and r <= tr) {
		return a[id];
	}
	int m = (l + r) / 2;
	return max(get(2 * id, l, m, tl, tr), get(2 * id + 1, m + 1, r, tl, tr));
}

void update(int id, int l, int r, int x, int val) {
	if (l == r) {
		a[id] = { val, x };
		return;
	}
	int m = (l + r) / 2;
	if (x <= m) update(2*id, l, m, x, val);
	else update(2 * id + 1, m+1, r, x, val);
	a[id] = max(a[id] = a[2 * id], a[2 * id + 1]);
}

void SET(int l, int r) {
	if (r - l + 1 < 1) return;
	pair<int, int> p = get(1, 0, n - 1, l, r);
	vining[p.second] = false;
	SET(l, p.second - 1 - d);
	SET(p.second + 1 + d, r);
}

void init(vector<int> A, int D) {
	d = D;
	n = A.size();
	a.resize(4*n);
	vining.resize(n, true);
	build(1, 0, n-1, A);
	SET(0, n - 1);
}

bool isWinning(int startIndex) {
	return vining[startIndex];
}

void updateValue(int index, int newValue) {
	update(1, 0, n - 1, index, newValue);
	vining.clear();
	vining.resize(n, true);
	SET(0, n - 1);
	return;
}