#include <iostream>
#include <algorithm>
#include <vector>
#define ll long long
#define inf (ll)(2*1e18)
//#define sort(a) sort(a.begin(), a.end())
//#define reverse(a) reverse(a.begin(), a.end())
using namespace std;

ll gcd(ll a, ll b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

bool check(vector<ll>& a, vector<ll>& b, vector<vector<ll>>& perm) {
    for (auto el : perm) {
        int gcd1 = 0, gcd2 = 0;
        for(auto id: el){
            gcd1 = gcd(gcd1, a[id]);
            gcd2 = gcd(gcd2, b[id]);
        }
        if (gcd1 != gcd2) {
            return false;
        }
    }
    return true;
}

void gen(ll id, ll k, ll n, vector<ll>& a, vector<vector<ll>>& perm) {
    if (id == k) {
        perm.push_back(a);
        return;
    }
    for (int i = 0; i < n; ++i) {
        bool status = false;
        for (int j = 0; j < a.size(); ++j) {
            if (a[j] == i) {
                status = true;
                break;
            }
        }
        if (status) {
            continue;
        }
        a.push_back(i);
        gen(id + 1, k, n, a, perm);
        a.pop_back();
    }
}

void solve() {
    ll n, k, x;
    cin >> n >> k >> x;
    vector<ll> a(n), c;
    vector<vector<ll>> perm;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    gen(0, k, n, c, perm);
    c = a;
    sort(c.begin(), c.end());
    while (!check(a, c, perm)) {
        next_permutation(c.begin(), c.end());
    }
    for (auto el : c) {
        cout << el << ' ';
    }
    cout << endl;
}

int main()
{
    ll t;
    cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}